"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
This file was autogenerated by go-to-protobuf. Do not edit it manually!"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2
import armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2
import armada_client.k8s.io.apimachinery.pkg.runtime.generated_pb2
import armada_client.k8s.io.apimachinery.pkg.util.intstr.generated_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class AWSElasticBlockStoreVolumeSource(google.protobuf.message.Message):
    """Represents a Persistent Disk resource in AWS.

    An AWS EBS disk must exist before mounting to a container. The disk
    must also be in the same AWS zone as the kubelet. An AWS EBS disk
    can only be mounted as read/write once. AWS EBS volumes support
    ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VOLUMEID_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    PARTITION_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    volumeID: builtins.str
    """Unique ID of the persistent disk resource in AWS (Amazon EBS volume).
    More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
    """
    fsType: builtins.str
    """Filesystem type of the volume that you want to mount.
    Tip: Ensure that the filesystem type is supported by the host operating system.
    Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
    TODO: how do we prevent errors in the filesystem from compromising the machine
    +optional
    """
    partition: builtins.int
    """The partition in the volume that you want to mount.
    If omitted, the default is to mount by volume name.
    Examples: For volume /dev/sda1, you specify the partition as "1".
    Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).
    +optional
    """
    readOnly: builtins.bool
    """Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".
    If omitted, the default is "false".
    More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
    +optional
    """
    def __init__(
        self,
        *,
        volumeID: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        partition: builtins.int | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "partition", b"partition", "readOnly", b"readOnly", "volumeID", b"volumeID"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "partition", b"partition", "readOnly", b"readOnly", "volumeID", b"volumeID"]) -> None: ...

global___AWSElasticBlockStoreVolumeSource = AWSElasticBlockStoreVolumeSource

@typing.final
class Affinity(google.protobuf.message.Message):
    """Affinity is a group of affinity scheduling rules."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NODEAFFINITY_FIELD_NUMBER: builtins.int
    PODAFFINITY_FIELD_NUMBER: builtins.int
    PODANTIAFFINITY_FIELD_NUMBER: builtins.int
    @property
    def nodeAffinity(self) -> global___NodeAffinity:
        """Describes node affinity scheduling rules for the pod.
        +optional
        """

    @property
    def podAffinity(self) -> global___PodAffinity:
        """Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).
        +optional
        """

    @property
    def podAntiAffinity(self) -> global___PodAntiAffinity:
        """Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).
        +optional
        """

    def __init__(
        self,
        *,
        nodeAffinity: global___NodeAffinity | None = ...,
        podAffinity: global___PodAffinity | None = ...,
        podAntiAffinity: global___PodAntiAffinity | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["nodeAffinity", b"nodeAffinity", "podAffinity", b"podAffinity", "podAntiAffinity", b"podAntiAffinity"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["nodeAffinity", b"nodeAffinity", "podAffinity", b"podAffinity", "podAntiAffinity", b"podAntiAffinity"]) -> None: ...

global___Affinity = Affinity

@typing.final
class AttachedVolume(google.protobuf.message.Message):
    """AttachedVolume describes a volume attached to a node"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    DEVICEPATH_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Name of the attached volume"""
    devicePath: builtins.str
    """DevicePath represents the device path where the volume should be available"""
    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        devicePath: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["devicePath", b"devicePath", "name", b"name"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["devicePath", b"devicePath", "name", b"name"]) -> None: ...

global___AttachedVolume = AttachedVolume

@typing.final
class AvoidPods(google.protobuf.message.Message):
    """AvoidPods describes pods that should avoid this node. This is the value for a
    Node annotation with key scheduler.alpha.kubernetes.io/preferAvoidPods and
    will eventually become a field of NodeStatus.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PREFERAVOIDPODS_FIELD_NUMBER: builtins.int
    @property
    def preferAvoidPods(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PreferAvoidPodsEntry]:
        """Bounded-sized list of signatures of pods that should avoid this node, sorted
        in timestamp order from oldest to newest. Size of the slice is unspecified.
        +optional
        """

    def __init__(
        self,
        *,
        preferAvoidPods: collections.abc.Iterable[global___PreferAvoidPodsEntry] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["preferAvoidPods", b"preferAvoidPods"]) -> None: ...

global___AvoidPods = AvoidPods

@typing.final
class AzureDiskVolumeSource(google.protobuf.message.Message):
    """AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DISKNAME_FIELD_NUMBER: builtins.int
    DISKURI_FIELD_NUMBER: builtins.int
    CACHINGMODE_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    KIND_FIELD_NUMBER: builtins.int
    diskName: builtins.str
    """The Name of the data disk in the blob storage"""
    diskURI: builtins.str
    """The URI the data disk in the blob storage"""
    cachingMode: builtins.str
    """Host Caching mode: None, Read Only, Read Write.
    +optional
    """
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    +optional
    """
    readOnly: builtins.bool
    """Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    +optional
    """
    kind: builtins.str
    """Expected values Shared: multiple blob disks per storage account  Dedicated: single blob disk per storage account  Managed: azure managed data disk (only in managed availability set). defaults to shared"""
    def __init__(
        self,
        *,
        diskName: builtins.str | None = ...,
        diskURI: builtins.str | None = ...,
        cachingMode: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        kind: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["cachingMode", b"cachingMode", "diskName", b"diskName", "diskURI", b"diskURI", "fsType", b"fsType", "kind", b"kind", "readOnly", b"readOnly"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["cachingMode", b"cachingMode", "diskName", b"diskName", "diskURI", b"diskURI", "fsType", b"fsType", "kind", b"kind", "readOnly", b"readOnly"]) -> None: ...

global___AzureDiskVolumeSource = AzureDiskVolumeSource

@typing.final
class AzureFilePersistentVolumeSource(google.protobuf.message.Message):
    """AzureFile represents an Azure File Service mount on the host and bind mount to the pod."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SECRETNAME_FIELD_NUMBER: builtins.int
    SHARENAME_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    SECRETNAMESPACE_FIELD_NUMBER: builtins.int
    secretName: builtins.str
    """the name of secret that contains Azure Storage Account Name and Key"""
    shareName: builtins.str
    """Share Name"""
    readOnly: builtins.bool
    """Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    +optional
    """
    secretNamespace: builtins.str
    """the namespace of the secret that contains Azure Storage Account Name and Key
    default is the same as the Pod
    +optional
    """
    def __init__(
        self,
        *,
        secretName: builtins.str | None = ...,
        shareName: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        secretNamespace: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["readOnly", b"readOnly", "secretName", b"secretName", "secretNamespace", b"secretNamespace", "shareName", b"shareName"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["readOnly", b"readOnly", "secretName", b"secretName", "secretNamespace", b"secretNamespace", "shareName", b"shareName"]) -> None: ...

global___AzureFilePersistentVolumeSource = AzureFilePersistentVolumeSource

@typing.final
class AzureFileVolumeSource(google.protobuf.message.Message):
    """AzureFile represents an Azure File Service mount on the host and bind mount to the pod."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SECRETNAME_FIELD_NUMBER: builtins.int
    SHARENAME_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    secretName: builtins.str
    """the name of secret that contains Azure Storage Account Name and Key"""
    shareName: builtins.str
    """Share Name"""
    readOnly: builtins.bool
    """Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    +optional
    """
    def __init__(
        self,
        *,
        secretName: builtins.str | None = ...,
        shareName: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["readOnly", b"readOnly", "secretName", b"secretName", "shareName", b"shareName"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["readOnly", b"readOnly", "secretName", b"secretName", "shareName", b"shareName"]) -> None: ...

global___AzureFileVolumeSource = AzureFileVolumeSource

@typing.final
class Binding(google.protobuf.message.Message):
    """Binding ties one object to another; for example, a pod is bound to a node by a scheduler.
    Deprecated in 1.7, please use the bindings subresource of pods instead.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    TARGET_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def target(self) -> global___ObjectReference:
        """The target object that you want to bind to the standard object."""

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        target: global___ObjectReference | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "target", b"target"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "target", b"target"]) -> None: ...

global___Binding = Binding

@typing.final
class CSIPersistentVolumeSource(google.protobuf.message.Message):
    """Represents storage that is managed by an external CSI volume driver (Beta feature)"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class VolumeAttributesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: builtins.str | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    DRIVER_FIELD_NUMBER: builtins.int
    VOLUMEHANDLE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    VOLUMEATTRIBUTES_FIELD_NUMBER: builtins.int
    CONTROLLERPUBLISHSECRETREF_FIELD_NUMBER: builtins.int
    NODESTAGESECRETREF_FIELD_NUMBER: builtins.int
    NODEPUBLISHSECRETREF_FIELD_NUMBER: builtins.int
    CONTROLLEREXPANDSECRETREF_FIELD_NUMBER: builtins.int
    driver: builtins.str
    """Driver is the name of the driver to use for this volume.
    Required.
    """
    volumeHandle: builtins.str
    """VolumeHandle is the unique volume name returned by the CSI volume
    plugin’s CreateVolume to refer to the volume on all subsequent calls.
    Required.
    """
    readOnly: builtins.bool
    """Optional: The value to pass to ControllerPublishVolumeRequest.
    Defaults to false (read/write).
    +optional
    """
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs".
    +optional
    """
    @property
    def volumeAttributes(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """Attributes of the volume to publish.
        +optional
        """

    @property
    def controllerPublishSecretRef(self) -> global___SecretReference:
        """ControllerPublishSecretRef is a reference to the secret object containing
        sensitive information to pass to the CSI driver to complete the CSI
        ControllerPublishVolume and ControllerUnpublishVolume calls.
        This field is optional, and may be empty if no secret is required. If the
        secret object contains more than one secret, all secrets are passed.
        +optional
        """

    @property
    def nodeStageSecretRef(self) -> global___SecretReference:
        """NodeStageSecretRef is a reference to the secret object containing sensitive
        information to pass to the CSI driver to complete the CSI NodeStageVolume
        and NodeStageVolume and NodeUnstageVolume calls.
        This field is optional, and may be empty if no secret is required. If the
        secret object contains more than one secret, all secrets are passed.
        +optional
        """

    @property
    def nodePublishSecretRef(self) -> global___SecretReference:
        """NodePublishSecretRef is a reference to the secret object containing
        sensitive information to pass to the CSI driver to complete the CSI
        NodePublishVolume and NodeUnpublishVolume calls.
        This field is optional, and may be empty if no secret is required. If the
        secret object contains more than one secret, all secrets are passed.
        +optional
        """

    @property
    def controllerExpandSecretRef(self) -> global___SecretReference:
        """ControllerExpandSecretRef is a reference to the secret object containing
        sensitive information to pass to the CSI driver to complete the CSI
        ControllerExpandVolume call.
        This is an alpha field and requires enabling ExpandCSIVolumes feature gate.
        This field is optional, and may be empty if no secret is required. If the
        secret object contains more than one secret, all secrets are passed.
        +optional
        """

    def __init__(
        self,
        *,
        driver: builtins.str | None = ...,
        volumeHandle: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        fsType: builtins.str | None = ...,
        volumeAttributes: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        controllerPublishSecretRef: global___SecretReference | None = ...,
        nodeStageSecretRef: global___SecretReference | None = ...,
        nodePublishSecretRef: global___SecretReference | None = ...,
        controllerExpandSecretRef: global___SecretReference | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["controllerExpandSecretRef", b"controllerExpandSecretRef", "controllerPublishSecretRef", b"controllerPublishSecretRef", "driver", b"driver", "fsType", b"fsType", "nodePublishSecretRef", b"nodePublishSecretRef", "nodeStageSecretRef", b"nodeStageSecretRef", "readOnly", b"readOnly", "volumeHandle", b"volumeHandle"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["controllerExpandSecretRef", b"controllerExpandSecretRef", "controllerPublishSecretRef", b"controllerPublishSecretRef", "driver", b"driver", "fsType", b"fsType", "nodePublishSecretRef", b"nodePublishSecretRef", "nodeStageSecretRef", b"nodeStageSecretRef", "readOnly", b"readOnly", "volumeAttributes", b"volumeAttributes", "volumeHandle", b"volumeHandle"]) -> None: ...

global___CSIPersistentVolumeSource = CSIPersistentVolumeSource

@typing.final
class CSIVolumeSource(google.protobuf.message.Message):
    """Represents a source location of a volume to mount, managed by an external CSI driver"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class VolumeAttributesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: builtins.str | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    DRIVER_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    VOLUMEATTRIBUTES_FIELD_NUMBER: builtins.int
    NODEPUBLISHSECRETREF_FIELD_NUMBER: builtins.int
    driver: builtins.str
    """Driver is the name of the CSI driver that handles this volume.
    Consult with your admin for the correct name as registered in the cluster.
    """
    readOnly: builtins.bool
    """Specifies a read-only configuration for the volume.
    Defaults to false (read/write).
    +optional
    """
    fsType: builtins.str
    """Filesystem type to mount. Ex. "ext4", "xfs", "ntfs".
    If not provided, the empty value is passed to the associated CSI driver
    which will determine the default filesystem to apply.
    +optional
    """
    @property
    def volumeAttributes(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """VolumeAttributes stores driver-specific properties that are passed to the CSI
        driver. Consult your driver's documentation for supported values.
        +optional
        """

    @property
    def nodePublishSecretRef(self) -> global___LocalObjectReference:
        """NodePublishSecretRef is a reference to the secret object containing
        sensitive information to pass to the CSI driver to complete the CSI
        NodePublishVolume and NodeUnpublishVolume calls.
        This field is optional, and  may be empty if no secret is required. If the
        secret object contains more than one secret, all secret references are passed.
        +optional
        """

    def __init__(
        self,
        *,
        driver: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        fsType: builtins.str | None = ...,
        volumeAttributes: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        nodePublishSecretRef: global___LocalObjectReference | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["driver", b"driver", "fsType", b"fsType", "nodePublishSecretRef", b"nodePublishSecretRef", "readOnly", b"readOnly"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["driver", b"driver", "fsType", b"fsType", "nodePublishSecretRef", b"nodePublishSecretRef", "readOnly", b"readOnly", "volumeAttributes", b"volumeAttributes"]) -> None: ...

global___CSIVolumeSource = CSIVolumeSource

@typing.final
class Capabilities(google.protobuf.message.Message):
    """Adds and removes POSIX capabilities from running containers."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ADD_FIELD_NUMBER: builtins.int
    DROP_FIELD_NUMBER: builtins.int
    @property
    def add(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Added capabilities
        +optional
        """

    @property
    def drop(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Removed capabilities
        +optional
        """

    def __init__(
        self,
        *,
        add: collections.abc.Iterable[builtins.str] | None = ...,
        drop: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["add", b"add", "drop", b"drop"]) -> None: ...

global___Capabilities = Capabilities

@typing.final
class CephFSPersistentVolumeSource(google.protobuf.message.Message):
    """Represents a Ceph Filesystem mount that lasts the lifetime of a pod
    Cephfs volumes do not support ownership management or SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MONITORS_FIELD_NUMBER: builtins.int
    PATH_FIELD_NUMBER: builtins.int
    USER_FIELD_NUMBER: builtins.int
    SECRETFILE_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    path: builtins.str
    """Optional: Used as the mounted root, rather than the full Ceph tree, default is /
    +optional
    """
    user: builtins.str
    """Optional: User is the rados user name, default is admin
    More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
    +optional
    """
    secretFile: builtins.str
    """Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret
    More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
    +optional
    """
    readOnly: builtins.bool
    """Optional: Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
    +optional
    """
    @property
    def monitors(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Required: Monitors is a collection of Ceph monitors
        More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
        """

    @property
    def secretRef(self) -> global___SecretReference:
        """Optional: SecretRef is reference to the authentication secret for User, default is empty.
        More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
        +optional
        """

    def __init__(
        self,
        *,
        monitors: collections.abc.Iterable[builtins.str] | None = ...,
        path: builtins.str | None = ...,
        user: builtins.str | None = ...,
        secretFile: builtins.str | None = ...,
        secretRef: global___SecretReference | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["path", b"path", "readOnly", b"readOnly", "secretFile", b"secretFile", "secretRef", b"secretRef", "user", b"user"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["monitors", b"monitors", "path", b"path", "readOnly", b"readOnly", "secretFile", b"secretFile", "secretRef", b"secretRef", "user", b"user"]) -> None: ...

global___CephFSPersistentVolumeSource = CephFSPersistentVolumeSource

@typing.final
class CephFSVolumeSource(google.protobuf.message.Message):
    """Represents a Ceph Filesystem mount that lasts the lifetime of a pod
    Cephfs volumes do not support ownership management or SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MONITORS_FIELD_NUMBER: builtins.int
    PATH_FIELD_NUMBER: builtins.int
    USER_FIELD_NUMBER: builtins.int
    SECRETFILE_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    path: builtins.str
    """Optional: Used as the mounted root, rather than the full Ceph tree, default is /
    +optional
    """
    user: builtins.str
    """Optional: User is the rados user name, default is admin
    More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
    +optional
    """
    secretFile: builtins.str
    """Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret
    More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
    +optional
    """
    readOnly: builtins.bool
    """Optional: Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
    +optional
    """
    @property
    def monitors(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Required: Monitors is a collection of Ceph monitors
        More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
        """

    @property
    def secretRef(self) -> global___LocalObjectReference:
        """Optional: SecretRef is reference to the authentication secret for User, default is empty.
        More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it
        +optional
        """

    def __init__(
        self,
        *,
        monitors: collections.abc.Iterable[builtins.str] | None = ...,
        path: builtins.str | None = ...,
        user: builtins.str | None = ...,
        secretFile: builtins.str | None = ...,
        secretRef: global___LocalObjectReference | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["path", b"path", "readOnly", b"readOnly", "secretFile", b"secretFile", "secretRef", b"secretRef", "user", b"user"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["monitors", b"monitors", "path", b"path", "readOnly", b"readOnly", "secretFile", b"secretFile", "secretRef", b"secretRef", "user", b"user"]) -> None: ...

global___CephFSVolumeSource = CephFSVolumeSource

@typing.final
class CinderPersistentVolumeSource(google.protobuf.message.Message):
    """Represents a cinder volume resource in Openstack.
    A Cinder volume must exist before mounting to a container.
    The volume must also be in the same region as the kubelet.
    Cinder volumes support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VOLUMEID_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    volumeID: builtins.str
    """volume id used to identify the volume in cinder.
    More info: https://examples.k8s.io/mysql-cinder-pd/README.md
    """
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    More info: https://examples.k8s.io/mysql-cinder-pd/README.md
    +optional
    """
    readOnly: builtins.bool
    """Optional: Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    More info: https://examples.k8s.io/mysql-cinder-pd/README.md
    +optional
    """
    @property
    def secretRef(self) -> global___SecretReference:
        """Optional: points to a secret object containing parameters used to connect
        to OpenStack.
        +optional
        """

    def __init__(
        self,
        *,
        volumeID: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        secretRef: global___SecretReference | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "readOnly", b"readOnly", "secretRef", b"secretRef", "volumeID", b"volumeID"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "readOnly", b"readOnly", "secretRef", b"secretRef", "volumeID", b"volumeID"]) -> None: ...

global___CinderPersistentVolumeSource = CinderPersistentVolumeSource

@typing.final
class CinderVolumeSource(google.protobuf.message.Message):
    """Represents a cinder volume resource in Openstack.
    A Cinder volume must exist before mounting to a container.
    The volume must also be in the same region as the kubelet.
    Cinder volumes support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VOLUMEID_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    volumeID: builtins.str
    """volume id used to identify the volume in cinder.
    More info: https://examples.k8s.io/mysql-cinder-pd/README.md
    """
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    More info: https://examples.k8s.io/mysql-cinder-pd/README.md
    +optional
    """
    readOnly: builtins.bool
    """Optional: Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    More info: https://examples.k8s.io/mysql-cinder-pd/README.md
    +optional
    """
    @property
    def secretRef(self) -> global___LocalObjectReference:
        """Optional: points to a secret object containing parameters used to connect
        to OpenStack.
        +optional
        """

    def __init__(
        self,
        *,
        volumeID: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        secretRef: global___LocalObjectReference | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "readOnly", b"readOnly", "secretRef", b"secretRef", "volumeID", b"volumeID"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "readOnly", b"readOnly", "secretRef", b"secretRef", "volumeID", b"volumeID"]) -> None: ...

global___CinderVolumeSource = CinderVolumeSource

@typing.final
class ClientIPConfig(google.protobuf.message.Message):
    """ClientIPConfig represents the configurations of Client IP based session affinity."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TIMEOUTSECONDS_FIELD_NUMBER: builtins.int
    timeoutSeconds: builtins.int
    """timeoutSeconds specifies the seconds of ClientIP type session sticky time.
    The value must be >0 && <=86400(for 1 day) if ServiceAffinity == "ClientIP".
    Default value is 10800(for 3 hours).
    +optional
    """
    def __init__(
        self,
        *,
        timeoutSeconds: builtins.int | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["timeoutSeconds", b"timeoutSeconds"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["timeoutSeconds", b"timeoutSeconds"]) -> None: ...

global___ClientIPConfig = ClientIPConfig

@typing.final
class ComponentCondition(google.protobuf.message.Message):
    """Information about the condition of a component."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    type: builtins.str
    """Type of condition for a component.
    Valid value: "Healthy"
    """
    status: builtins.str
    """Status of the condition for a component.
    Valid values for "Healthy": "True", "False", or "Unknown".
    """
    message: builtins.str
    """Message about the condition for a component.
    For example, information about a health check.
    +optional
    """
    error: builtins.str
    """Condition error code for a component.
    For example, a health check error code.
    +optional
    """
    def __init__(
        self,
        *,
        type: builtins.str | None = ...,
        status: builtins.str | None = ...,
        message: builtins.str | None = ...,
        error: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "message", b"message", "status", b"status", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "message", b"message", "status", b"status", "type", b"type"]) -> None: ...

global___ComponentCondition = ComponentCondition

@typing.final
class ComponentStatus(google.protobuf.message.Message):
    """ComponentStatus (and ComponentStatusList) holds the cluster validation info.
    Deprecated: This API is deprecated in v1.19+
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    CONDITIONS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def conditions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ComponentCondition]:
        """List of component conditions observed
        +optional
        +patchMergeKey=type
        +patchStrategy=merge
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        conditions: collections.abc.Iterable[global___ComponentCondition] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["conditions", b"conditions", "metadata", b"metadata"]) -> None: ...

global___ComponentStatus = ComponentStatus

@typing.final
class ComponentStatusList(google.protobuf.message.Message):
    """Status of all the conditions for the component as a list of ComponentStatus objects.
    Deprecated: This API is deprecated in v1.19+
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ComponentStatus]:
        """List of ComponentStatus objects."""

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___ComponentStatus] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___ComponentStatusList = ComponentStatusList

@typing.final
class ConfigMap(google.protobuf.message.Message):
    """ConfigMap holds configuration data for pods to consume."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class DataEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: builtins.str | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    @typing.final
    class BinaryDataEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.bytes
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: builtins.bytes | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    METADATA_FIELD_NUMBER: builtins.int
    IMMUTABLE_FIELD_NUMBER: builtins.int
    DATA_FIELD_NUMBER: builtins.int
    BINARYDATA_FIELD_NUMBER: builtins.int
    immutable: builtins.bool
    """Immutable, if set to true, ensures that data stored in the ConfigMap cannot
    be updated (only object metadata can be modified).
    If not set to true, the field can be modified at any time.
    Defaulted to nil.
    +optional
    """
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def data(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """Data contains the configuration data.
        Each key must consist of alphanumeric characters, '-', '_' or '.'.
        Values with non-UTF-8 byte sequences must use the BinaryData field.
        The keys stored in Data must not overlap with the keys in
        the BinaryData field, this is enforced during validation process.
        +optional
        """

    @property
    def binaryData(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.bytes]:
        """BinaryData contains the binary data.
        Each key must consist of alphanumeric characters, '-', '_' or '.'.
        BinaryData can contain byte sequences that are not in the UTF-8 range.
        The keys stored in BinaryData must not overlap with the ones in
        the Data field, this is enforced during validation process.
        Using this field will require 1.10+ apiserver and
        kubelet.
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        immutable: builtins.bool | None = ...,
        data: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        binaryData: collections.abc.Mapping[builtins.str, builtins.bytes] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["immutable", b"immutable", "metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["binaryData", b"binaryData", "data", b"data", "immutable", b"immutable", "metadata", b"metadata"]) -> None: ...

global___ConfigMap = ConfigMap

@typing.final
class ConfigMapEnvSource(google.protobuf.message.Message):
    """ConfigMapEnvSource selects a ConfigMap to populate the environment
    variables with.

    The contents of the target ConfigMap's Data field will represent the
    key-value pairs as environment variables.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LOCALOBJECTREFERENCE_FIELD_NUMBER: builtins.int
    OPTIONAL_FIELD_NUMBER: builtins.int
    optional: builtins.bool
    """Specify whether the ConfigMap must be defined
    +optional
    """
    @property
    def localObjectReference(self) -> global___LocalObjectReference:
        """The ConfigMap to select from."""

    def __init__(
        self,
        *,
        localObjectReference: global___LocalObjectReference | None = ...,
        optional: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["localObjectReference", b"localObjectReference", "optional", b"optional"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["localObjectReference", b"localObjectReference", "optional", b"optional"]) -> None: ...

global___ConfigMapEnvSource = ConfigMapEnvSource

@typing.final
class ConfigMapKeySelector(google.protobuf.message.Message):
    """Selects a key from a ConfigMap.
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LOCALOBJECTREFERENCE_FIELD_NUMBER: builtins.int
    KEY_FIELD_NUMBER: builtins.int
    OPTIONAL_FIELD_NUMBER: builtins.int
    key: builtins.str
    """The key to select."""
    optional: builtins.bool
    """Specify whether the ConfigMap or its key must be defined
    +optional
    """
    @property
    def localObjectReference(self) -> global___LocalObjectReference:
        """The ConfigMap to select from."""

    def __init__(
        self,
        *,
        localObjectReference: global___LocalObjectReference | None = ...,
        key: builtins.str | None = ...,
        optional: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "localObjectReference", b"localObjectReference", "optional", b"optional"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "localObjectReference", b"localObjectReference", "optional", b"optional"]) -> None: ...

global___ConfigMapKeySelector = ConfigMapKeySelector

@typing.final
class ConfigMapList(google.protobuf.message.Message):
    """ConfigMapList is a resource containing a list of ConfigMap objects."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ConfigMap]:
        """Items is the list of ConfigMaps."""

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___ConfigMap] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___ConfigMapList = ConfigMapList

@typing.final
class ConfigMapNodeConfigSource(google.protobuf.message.Message):
    """ConfigMapNodeConfigSource contains the information to reference a ConfigMap as a config source for the Node.
    This API is deprecated since 1.22: https://git.k8s.io/enhancements/keps/sig-node/281-dynamic-kubelet-configuration
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAMESPACE_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    UID_FIELD_NUMBER: builtins.int
    RESOURCEVERSION_FIELD_NUMBER: builtins.int
    KUBELETCONFIGKEY_FIELD_NUMBER: builtins.int
    namespace: builtins.str
    """Namespace is the metadata.namespace of the referenced ConfigMap.
    This field is required in all cases.
    """
    name: builtins.str
    """Name is the metadata.name of the referenced ConfigMap.
    This field is required in all cases.
    """
    uid: builtins.str
    """UID is the metadata.UID of the referenced ConfigMap.
    This field is forbidden in Node.Spec, and required in Node.Status.
    +optional
    """
    resourceVersion: builtins.str
    """ResourceVersion is the metadata.ResourceVersion of the referenced ConfigMap.
    This field is forbidden in Node.Spec, and required in Node.Status.
    +optional
    """
    kubeletConfigKey: builtins.str
    """KubeletConfigKey declares which key of the referenced ConfigMap corresponds to the KubeletConfiguration structure
    This field is required in all cases.
    """
    def __init__(
        self,
        *,
        namespace: builtins.str | None = ...,
        name: builtins.str | None = ...,
        uid: builtins.str | None = ...,
        resourceVersion: builtins.str | None = ...,
        kubeletConfigKey: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["kubeletConfigKey", b"kubeletConfigKey", "name", b"name", "namespace", b"namespace", "resourceVersion", b"resourceVersion", "uid", b"uid"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["kubeletConfigKey", b"kubeletConfigKey", "name", b"name", "namespace", b"namespace", "resourceVersion", b"resourceVersion", "uid", b"uid"]) -> None: ...

global___ConfigMapNodeConfigSource = ConfigMapNodeConfigSource

@typing.final
class ConfigMapProjection(google.protobuf.message.Message):
    """Adapts a ConfigMap into a projected volume.

    The contents of the target ConfigMap's Data field will be presented in a
    projected volume as files using the keys in the Data field as the file names,
    unless the items element is populated with specific mappings of keys to paths.
    Note that this is identical to a configmap volume source without the default
    mode.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LOCALOBJECTREFERENCE_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    OPTIONAL_FIELD_NUMBER: builtins.int
    optional: builtins.bool
    """Specify whether the ConfigMap or its keys must be defined
    +optional
    """
    @property
    def localObjectReference(self) -> global___LocalObjectReference: ...
    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___KeyToPath]:
        """If unspecified, each key-value pair in the Data field of the referenced
        ConfigMap will be projected into the volume as a file whose name is the
        key and content is the value. If specified, the listed keys will be
        projected into the specified paths, and unlisted keys will not be
        present. If a key is specified which is not present in the ConfigMap,
        the volume setup will error unless it is marked optional. Paths must be
        relative and may not contain the '..' path or start with '..'.
        +optional
        """

    def __init__(
        self,
        *,
        localObjectReference: global___LocalObjectReference | None = ...,
        items: collections.abc.Iterable[global___KeyToPath] | None = ...,
        optional: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["localObjectReference", b"localObjectReference", "optional", b"optional"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "localObjectReference", b"localObjectReference", "optional", b"optional"]) -> None: ...

global___ConfigMapProjection = ConfigMapProjection

@typing.final
class ConfigMapVolumeSource(google.protobuf.message.Message):
    """Adapts a ConfigMap into a volume.

    The contents of the target ConfigMap's Data field will be presented in a
    volume as files using the keys in the Data field as the file names, unless
    the items element is populated with specific mappings of keys to paths.
    ConfigMap volumes support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LOCALOBJECTREFERENCE_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    DEFAULTMODE_FIELD_NUMBER: builtins.int
    OPTIONAL_FIELD_NUMBER: builtins.int
    defaultMode: builtins.int
    """Optional: mode bits used to set permissions on created files by default.
    Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511.
    YAML accepts both octal and decimal values, JSON requires decimal values for mode bits.
    Defaults to 0644.
    Directories within the path are not affected by this setting.
    This might be in conflict with other options that affect the file
    mode, like fsGroup, and the result can be other mode bits set.
    +optional
    """
    optional: builtins.bool
    """Specify whether the ConfigMap or its keys must be defined
    +optional
    """
    @property
    def localObjectReference(self) -> global___LocalObjectReference: ...
    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___KeyToPath]:
        """If unspecified, each key-value pair in the Data field of the referenced
        ConfigMap will be projected into the volume as a file whose name is the
        key and content is the value. If specified, the listed keys will be
        projected into the specified paths, and unlisted keys will not be
        present. If a key is specified which is not present in the ConfigMap,
        the volume setup will error unless it is marked optional. Paths must be
        relative and may not contain the '..' path or start with '..'.
        +optional
        """

    def __init__(
        self,
        *,
        localObjectReference: global___LocalObjectReference | None = ...,
        items: collections.abc.Iterable[global___KeyToPath] | None = ...,
        defaultMode: builtins.int | None = ...,
        optional: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["defaultMode", b"defaultMode", "localObjectReference", b"localObjectReference", "optional", b"optional"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["defaultMode", b"defaultMode", "items", b"items", "localObjectReference", b"localObjectReference", "optional", b"optional"]) -> None: ...

global___ConfigMapVolumeSource = ConfigMapVolumeSource

@typing.final
class Container(google.protobuf.message.Message):
    """A single application container that you want to run within a pod."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    IMAGE_FIELD_NUMBER: builtins.int
    COMMAND_FIELD_NUMBER: builtins.int
    ARGS_FIELD_NUMBER: builtins.int
    WORKINGDIR_FIELD_NUMBER: builtins.int
    PORTS_FIELD_NUMBER: builtins.int
    ENVFROM_FIELD_NUMBER: builtins.int
    ENV_FIELD_NUMBER: builtins.int
    RESOURCES_FIELD_NUMBER: builtins.int
    VOLUMEMOUNTS_FIELD_NUMBER: builtins.int
    VOLUMEDEVICES_FIELD_NUMBER: builtins.int
    LIVENESSPROBE_FIELD_NUMBER: builtins.int
    READINESSPROBE_FIELD_NUMBER: builtins.int
    STARTUPPROBE_FIELD_NUMBER: builtins.int
    LIFECYCLE_FIELD_NUMBER: builtins.int
    TERMINATIONMESSAGEPATH_FIELD_NUMBER: builtins.int
    TERMINATIONMESSAGEPOLICY_FIELD_NUMBER: builtins.int
    IMAGEPULLPOLICY_FIELD_NUMBER: builtins.int
    SECURITYCONTEXT_FIELD_NUMBER: builtins.int
    STDIN_FIELD_NUMBER: builtins.int
    STDINONCE_FIELD_NUMBER: builtins.int
    TTY_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Name of the container specified as a DNS_LABEL.
    Each container in a pod must have a unique name (DNS_LABEL).
    Cannot be updated.
    """
    image: builtins.str
    """Docker image name.
    More info: https://kubernetes.io/docs/concepts/containers/images
    This field is optional to allow higher level config management to default or override
    container images in workload controllers like Deployments and StatefulSets.
    +optional
    """
    workingDir: builtins.str
    """Container's working directory.
    If not specified, the container runtime's default will be used, which
    might be configured in the container image.
    Cannot be updated.
    +optional
    """
    terminationMessagePath: builtins.str
    """Optional: Path at which the file to which the container's termination message
    will be written is mounted into the container's filesystem.
    Message written is intended to be brief final status, such as an assertion failure message.
    Will be truncated by the node if greater than 4096 bytes. The total message length across
    all containers will be limited to 12kb.
    Defaults to /dev/termination-log.
    Cannot be updated.
    +optional
    """
    terminationMessagePolicy: builtins.str
    """Indicate how the termination message should be populated. File will use the contents of
    terminationMessagePath to populate the container status message on both success and failure.
    FallbackToLogsOnError will use the last chunk of container log output if the termination
    message file is empty and the container exited with an error.
    The log output is limited to 2048 bytes or 80 lines, whichever is smaller.
    Defaults to File.
    Cannot be updated.
    +optional
    """
    imagePullPolicy: builtins.str
    """Image pull policy.
    One of Always, Never, IfNotPresent.
    Defaults to Always if :latest tag is specified, or IfNotPresent otherwise.
    Cannot be updated.
    More info: https://kubernetes.io/docs/concepts/containers/images#updating-images
    +optional
    """
    stdin: builtins.bool
    """Whether this container should allocate a buffer for stdin in the container runtime. If this
    is not set, reads from stdin in the container will always result in EOF.
    Default is false.
    +optional
    """
    stdinOnce: builtins.bool
    """Whether the container runtime should close the stdin channel after it has been opened by
    a single attach. When stdin is true the stdin stream will remain open across multiple attach
    sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the
    first client attaches to stdin, and then remains open and accepts data until the client disconnects,
    at which time stdin is closed and remains closed until the container is restarted. If this
    flag is false, a container processes that reads from stdin will never receive an EOF.
    Default is false
    +optional
    """
    tty: builtins.bool
    """Whether this container should allocate a TTY for itself, also requires 'stdin' to be true.
    Default is false.
    +optional
    """
    @property
    def command(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Entrypoint array. Not executed within a shell.
        The docker image's ENTRYPOINT is used if this is not provided.
        Variable references $(VAR_NAME) are expanded using the container's environment. If a variable
        cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced
        to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will
        produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless
        of whether the variable exists or not. Cannot be updated.
        More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
        +optional
        """

    @property
    def args(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Arguments to the entrypoint.
        The docker image's CMD is used if this is not provided.
        Variable references $(VAR_NAME) are expanded using the container's environment. If a variable
        cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced
        to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will
        produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless
        of whether the variable exists or not. Cannot be updated.
        More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
        +optional
        """

    @property
    def ports(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ContainerPort]:
        """List of ports to expose from the container. Exposing a port here gives
        the system additional information about the network connections a
        container uses, but is primarily informational. Not specifying a port here
        DOES NOT prevent that port from being exposed. Any port which is
        listening on the default "0.0.0.0" address inside a container will be
        accessible from the network.
        Cannot be updated.
        +optional
        +patchMergeKey=containerPort
        +patchStrategy=merge
        +listType=map
        +listMapKey=containerPort
        +listMapKey=protocol
        """

    @property
    def envFrom(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___EnvFromSource]:
        """List of sources to populate environment variables in the container.
        The keys defined within a source must be a C_IDENTIFIER. All invalid keys
        will be reported as an event when the container is starting. When a key exists in multiple
        sources, the value associated with the last source will take precedence.
        Values defined by an Env with a duplicate key will take precedence.
        Cannot be updated.
        +optional
        """

    @property
    def env(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___EnvVar]:
        """List of environment variables to set in the container.
        Cannot be updated.
        +optional
        +patchMergeKey=name
        +patchStrategy=merge
        """

    @property
    def resources(self) -> global___ResourceRequirements:
        """Compute Resources required by this container.
        Cannot be updated.
        More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
        +optional
        """

    @property
    def volumeMounts(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___VolumeMount]:
        """Pod volumes to mount into the container's filesystem.
        Cannot be updated.
        +optional
        +patchMergeKey=mountPath
        +patchStrategy=merge
        """

    @property
    def volumeDevices(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___VolumeDevice]:
        """volumeDevices is the list of block devices to be used by the container.
        +patchMergeKey=devicePath
        +patchStrategy=merge
        +optional
        """

    @property
    def livenessProbe(self) -> global___Probe:
        """Periodic probe of container liveness.
        Container will be restarted if the probe fails.
        Cannot be updated.
        More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
        +optional
        """

    @property
    def readinessProbe(self) -> global___Probe:
        """Periodic probe of container service readiness.
        Container will be removed from service endpoints if the probe fails.
        Cannot be updated.
        More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
        +optional
        """

    @property
    def startupProbe(self) -> global___Probe:
        """StartupProbe indicates that the Pod has successfully initialized.
        If specified, no other probes are executed until this completes successfully.
        If this probe fails, the Pod will be restarted, just as if the livenessProbe failed.
        This can be used to provide different probe parameters at the beginning of a Pod's lifecycle,
        when it might take a long time to load data or warm a cache, than during steady-state operation.
        This cannot be updated.
        More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
        +optional
        """

    @property
    def lifecycle(self) -> global___Lifecycle:
        """Actions that the management system should take in response to container lifecycle events.
        Cannot be updated.
        +optional
        """

    @property
    def securityContext(self) -> global___SecurityContext:
        """SecurityContext defines the security options the container should be run with.
        If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext.
        More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/
        +optional
        """

    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        image: builtins.str | None = ...,
        command: collections.abc.Iterable[builtins.str] | None = ...,
        args: collections.abc.Iterable[builtins.str] | None = ...,
        workingDir: builtins.str | None = ...,
        ports: collections.abc.Iterable[global___ContainerPort] | None = ...,
        envFrom: collections.abc.Iterable[global___EnvFromSource] | None = ...,
        env: collections.abc.Iterable[global___EnvVar] | None = ...,
        resources: global___ResourceRequirements | None = ...,
        volumeMounts: collections.abc.Iterable[global___VolumeMount] | None = ...,
        volumeDevices: collections.abc.Iterable[global___VolumeDevice] | None = ...,
        livenessProbe: global___Probe | None = ...,
        readinessProbe: global___Probe | None = ...,
        startupProbe: global___Probe | None = ...,
        lifecycle: global___Lifecycle | None = ...,
        terminationMessagePath: builtins.str | None = ...,
        terminationMessagePolicy: builtins.str | None = ...,
        imagePullPolicy: builtins.str | None = ...,
        securityContext: global___SecurityContext | None = ...,
        stdin: builtins.bool | None = ...,
        stdinOnce: builtins.bool | None = ...,
        tty: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["image", b"image", "imagePullPolicy", b"imagePullPolicy", "lifecycle", b"lifecycle", "livenessProbe", b"livenessProbe", "name", b"name", "readinessProbe", b"readinessProbe", "resources", b"resources", "securityContext", b"securityContext", "startupProbe", b"startupProbe", "stdin", b"stdin", "stdinOnce", b"stdinOnce", "terminationMessagePath", b"terminationMessagePath", "terminationMessagePolicy", b"terminationMessagePolicy", "tty", b"tty", "workingDir", b"workingDir"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["args", b"args", "command", b"command", "env", b"env", "envFrom", b"envFrom", "image", b"image", "imagePullPolicy", b"imagePullPolicy", "lifecycle", b"lifecycle", "livenessProbe", b"livenessProbe", "name", b"name", "ports", b"ports", "readinessProbe", b"readinessProbe", "resources", b"resources", "securityContext", b"securityContext", "startupProbe", b"startupProbe", "stdin", b"stdin", "stdinOnce", b"stdinOnce", "terminationMessagePath", b"terminationMessagePath", "terminationMessagePolicy", b"terminationMessagePolicy", "tty", b"tty", "volumeDevices", b"volumeDevices", "volumeMounts", b"volumeMounts", "workingDir", b"workingDir"]) -> None: ...

global___Container = Container

@typing.final
class ContainerImage(google.protobuf.message.Message):
    """Describe a container image"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAMES_FIELD_NUMBER: builtins.int
    SIZEBYTES_FIELD_NUMBER: builtins.int
    sizeBytes: builtins.int
    """The size of the image in bytes.
    +optional
    """
    @property
    def names(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Names by which this image is known.
        e.g. ["k8s.gcr.io/hyperkube:v1.0.7", "dockerhub.io/google_containers/hyperkube:v1.0.7"]
        +optional
        """

    def __init__(
        self,
        *,
        names: collections.abc.Iterable[builtins.str] | None = ...,
        sizeBytes: builtins.int | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["sizeBytes", b"sizeBytes"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["names", b"names", "sizeBytes", b"sizeBytes"]) -> None: ...

global___ContainerImage = ContainerImage

@typing.final
class ContainerPort(google.protobuf.message.Message):
    """ContainerPort represents a network port in a single container."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    HOSTPORT_FIELD_NUMBER: builtins.int
    CONTAINERPORT_FIELD_NUMBER: builtins.int
    PROTOCOL_FIELD_NUMBER: builtins.int
    HOSTIP_FIELD_NUMBER: builtins.int
    name: builtins.str
    """If specified, this must be an IANA_SVC_NAME and unique within the pod. Each
    named port in a pod must have a unique name. Name for the port that can be
    referred to by services.
    +optional
    """
    hostPort: builtins.int
    """Number of port to expose on the host.
    If specified, this must be a valid port number, 0 < x < 65536.
    If HostNetwork is specified, this must match ContainerPort.
    Most containers do not need this.
    +optional
    """
    containerPort: builtins.int
    """Number of port to expose on the pod's IP address.
    This must be a valid port number, 0 < x < 65536.
    """
    protocol: builtins.str
    """Protocol for port. Must be UDP, TCP, or SCTP.
    Defaults to "TCP".
    +optional
    +default="TCP"
    """
    hostIP: builtins.str
    """What host IP to bind the external port to.
    +optional
    """
    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        hostPort: builtins.int | None = ...,
        containerPort: builtins.int | None = ...,
        protocol: builtins.str | None = ...,
        hostIP: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["containerPort", b"containerPort", "hostIP", b"hostIP", "hostPort", b"hostPort", "name", b"name", "protocol", b"protocol"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["containerPort", b"containerPort", "hostIP", b"hostIP", "hostPort", b"hostPort", "name", b"name", "protocol", b"protocol"]) -> None: ...

global___ContainerPort = ContainerPort

@typing.final
class ContainerState(google.protobuf.message.Message):
    """ContainerState holds a possible state of container.
    Only one of its members may be specified.
    If none of them is specified, the default one is ContainerStateWaiting.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WAITING_FIELD_NUMBER: builtins.int
    RUNNING_FIELD_NUMBER: builtins.int
    TERMINATED_FIELD_NUMBER: builtins.int
    @property
    def waiting(self) -> global___ContainerStateWaiting:
        """Details about a waiting container
        +optional
        """

    @property
    def running(self) -> global___ContainerStateRunning:
        """Details about a running container
        +optional
        """

    @property
    def terminated(self) -> global___ContainerStateTerminated:
        """Details about a terminated container
        +optional
        """

    def __init__(
        self,
        *,
        waiting: global___ContainerStateWaiting | None = ...,
        running: global___ContainerStateRunning | None = ...,
        terminated: global___ContainerStateTerminated | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["running", b"running", "terminated", b"terminated", "waiting", b"waiting"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["running", b"running", "terminated", b"terminated", "waiting", b"waiting"]) -> None: ...

global___ContainerState = ContainerState

@typing.final
class ContainerStateRunning(google.protobuf.message.Message):
    """ContainerStateRunning is a running state of a container."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    STARTEDAT_FIELD_NUMBER: builtins.int
    @property
    def startedAt(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """Time at which the container was last (re-)started
        +optional
        """

    def __init__(
        self,
        *,
        startedAt: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["startedAt", b"startedAt"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["startedAt", b"startedAt"]) -> None: ...

global___ContainerStateRunning = ContainerStateRunning

@typing.final
class ContainerStateTerminated(google.protobuf.message.Message):
    """ContainerStateTerminated is a terminated state of a container."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EXITCODE_FIELD_NUMBER: builtins.int
    SIGNAL_FIELD_NUMBER: builtins.int
    REASON_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    STARTEDAT_FIELD_NUMBER: builtins.int
    FINISHEDAT_FIELD_NUMBER: builtins.int
    CONTAINERID_FIELD_NUMBER: builtins.int
    exitCode: builtins.int
    """Exit status from the last termination of the container"""
    signal: builtins.int
    """Signal from the last termination of the container
    +optional
    """
    reason: builtins.str
    """(brief) reason from the last termination of the container
    +optional
    """
    message: builtins.str
    """Message regarding the last termination of the container
    +optional
    """
    containerID: builtins.str
    """Container's ID in the format 'docker://<container_id>'
    +optional
    """
    @property
    def startedAt(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """Time at which previous execution of the container started
        +optional
        """

    @property
    def finishedAt(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """Time at which the container last terminated
        +optional
        """

    def __init__(
        self,
        *,
        exitCode: builtins.int | None = ...,
        signal: builtins.int | None = ...,
        reason: builtins.str | None = ...,
        message: builtins.str | None = ...,
        startedAt: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        finishedAt: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        containerID: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["containerID", b"containerID", "exitCode", b"exitCode", "finishedAt", b"finishedAt", "message", b"message", "reason", b"reason", "signal", b"signal", "startedAt", b"startedAt"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["containerID", b"containerID", "exitCode", b"exitCode", "finishedAt", b"finishedAt", "message", b"message", "reason", b"reason", "signal", b"signal", "startedAt", b"startedAt"]) -> None: ...

global___ContainerStateTerminated = ContainerStateTerminated

@typing.final
class ContainerStateWaiting(google.protobuf.message.Message):
    """ContainerStateWaiting is a waiting state of a container."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REASON_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    reason: builtins.str
    """(brief) reason the container is not yet running.
    +optional
    """
    message: builtins.str
    """Message regarding why the container is not yet running.
    +optional
    """
    def __init__(
        self,
        *,
        reason: builtins.str | None = ...,
        message: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["message", b"message", "reason", b"reason"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["message", b"message", "reason", b"reason"]) -> None: ...

global___ContainerStateWaiting = ContainerStateWaiting

@typing.final
class ContainerStatus(google.protobuf.message.Message):
    """ContainerStatus contains details for the current status of this container."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    STATE_FIELD_NUMBER: builtins.int
    LASTSTATE_FIELD_NUMBER: builtins.int
    READY_FIELD_NUMBER: builtins.int
    RESTARTCOUNT_FIELD_NUMBER: builtins.int
    IMAGE_FIELD_NUMBER: builtins.int
    IMAGEID_FIELD_NUMBER: builtins.int
    CONTAINERID_FIELD_NUMBER: builtins.int
    STARTED_FIELD_NUMBER: builtins.int
    name: builtins.str
    """This must be a DNS_LABEL. Each container in a pod must have a unique name.
    Cannot be updated.
    """
    ready: builtins.bool
    """Specifies whether the container has passed its readiness probe."""
    restartCount: builtins.int
    """The number of times the container has been restarted, currently based on
    the number of dead containers that have not yet been removed.
    Note that this is calculated from dead containers. But those containers are subject to
    garbage collection. This value will get capped at 5 by GC.
    """
    image: builtins.str
    """The image the container is running.
    More info: https://kubernetes.io/docs/concepts/containers/images
    TODO(dchen1107): Which image the container is running with?
    """
    imageID: builtins.str
    """ImageID of the container's image."""
    containerID: builtins.str
    """Container's ID in the format 'docker://<container_id>'.
    +optional
    """
    started: builtins.bool
    """Specifies whether the container has passed its startup probe.
    Initialized as false, becomes true after startupProbe is considered successful.
    Resets to false when the container is restarted, or if kubelet loses state temporarily.
    Is always true when no startupProbe is defined.
    +optional
    """
    @property
    def state(self) -> global___ContainerState:
        """Details about the container's current condition.
        +optional
        """

    @property
    def lastState(self) -> global___ContainerState:
        """Details about the container's last termination condition.
        +optional
        """

    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        state: global___ContainerState | None = ...,
        lastState: global___ContainerState | None = ...,
        ready: builtins.bool | None = ...,
        restartCount: builtins.int | None = ...,
        image: builtins.str | None = ...,
        imageID: builtins.str | None = ...,
        containerID: builtins.str | None = ...,
        started: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["containerID", b"containerID", "image", b"image", "imageID", b"imageID", "lastState", b"lastState", "name", b"name", "ready", b"ready", "restartCount", b"restartCount", "started", b"started", "state", b"state"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["containerID", b"containerID", "image", b"image", "imageID", b"imageID", "lastState", b"lastState", "name", b"name", "ready", b"ready", "restartCount", b"restartCount", "started", b"started", "state", b"state"]) -> None: ...

global___ContainerStatus = ContainerStatus

@typing.final
class DaemonEndpoint(google.protobuf.message.Message):
    """DaemonEndpoint contains information about a single Daemon endpoint."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PORT_FIELD_NUMBER: builtins.int
    Port: builtins.int
    """Port number of the given endpoint."""
    def __init__(
        self,
        *,
        Port: builtins.int | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["Port", b"Port"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["Port", b"Port"]) -> None: ...

global___DaemonEndpoint = DaemonEndpoint

@typing.final
class DownwardAPIProjection(google.protobuf.message.Message):
    """Represents downward API info for projecting into a projected volume.
    Note that this is identical to a downwardAPI volume source without the default
    mode.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___DownwardAPIVolumeFile]:
        """Items is a list of DownwardAPIVolume file
        +optional
        """

    def __init__(
        self,
        *,
        items: collections.abc.Iterable[global___DownwardAPIVolumeFile] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["items", b"items"]) -> None: ...

global___DownwardAPIProjection = DownwardAPIProjection

@typing.final
class DownwardAPIVolumeFile(google.protobuf.message.Message):
    """DownwardAPIVolumeFile represents information to create the file containing the pod field"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PATH_FIELD_NUMBER: builtins.int
    FIELDREF_FIELD_NUMBER: builtins.int
    RESOURCEFIELDREF_FIELD_NUMBER: builtins.int
    MODE_FIELD_NUMBER: builtins.int
    path: builtins.str
    """Required: Path is  the relative path name of the file to be created. Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'"""
    mode: builtins.int
    """Optional: mode bits used to set permissions on this file, must be an octal value
    between 0000 and 0777 or a decimal value between 0 and 511.
    YAML accepts both octal and decimal values, JSON requires decimal values for mode bits.
    If not specified, the volume defaultMode will be used.
    This might be in conflict with other options that affect the file
    mode, like fsGroup, and the result can be other mode bits set.
    +optional
    """
    @property
    def fieldRef(self) -> global___ObjectFieldSelector:
        """Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.
        +optional
        """

    @property
    def resourceFieldRef(self) -> global___ResourceFieldSelector:
        """Selects a resource of the container: only resources limits and requests
        (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
        +optional
        """

    def __init__(
        self,
        *,
        path: builtins.str | None = ...,
        fieldRef: global___ObjectFieldSelector | None = ...,
        resourceFieldRef: global___ResourceFieldSelector | None = ...,
        mode: builtins.int | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fieldRef", b"fieldRef", "mode", b"mode", "path", b"path", "resourceFieldRef", b"resourceFieldRef"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fieldRef", b"fieldRef", "mode", b"mode", "path", b"path", "resourceFieldRef", b"resourceFieldRef"]) -> None: ...

global___DownwardAPIVolumeFile = DownwardAPIVolumeFile

@typing.final
class DownwardAPIVolumeSource(google.protobuf.message.Message):
    """DownwardAPIVolumeSource represents a volume containing downward API info.
    Downward API volumes support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ITEMS_FIELD_NUMBER: builtins.int
    DEFAULTMODE_FIELD_NUMBER: builtins.int
    defaultMode: builtins.int
    """Optional: mode bits to use on created files by default. Must be a
    Optional: mode bits used to set permissions on created files by default.
    Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511.
    YAML accepts both octal and decimal values, JSON requires decimal values for mode bits.
    Defaults to 0644.
    Directories within the path are not affected by this setting.
    This might be in conflict with other options that affect the file
    mode, like fsGroup, and the result can be other mode bits set.
    +optional
    """
    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___DownwardAPIVolumeFile]:
        """Items is a list of downward API volume file
        +optional
        """

    def __init__(
        self,
        *,
        items: collections.abc.Iterable[global___DownwardAPIVolumeFile] | None = ...,
        defaultMode: builtins.int | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["defaultMode", b"defaultMode"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["defaultMode", b"defaultMode", "items", b"items"]) -> None: ...

global___DownwardAPIVolumeSource = DownwardAPIVolumeSource

@typing.final
class EmptyDirVolumeSource(google.protobuf.message.Message):
    """Represents an empty directory for a pod.
    Empty directory volumes support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MEDIUM_FIELD_NUMBER: builtins.int
    SIZELIMIT_FIELD_NUMBER: builtins.int
    medium: builtins.str
    """What type of storage medium should back this directory.
    The default is "" which means to use the node's default medium.
    Must be an empty string (default) or Memory.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
    +optional
    """
    @property
    def sizeLimit(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity:
        """Total amount of local storage required for this EmptyDir volume.
        The size limit is also applicable for memory medium.
        The maximum usage on memory medium EmptyDir would be the minimum value between
        the SizeLimit specified here and the sum of memory limits of all containers in a pod.
        The default is nil which means that the limit is undefined.
        More info: http://kubernetes.io/docs/user-guide/volumes#emptydir
        +optional
        """

    def __init__(
        self,
        *,
        medium: builtins.str | None = ...,
        sizeLimit: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["medium", b"medium", "sizeLimit", b"sizeLimit"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["medium", b"medium", "sizeLimit", b"sizeLimit"]) -> None: ...

global___EmptyDirVolumeSource = EmptyDirVolumeSource

@typing.final
class EndpointAddress(google.protobuf.message.Message):
    """EndpointAddress is a tuple that describes single IP address.
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    IP_FIELD_NUMBER: builtins.int
    HOSTNAME_FIELD_NUMBER: builtins.int
    NODENAME_FIELD_NUMBER: builtins.int
    TARGETREF_FIELD_NUMBER: builtins.int
    ip: builtins.str
    """The IP of this endpoint.
    May not be loopback (127.0.0.0/8), link-local (169.254.0.0/16),
    or link-local multicast ((224.0.0.0/24).
    IPv6 is also accepted but not fully supported on all platforms. Also, certain
    kubernetes components, like kube-proxy, are not IPv6 ready.
    TODO: This should allow hostname or IP, See #4447.
    """
    hostname: builtins.str
    """The Hostname of this endpoint
    +optional
    """
    nodeName: builtins.str
    """Optional: Node hosting this endpoint. This can be used to determine endpoints local to a node.
    +optional
    """
    @property
    def targetRef(self) -> global___ObjectReference:
        """Reference to object providing the endpoint.
        +optional
        """

    def __init__(
        self,
        *,
        ip: builtins.str | None = ...,
        hostname: builtins.str | None = ...,
        nodeName: builtins.str | None = ...,
        targetRef: global___ObjectReference | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["hostname", b"hostname", "ip", b"ip", "nodeName", b"nodeName", "targetRef", b"targetRef"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["hostname", b"hostname", "ip", b"ip", "nodeName", b"nodeName", "targetRef", b"targetRef"]) -> None: ...

global___EndpointAddress = EndpointAddress

@typing.final
class EndpointPort(google.protobuf.message.Message):
    """EndpointPort is a tuple that describes a single port.
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    PORT_FIELD_NUMBER: builtins.int
    PROTOCOL_FIELD_NUMBER: builtins.int
    APPPROTOCOL_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The name of this port.  This must match the 'name' field in the
    corresponding ServicePort.
    Must be a DNS_LABEL.
    Optional only if one port is defined.
    +optional
    """
    port: builtins.int
    """The port number of the endpoint."""
    protocol: builtins.str
    """The IP protocol for this port.
    Must be UDP, TCP, or SCTP.
    Default is TCP.
    +optional
    """
    appProtocol: builtins.str
    """The application protocol for this port.
    This field follows standard Kubernetes label syntax.
    Un-prefixed names are reserved for IANA standard service names (as per
    RFC-6335 and http://www.iana.org/assignments/service-names).
    Non-standard protocols should use prefixed names such as
    mycompany.com/my-custom-protocol.
    +optional
    """
    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        port: builtins.int | None = ...,
        protocol: builtins.str | None = ...,
        appProtocol: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["appProtocol", b"appProtocol", "name", b"name", "port", b"port", "protocol", b"protocol"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["appProtocol", b"appProtocol", "name", b"name", "port", b"port", "protocol", b"protocol"]) -> None: ...

global___EndpointPort = EndpointPort

@typing.final
class EndpointSubset(google.protobuf.message.Message):
    """EndpointSubset is a group of addresses with a common set of ports. The
    expanded set of endpoints is the Cartesian product of Addresses x Ports.
    For example, given:
      {
        Addresses: [{"ip": "10.10.1.1"}, {"ip": "10.10.2.2"}],
        Ports:     [{"name": "a", "port": 8675}, {"name": "b", "port": 309}]
      }
    The resulting set of endpoints can be viewed as:
        a: [ 10.10.1.1:8675, 10.10.2.2:8675 ],
        b: [ 10.10.1.1:309, 10.10.2.2:309 ]
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ADDRESSES_FIELD_NUMBER: builtins.int
    NOTREADYADDRESSES_FIELD_NUMBER: builtins.int
    PORTS_FIELD_NUMBER: builtins.int
    @property
    def addresses(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___EndpointAddress]:
        """IP addresses which offer the related ports that are marked as ready. These endpoints
        should be considered safe for load balancers and clients to utilize.
        +optional
        """

    @property
    def notReadyAddresses(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___EndpointAddress]:
        """IP addresses which offer the related ports but are not currently marked as ready
        because they have not yet finished starting, have recently failed a readiness check,
        or have recently failed a liveness check.
        +optional
        """

    @property
    def ports(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___EndpointPort]:
        """Port numbers available on the related IP addresses.
        +optional
        """

    def __init__(
        self,
        *,
        addresses: collections.abc.Iterable[global___EndpointAddress] | None = ...,
        notReadyAddresses: collections.abc.Iterable[global___EndpointAddress] | None = ...,
        ports: collections.abc.Iterable[global___EndpointPort] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["addresses", b"addresses", "notReadyAddresses", b"notReadyAddresses", "ports", b"ports"]) -> None: ...

global___EndpointSubset = EndpointSubset

@typing.final
class Endpoints(google.protobuf.message.Message):
    """Endpoints is a collection of endpoints that implement the actual service. Example:
      Name: "mysvc",
      Subsets: [
        {
          Addresses: [{"ip": "10.10.1.1"}, {"ip": "10.10.2.2"}],
          Ports: [{"name": "a", "port": 8675}, {"name": "b", "port": 309}]
        },
        {
          Addresses: [{"ip": "10.10.3.3"}],
          Ports: [{"name": "a", "port": 93}, {"name": "b", "port": 76}]
        },
     ]
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SUBSETS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def subsets(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___EndpointSubset]:
        """The set of all endpoints is the union of all subsets. Addresses are placed into
        subsets according to the IPs they share. A single address with multiple ports,
        some of which are ready and some of which are not (because they come from
        different containers) will result in the address being displayed in different
        subsets for the different ports. No address will appear in both Addresses and
        NotReadyAddresses in the same subset.
        Sets of addresses and ports that comprise a service.
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        subsets: collections.abc.Iterable[global___EndpointSubset] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "subsets", b"subsets"]) -> None: ...

global___Endpoints = Endpoints

@typing.final
class EndpointsList(google.protobuf.message.Message):
    """EndpointsList is a list of endpoints."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Endpoints]:
        """List of endpoints."""

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___Endpoints] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___EndpointsList = EndpointsList

@typing.final
class EnvFromSource(google.protobuf.message.Message):
    """EnvFromSource represents the source of a set of ConfigMaps"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PREFIX_FIELD_NUMBER: builtins.int
    CONFIGMAPREF_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    prefix: builtins.str
    """An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER.
    +optional
    """
    @property
    def configMapRef(self) -> global___ConfigMapEnvSource:
        """The ConfigMap to select from
        +optional
        """

    @property
    def secretRef(self) -> global___SecretEnvSource:
        """The Secret to select from
        +optional
        """

    def __init__(
        self,
        *,
        prefix: builtins.str | None = ...,
        configMapRef: global___ConfigMapEnvSource | None = ...,
        secretRef: global___SecretEnvSource | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["configMapRef", b"configMapRef", "prefix", b"prefix", "secretRef", b"secretRef"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["configMapRef", b"configMapRef", "prefix", b"prefix", "secretRef", b"secretRef"]) -> None: ...

global___EnvFromSource = EnvFromSource

@typing.final
class EnvVar(google.protobuf.message.Message):
    """EnvVar represents an environment variable present in a Container."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    VALUE_FIELD_NUMBER: builtins.int
    VALUEFROM_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Name of the environment variable. Must be a C_IDENTIFIER."""
    value: builtins.str
    """Variable references $(VAR_NAME) are expanded
    using the previously defined environment variables in the container and
    any service environment variables. If a variable cannot be resolved,
    the reference in the input string will be unchanged. Double $$ are reduced
    to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e.
    "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)".
    Escaped references will never be expanded, regardless of whether the variable
    exists or not.
    Defaults to "".
    +optional
    """
    @property
    def valueFrom(self) -> global___EnvVarSource:
        """Source for the environment variable's value. Cannot be used if value is not empty.
        +optional
        """

    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        value: builtins.str | None = ...,
        valueFrom: global___EnvVarSource | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["name", b"name", "value", b"value", "valueFrom", b"valueFrom"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "value", b"value", "valueFrom", b"valueFrom"]) -> None: ...

global___EnvVar = EnvVar

@typing.final
class EnvVarSource(google.protobuf.message.Message):
    """EnvVarSource represents a source for the value of an EnvVar."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FIELDREF_FIELD_NUMBER: builtins.int
    RESOURCEFIELDREF_FIELD_NUMBER: builtins.int
    CONFIGMAPKEYREF_FIELD_NUMBER: builtins.int
    SECRETKEYREF_FIELD_NUMBER: builtins.int
    @property
    def fieldRef(self) -> global___ObjectFieldSelector:
        """Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`,
        spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
        +optional
        """

    @property
    def resourceFieldRef(self) -> global___ResourceFieldSelector:
        """Selects a resource of the container: only resources limits and requests
        (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
        +optional
        """

    @property
    def configMapKeyRef(self) -> global___ConfigMapKeySelector:
        """Selects a key of a ConfigMap.
        +optional
        """

    @property
    def secretKeyRef(self) -> global___SecretKeySelector:
        """Selects a key of a secret in the pod's namespace
        +optional
        """

    def __init__(
        self,
        *,
        fieldRef: global___ObjectFieldSelector | None = ...,
        resourceFieldRef: global___ResourceFieldSelector | None = ...,
        configMapKeyRef: global___ConfigMapKeySelector | None = ...,
        secretKeyRef: global___SecretKeySelector | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["configMapKeyRef", b"configMapKeyRef", "fieldRef", b"fieldRef", "resourceFieldRef", b"resourceFieldRef", "secretKeyRef", b"secretKeyRef"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["configMapKeyRef", b"configMapKeyRef", "fieldRef", b"fieldRef", "resourceFieldRef", b"resourceFieldRef", "secretKeyRef", b"secretKeyRef"]) -> None: ...

global___EnvVarSource = EnvVarSource

@typing.final
class EphemeralContainer(google.protobuf.message.Message):
    """An EphemeralContainer is a container that may be added temporarily to an existing pod for
    user-initiated activities such as debugging. Ephemeral containers have no resource or
    scheduling guarantees, and they will not be restarted when they exit or when a pod is
    removed or restarted. If an ephemeral container causes a pod to exceed its resource
    allocation, the pod may be evicted.
    Ephemeral containers may not be added by directly updating the pod spec. They must be added
    via the pod's ephemeralcontainers subresource, and they will appear in the pod spec
    once added.
    This is an alpha feature enabled by the EphemeralContainers feature flag.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EPHEMERALCONTAINERCOMMON_FIELD_NUMBER: builtins.int
    TARGETCONTAINERNAME_FIELD_NUMBER: builtins.int
    targetContainerName: builtins.str
    """If set, the name of the container from PodSpec that this ephemeral container targets.
    The ephemeral container will be run in the namespaces (IPC, PID, etc) of this container.
    If not set then the ephemeral container is run in whatever namespaces are shared
    for the pod. Note that the container runtime must support this feature.
    +optional
    """
    @property
    def ephemeralContainerCommon(self) -> global___EphemeralContainerCommon:
        """Ephemeral containers have all of the fields of Container, plus additional fields
        specific to ephemeral containers. Fields in common with Container are in the
        following inlined struct so than an EphemeralContainer may easily be converted
        to a Container.
        """

    def __init__(
        self,
        *,
        ephemeralContainerCommon: global___EphemeralContainerCommon | None = ...,
        targetContainerName: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["ephemeralContainerCommon", b"ephemeralContainerCommon", "targetContainerName", b"targetContainerName"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["ephemeralContainerCommon", b"ephemeralContainerCommon", "targetContainerName", b"targetContainerName"]) -> None: ...

global___EphemeralContainer = EphemeralContainer

@typing.final
class EphemeralContainerCommon(google.protobuf.message.Message):
    """EphemeralContainerCommon is a copy of all fields in Container to be inlined in
    EphemeralContainer. This separate type allows easy conversion from EphemeralContainer
    to Container and allows separate documentation for the fields of EphemeralContainer.
    When a new field is added to Container it must be added here as well.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    IMAGE_FIELD_NUMBER: builtins.int
    COMMAND_FIELD_NUMBER: builtins.int
    ARGS_FIELD_NUMBER: builtins.int
    WORKINGDIR_FIELD_NUMBER: builtins.int
    PORTS_FIELD_NUMBER: builtins.int
    ENVFROM_FIELD_NUMBER: builtins.int
    ENV_FIELD_NUMBER: builtins.int
    RESOURCES_FIELD_NUMBER: builtins.int
    VOLUMEMOUNTS_FIELD_NUMBER: builtins.int
    VOLUMEDEVICES_FIELD_NUMBER: builtins.int
    LIVENESSPROBE_FIELD_NUMBER: builtins.int
    READINESSPROBE_FIELD_NUMBER: builtins.int
    STARTUPPROBE_FIELD_NUMBER: builtins.int
    LIFECYCLE_FIELD_NUMBER: builtins.int
    TERMINATIONMESSAGEPATH_FIELD_NUMBER: builtins.int
    TERMINATIONMESSAGEPOLICY_FIELD_NUMBER: builtins.int
    IMAGEPULLPOLICY_FIELD_NUMBER: builtins.int
    SECURITYCONTEXT_FIELD_NUMBER: builtins.int
    STDIN_FIELD_NUMBER: builtins.int
    STDINONCE_FIELD_NUMBER: builtins.int
    TTY_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Name of the ephemeral container specified as a DNS_LABEL.
    This name must be unique among all containers, init containers and ephemeral containers.
    """
    image: builtins.str
    """Docker image name.
    More info: https://kubernetes.io/docs/concepts/containers/images
    """
    workingDir: builtins.str
    """Container's working directory.
    If not specified, the container runtime's default will be used, which
    might be configured in the container image.
    Cannot be updated.
    +optional
    """
    terminationMessagePath: builtins.str
    """Optional: Path at which the file to which the container's termination message
    will be written is mounted into the container's filesystem.
    Message written is intended to be brief final status, such as an assertion failure message.
    Will be truncated by the node if greater than 4096 bytes. The total message length across
    all containers will be limited to 12kb.
    Defaults to /dev/termination-log.
    Cannot be updated.
    +optional
    """
    terminationMessagePolicy: builtins.str
    """Indicate how the termination message should be populated. File will use the contents of
    terminationMessagePath to populate the container status message on both success and failure.
    FallbackToLogsOnError will use the last chunk of container log output if the termination
    message file is empty and the container exited with an error.
    The log output is limited to 2048 bytes or 80 lines, whichever is smaller.
    Defaults to File.
    Cannot be updated.
    +optional
    """
    imagePullPolicy: builtins.str
    """Image pull policy.
    One of Always, Never, IfNotPresent.
    Defaults to Always if :latest tag is specified, or IfNotPresent otherwise.
    Cannot be updated.
    More info: https://kubernetes.io/docs/concepts/containers/images#updating-images
    +optional
    """
    stdin: builtins.bool
    """Whether this container should allocate a buffer for stdin in the container runtime. If this
    is not set, reads from stdin in the container will always result in EOF.
    Default is false.
    +optional
    """
    stdinOnce: builtins.bool
    """Whether the container runtime should close the stdin channel after it has been opened by
    a single attach. When stdin is true the stdin stream will remain open across multiple attach
    sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the
    first client attaches to stdin, and then remains open and accepts data until the client disconnects,
    at which time stdin is closed and remains closed until the container is restarted. If this
    flag is false, a container processes that reads from stdin will never receive an EOF.
    Default is false
    +optional
    """
    tty: builtins.bool
    """Whether this container should allocate a TTY for itself, also requires 'stdin' to be true.
    Default is false.
    +optional
    """
    @property
    def command(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Entrypoint array. Not executed within a shell.
        The docker image's ENTRYPOINT is used if this is not provided.
        Variable references $(VAR_NAME) are expanded using the container's environment. If a variable
        cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced
        to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will
        produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless
        of whether the variable exists or not. Cannot be updated.
        More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
        +optional
        """

    @property
    def args(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Arguments to the entrypoint.
        The docker image's CMD is used if this is not provided.
        Variable references $(VAR_NAME) are expanded using the container's environment. If a variable
        cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced
        to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will
        produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless
        of whether the variable exists or not. Cannot be updated.
        More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
        +optional
        """

    @property
    def ports(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ContainerPort]:
        """Ports are not allowed for ephemeral containers."""

    @property
    def envFrom(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___EnvFromSource]:
        """List of sources to populate environment variables in the container.
        The keys defined within a source must be a C_IDENTIFIER. All invalid keys
        will be reported as an event when the container is starting. When a key exists in multiple
        sources, the value associated with the last source will take precedence.
        Values defined by an Env with a duplicate key will take precedence.
        Cannot be updated.
        +optional
        """

    @property
    def env(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___EnvVar]:
        """List of environment variables to set in the container.
        Cannot be updated.
        +optional
        +patchMergeKey=name
        +patchStrategy=merge
        """

    @property
    def resources(self) -> global___ResourceRequirements:
        """Resources are not allowed for ephemeral containers. Ephemeral containers use spare resources
        already allocated to the pod.
        +optional
        """

    @property
    def volumeMounts(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___VolumeMount]:
        """Pod volumes to mount into the container's filesystem.
        Cannot be updated.
        +optional
        +patchMergeKey=mountPath
        +patchStrategy=merge
        """

    @property
    def volumeDevices(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___VolumeDevice]:
        """volumeDevices is the list of block devices to be used by the container.
        +patchMergeKey=devicePath
        +patchStrategy=merge
        +optional
        """

    @property
    def livenessProbe(self) -> global___Probe:
        """Probes are not allowed for ephemeral containers.
        +optional
        """

    @property
    def readinessProbe(self) -> global___Probe:
        """Probes are not allowed for ephemeral containers.
        +optional
        """

    @property
    def startupProbe(self) -> global___Probe:
        """Probes are not allowed for ephemeral containers.
        +optional
        """

    @property
    def lifecycle(self) -> global___Lifecycle:
        """Lifecycle is not allowed for ephemeral containers.
        +optional
        """

    @property
    def securityContext(self) -> global___SecurityContext:
        """Optional: SecurityContext defines the security options the ephemeral container should be run with.
        If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext.
        +optional
        """

    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        image: builtins.str | None = ...,
        command: collections.abc.Iterable[builtins.str] | None = ...,
        args: collections.abc.Iterable[builtins.str] | None = ...,
        workingDir: builtins.str | None = ...,
        ports: collections.abc.Iterable[global___ContainerPort] | None = ...,
        envFrom: collections.abc.Iterable[global___EnvFromSource] | None = ...,
        env: collections.abc.Iterable[global___EnvVar] | None = ...,
        resources: global___ResourceRequirements | None = ...,
        volumeMounts: collections.abc.Iterable[global___VolumeMount] | None = ...,
        volumeDevices: collections.abc.Iterable[global___VolumeDevice] | None = ...,
        livenessProbe: global___Probe | None = ...,
        readinessProbe: global___Probe | None = ...,
        startupProbe: global___Probe | None = ...,
        lifecycle: global___Lifecycle | None = ...,
        terminationMessagePath: builtins.str | None = ...,
        terminationMessagePolicy: builtins.str | None = ...,
        imagePullPolicy: builtins.str | None = ...,
        securityContext: global___SecurityContext | None = ...,
        stdin: builtins.bool | None = ...,
        stdinOnce: builtins.bool | None = ...,
        tty: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["image", b"image", "imagePullPolicy", b"imagePullPolicy", "lifecycle", b"lifecycle", "livenessProbe", b"livenessProbe", "name", b"name", "readinessProbe", b"readinessProbe", "resources", b"resources", "securityContext", b"securityContext", "startupProbe", b"startupProbe", "stdin", b"stdin", "stdinOnce", b"stdinOnce", "terminationMessagePath", b"terminationMessagePath", "terminationMessagePolicy", b"terminationMessagePolicy", "tty", b"tty", "workingDir", b"workingDir"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["args", b"args", "command", b"command", "env", b"env", "envFrom", b"envFrom", "image", b"image", "imagePullPolicy", b"imagePullPolicy", "lifecycle", b"lifecycle", "livenessProbe", b"livenessProbe", "name", b"name", "ports", b"ports", "readinessProbe", b"readinessProbe", "resources", b"resources", "securityContext", b"securityContext", "startupProbe", b"startupProbe", "stdin", b"stdin", "stdinOnce", b"stdinOnce", "terminationMessagePath", b"terminationMessagePath", "terminationMessagePolicy", b"terminationMessagePolicy", "tty", b"tty", "volumeDevices", b"volumeDevices", "volumeMounts", b"volumeMounts", "workingDir", b"workingDir"]) -> None: ...

global___EphemeralContainerCommon = EphemeralContainerCommon

@typing.final
class EphemeralVolumeSource(google.protobuf.message.Message):
    """Represents an ephemeral volume that is handled by a normal storage driver."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VOLUMECLAIMTEMPLATE_FIELD_NUMBER: builtins.int
    @property
    def volumeClaimTemplate(self) -> global___PersistentVolumeClaimTemplate:
        """Will be used to create a stand-alone PVC to provision the volume.
        The pod in which this EphemeralVolumeSource is embedded will be the
        owner of the PVC, i.e. the PVC will be deleted together with the
        pod.  The name of the PVC will be `<pod name>-<volume name>` where
        `<volume name>` is the name from the `PodSpec.Volumes` array
        entry. Pod validation will reject the pod if the concatenated name
        is not valid for a PVC (for example, too long).

        An existing PVC with that name that is not owned by the pod
        will *not* be used for the pod to avoid using an unrelated
        volume by mistake. Starting the pod is then blocked until
        the unrelated PVC is removed. If such a pre-created PVC is
        meant to be used by the pod, the PVC has to updated with an
        owner reference to the pod once the pod exists. Normally
        this should not be necessary, but it may be useful when
        manually reconstructing a broken cluster.

        This field is read-only and no changes will be made by Kubernetes
        to the PVC after it has been created.

        Required, must not be nil.
        """

    def __init__(
        self,
        *,
        volumeClaimTemplate: global___PersistentVolumeClaimTemplate | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["volumeClaimTemplate", b"volumeClaimTemplate"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["volumeClaimTemplate", b"volumeClaimTemplate"]) -> None: ...

global___EphemeralVolumeSource = EphemeralVolumeSource

@typing.final
class Event(google.protobuf.message.Message):
    """Event is a report of an event somewhere in the cluster.  Events
    have a limited retention time and triggers and messages may evolve
    with time.  Event consumers should not rely on the timing of an event
    with a given Reason reflecting a consistent underlying trigger, or the
    continued existence of events with that Reason.  Events should be
    treated as informative, best-effort, supplemental data.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    INVOLVEDOBJECT_FIELD_NUMBER: builtins.int
    REASON_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    SOURCE_FIELD_NUMBER: builtins.int
    FIRSTTIMESTAMP_FIELD_NUMBER: builtins.int
    LASTTIMESTAMP_FIELD_NUMBER: builtins.int
    COUNT_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    EVENTTIME_FIELD_NUMBER: builtins.int
    SERIES_FIELD_NUMBER: builtins.int
    ACTION_FIELD_NUMBER: builtins.int
    RELATED_FIELD_NUMBER: builtins.int
    REPORTINGCOMPONENT_FIELD_NUMBER: builtins.int
    REPORTINGINSTANCE_FIELD_NUMBER: builtins.int
    reason: builtins.str
    """This should be a short, machine understandable string that gives the reason
    for the transition into the object's current status.
    TODO: provide exact specification for format.
    +optional
    """
    message: builtins.str
    """A human-readable description of the status of this operation.
    TODO: decide on maximum length.
    +optional
    """
    count: builtins.int
    """The number of times this event has occurred.
    +optional
    """
    type: builtins.str
    """Type of this event (Normal, Warning), new types could be added in the future
    +optional
    """
    action: builtins.str
    """What action was taken/failed regarding to the Regarding object.
    +optional
    """
    reportingComponent: builtins.str
    """Name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`.
    +optional
    """
    reportingInstance: builtins.str
    """ID of the controller instance, e.g. `kubelet-xyzf`.
    +optional
    """
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        """

    @property
    def involvedObject(self) -> global___ObjectReference:
        """The object that this event is about."""

    @property
    def source(self) -> global___EventSource:
        """The component reporting this event. Should be a short machine understandable string.
        +optional
        """

    @property
    def firstTimestamp(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """The time at which the event was first recorded. (Time of server receipt is in TypeMeta.)
        +optional
        """

    @property
    def lastTimestamp(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """The time at which the most recent occurrence of this event was recorded.
        +optional
        """

    @property
    def eventTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.MicroTime:
        """Time when this Event was first observed.
        +optional
        """

    @property
    def series(self) -> global___EventSeries:
        """Data about the Event series this event represents or nil if it's a singleton Event.
        +optional
        """

    @property
    def related(self) -> global___ObjectReference:
        """Optional secondary object for more complex actions.
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        involvedObject: global___ObjectReference | None = ...,
        reason: builtins.str | None = ...,
        message: builtins.str | None = ...,
        source: global___EventSource | None = ...,
        firstTimestamp: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        lastTimestamp: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        count: builtins.int | None = ...,
        type: builtins.str | None = ...,
        eventTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.MicroTime | None = ...,
        series: global___EventSeries | None = ...,
        action: builtins.str | None = ...,
        related: global___ObjectReference | None = ...,
        reportingComponent: builtins.str | None = ...,
        reportingInstance: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["action", b"action", "count", b"count", "eventTime", b"eventTime", "firstTimestamp", b"firstTimestamp", "involvedObject", b"involvedObject", "lastTimestamp", b"lastTimestamp", "message", b"message", "metadata", b"metadata", "reason", b"reason", "related", b"related", "reportingComponent", b"reportingComponent", "reportingInstance", b"reportingInstance", "series", b"series", "source", b"source", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["action", b"action", "count", b"count", "eventTime", b"eventTime", "firstTimestamp", b"firstTimestamp", "involvedObject", b"involvedObject", "lastTimestamp", b"lastTimestamp", "message", b"message", "metadata", b"metadata", "reason", b"reason", "related", b"related", "reportingComponent", b"reportingComponent", "reportingInstance", b"reportingInstance", "series", b"series", "source", b"source", "type", b"type"]) -> None: ...

global___Event = Event

@typing.final
class EventList(google.protobuf.message.Message):
    """EventList is a list of events."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Event]:
        """List of events"""

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___Event] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___EventList = EventList

@typing.final
class EventSeries(google.protobuf.message.Message):
    """EventSeries contain information on series of events, i.e. thing that was/is happening
    continuously for some time.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    COUNT_FIELD_NUMBER: builtins.int
    LASTOBSERVEDTIME_FIELD_NUMBER: builtins.int
    count: builtins.int
    """Number of occurrences in this series up to the last heartbeat time"""
    @property
    def lastObservedTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.MicroTime:
        """Time of the last occurrence observed"""

    def __init__(
        self,
        *,
        count: builtins.int | None = ...,
        lastObservedTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.MicroTime | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["count", b"count", "lastObservedTime", b"lastObservedTime"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["count", b"count", "lastObservedTime", b"lastObservedTime"]) -> None: ...

global___EventSeries = EventSeries

@typing.final
class EventSource(google.protobuf.message.Message):
    """EventSource contains information for an event."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    COMPONENT_FIELD_NUMBER: builtins.int
    HOST_FIELD_NUMBER: builtins.int
    component: builtins.str
    """Component from which the event is generated.
    +optional
    """
    host: builtins.str
    """Node name on which the event is generated.
    +optional
    """
    def __init__(
        self,
        *,
        component: builtins.str | None = ...,
        host: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["component", b"component", "host", b"host"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["component", b"component", "host", b"host"]) -> None: ...

global___EventSource = EventSource

@typing.final
class ExecAction(google.protobuf.message.Message):
    """ExecAction describes a "run in container" action."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    COMMAND_FIELD_NUMBER: builtins.int
    @property
    def command(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Command is the command line to execute inside the container, the working directory for the
        command  is root ('/') in the container's filesystem. The command is simply exec'd, it is
        not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use
        a shell, you need to explicitly call out to that shell.
        Exit status of 0 is treated as live/healthy and non-zero is unhealthy.
        +optional
        """

    def __init__(
        self,
        *,
        command: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["command", b"command"]) -> None: ...

global___ExecAction = ExecAction

@typing.final
class FCVolumeSource(google.protobuf.message.Message):
    """Represents a Fibre Channel volume.
    Fibre Channel volumes can only be mounted as read/write once.
    Fibre Channel volumes support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TARGETWWNS_FIELD_NUMBER: builtins.int
    LUN_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    WWIDS_FIELD_NUMBER: builtins.int
    lun: builtins.int
    """Optional: FC target lun number
    +optional
    """
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    TODO: how do we prevent errors in the filesystem from compromising the machine
    +optional
    """
    readOnly: builtins.bool
    """Optional: Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    +optional
    """
    @property
    def targetWWNs(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Optional: FC target worldwide names (WWNs)
        +optional
        """

    @property
    def wwids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Optional: FC volume world wide identifiers (wwids)
        Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.
        +optional
        """

    def __init__(
        self,
        *,
        targetWWNs: collections.abc.Iterable[builtins.str] | None = ...,
        lun: builtins.int | None = ...,
        fsType: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        wwids: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "lun", b"lun", "readOnly", b"readOnly"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "lun", b"lun", "readOnly", b"readOnly", "targetWWNs", b"targetWWNs", "wwids", b"wwids"]) -> None: ...

global___FCVolumeSource = FCVolumeSource

@typing.final
class FlexPersistentVolumeSource(google.protobuf.message.Message):
    """FlexPersistentVolumeSource represents a generic persistent volume resource that is
    provisioned/attached using an exec based plugin.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class OptionsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: builtins.str | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    DRIVER_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    OPTIONS_FIELD_NUMBER: builtins.int
    driver: builtins.str
    """Driver is the name of the driver to use for this volume."""
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script.
    +optional
    """
    readOnly: builtins.bool
    """Optional: Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    +optional
    """
    @property
    def secretRef(self) -> global___SecretReference:
        """Optional: SecretRef is reference to the secret object containing
        sensitive information to pass to the plugin scripts. This may be
        empty if no secret object is specified. If the secret object
        contains more than one secret, all secrets are passed to the plugin
        scripts.
        +optional
        """

    @property
    def options(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """Optional: Extra command options if any.
        +optional
        """

    def __init__(
        self,
        *,
        driver: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        secretRef: global___SecretReference | None = ...,
        readOnly: builtins.bool | None = ...,
        options: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["driver", b"driver", "fsType", b"fsType", "readOnly", b"readOnly", "secretRef", b"secretRef"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["driver", b"driver", "fsType", b"fsType", "options", b"options", "readOnly", b"readOnly", "secretRef", b"secretRef"]) -> None: ...

global___FlexPersistentVolumeSource = FlexPersistentVolumeSource

@typing.final
class FlexVolumeSource(google.protobuf.message.Message):
    """FlexVolume represents a generic volume resource that is
    provisioned/attached using an exec based plugin.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class OptionsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: builtins.str | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    DRIVER_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    OPTIONS_FIELD_NUMBER: builtins.int
    driver: builtins.str
    """Driver is the name of the driver to use for this volume."""
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script.
    +optional
    """
    readOnly: builtins.bool
    """Optional: Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    +optional
    """
    @property
    def secretRef(self) -> global___LocalObjectReference:
        """Optional: SecretRef is reference to the secret object containing
        sensitive information to pass to the plugin scripts. This may be
        empty if no secret object is specified. If the secret object
        contains more than one secret, all secrets are passed to the plugin
        scripts.
        +optional
        """

    @property
    def options(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """Optional: Extra command options if any.
        +optional
        """

    def __init__(
        self,
        *,
        driver: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        secretRef: global___LocalObjectReference | None = ...,
        readOnly: builtins.bool | None = ...,
        options: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["driver", b"driver", "fsType", b"fsType", "readOnly", b"readOnly", "secretRef", b"secretRef"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["driver", b"driver", "fsType", b"fsType", "options", b"options", "readOnly", b"readOnly", "secretRef", b"secretRef"]) -> None: ...

global___FlexVolumeSource = FlexVolumeSource

@typing.final
class FlockerVolumeSource(google.protobuf.message.Message):
    """Represents a Flocker volume mounted by the Flocker agent.
    One and only one of datasetName and datasetUUID should be set.
    Flocker volumes do not support ownership management or SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DATASETNAME_FIELD_NUMBER: builtins.int
    DATASETUUID_FIELD_NUMBER: builtins.int
    datasetName: builtins.str
    """Name of the dataset stored as metadata -> name on the dataset for Flocker
    should be considered as deprecated
    +optional
    """
    datasetUUID: builtins.str
    """UUID of the dataset. This is unique identifier of a Flocker dataset
    +optional
    """
    def __init__(
        self,
        *,
        datasetName: builtins.str | None = ...,
        datasetUUID: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["datasetName", b"datasetName", "datasetUUID", b"datasetUUID"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["datasetName", b"datasetName", "datasetUUID", b"datasetUUID"]) -> None: ...

global___FlockerVolumeSource = FlockerVolumeSource

@typing.final
class GCEPersistentDiskVolumeSource(google.protobuf.message.Message):
    """Represents a Persistent Disk resource in Google Compute Engine.

    A GCE PD must exist before mounting to a container. The disk must
    also be in the same GCE project and zone as the kubelet. A GCE PD
    can only be mounted as read/write once or read-only many times. GCE
    PDs support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PDNAME_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    PARTITION_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    pdName: builtins.str
    """Unique name of the PD resource in GCE. Used to identify the disk in GCE.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
    """
    fsType: builtins.str
    """Filesystem type of the volume that you want to mount.
    Tip: Ensure that the filesystem type is supported by the host operating system.
    Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
    TODO: how do we prevent errors in the filesystem from compromising the machine
    +optional
    """
    partition: builtins.int
    """The partition in the volume that you want to mount.
    If omitted, the default is to mount by volume name.
    Examples: For volume /dev/sda1, you specify the partition as "1".
    Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).
    More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
    +optional
    """
    readOnly: builtins.bool
    """ReadOnly here will force the ReadOnly setting in VolumeMounts.
    Defaults to false.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
    +optional
    """
    def __init__(
        self,
        *,
        pdName: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        partition: builtins.int | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "partition", b"partition", "pdName", b"pdName", "readOnly", b"readOnly"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "partition", b"partition", "pdName", b"pdName", "readOnly", b"readOnly"]) -> None: ...

global___GCEPersistentDiskVolumeSource = GCEPersistentDiskVolumeSource

@typing.final
class GitRepoVolumeSource(google.protobuf.message.Message):
    """Represents a volume that is populated with the contents of a git repository.
    Git repo volumes do not support ownership management.
    Git repo volumes support SELinux relabeling.

    DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an
    EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir
    into the Pod's container.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REPOSITORY_FIELD_NUMBER: builtins.int
    REVISION_FIELD_NUMBER: builtins.int
    DIRECTORY_FIELD_NUMBER: builtins.int
    repository: builtins.str
    """Repository URL"""
    revision: builtins.str
    """Commit hash for the specified revision.
    +optional
    """
    directory: builtins.str
    """Target directory name.
    Must not contain or start with '..'.  If '.' is supplied, the volume directory will be the
    git repository.  Otherwise, if specified, the volume will contain the git repository in
    the subdirectory with the given name.
    +optional
    """
    def __init__(
        self,
        *,
        repository: builtins.str | None = ...,
        revision: builtins.str | None = ...,
        directory: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["directory", b"directory", "repository", b"repository", "revision", b"revision"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["directory", b"directory", "repository", b"repository", "revision", b"revision"]) -> None: ...

global___GitRepoVolumeSource = GitRepoVolumeSource

@typing.final
class GlusterfsPersistentVolumeSource(google.protobuf.message.Message):
    """Represents a Glusterfs mount that lasts the lifetime of a pod.
    Glusterfs volumes do not support ownership management or SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ENDPOINTS_FIELD_NUMBER: builtins.int
    PATH_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    ENDPOINTSNAMESPACE_FIELD_NUMBER: builtins.int
    endpoints: builtins.str
    """EndpointsName is the endpoint name that details Glusterfs topology.
    More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
    """
    path: builtins.str
    """Path is the Glusterfs volume path.
    More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
    """
    readOnly: builtins.bool
    """ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions.
    Defaults to false.
    More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
    +optional
    """
    endpointsNamespace: builtins.str
    """EndpointsNamespace is the namespace that contains Glusterfs endpoint.
    If this field is empty, the EndpointNamespace defaults to the same namespace as the bound PVC.
    More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
    +optional
    """
    def __init__(
        self,
        *,
        endpoints: builtins.str | None = ...,
        path: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        endpointsNamespace: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["endpoints", b"endpoints", "endpointsNamespace", b"endpointsNamespace", "path", b"path", "readOnly", b"readOnly"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["endpoints", b"endpoints", "endpointsNamespace", b"endpointsNamespace", "path", b"path", "readOnly", b"readOnly"]) -> None: ...

global___GlusterfsPersistentVolumeSource = GlusterfsPersistentVolumeSource

@typing.final
class GlusterfsVolumeSource(google.protobuf.message.Message):
    """Represents a Glusterfs mount that lasts the lifetime of a pod.
    Glusterfs volumes do not support ownership management or SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ENDPOINTS_FIELD_NUMBER: builtins.int
    PATH_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    endpoints: builtins.str
    """EndpointsName is the endpoint name that details Glusterfs topology.
    More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
    """
    path: builtins.str
    """Path is the Glusterfs volume path.
    More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
    """
    readOnly: builtins.bool
    """ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions.
    Defaults to false.
    More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod
    +optional
    """
    def __init__(
        self,
        *,
        endpoints: builtins.str | None = ...,
        path: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["endpoints", b"endpoints", "path", b"path", "readOnly", b"readOnly"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["endpoints", b"endpoints", "path", b"path", "readOnly", b"readOnly"]) -> None: ...

global___GlusterfsVolumeSource = GlusterfsVolumeSource

@typing.final
class HTTPGetAction(google.protobuf.message.Message):
    """HTTPGetAction describes an action based on HTTP Get requests."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PATH_FIELD_NUMBER: builtins.int
    PORT_FIELD_NUMBER: builtins.int
    HOST_FIELD_NUMBER: builtins.int
    SCHEME_FIELD_NUMBER: builtins.int
    HTTPHEADERS_FIELD_NUMBER: builtins.int
    path: builtins.str
    """Path to access on the HTTP server.
    +optional
    """
    host: builtins.str
    """Host name to connect to, defaults to the pod IP. You probably want to set
    "Host" in httpHeaders instead.
    +optional
    """
    scheme: builtins.str
    """Scheme to use for connecting to the host.
    Defaults to HTTP.
    +optional
    """
    @property
    def port(self) -> armada_client.k8s.io.apimachinery.pkg.util.intstr.generated_pb2.IntOrString:
        """Name or number of the port to access on the container.
        Number must be in the range 1 to 65535.
        Name must be an IANA_SVC_NAME.
        """

    @property
    def httpHeaders(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___HTTPHeader]:
        """Custom headers to set in the request. HTTP allows repeated headers.
        +optional
        """

    def __init__(
        self,
        *,
        path: builtins.str | None = ...,
        port: armada_client.k8s.io.apimachinery.pkg.util.intstr.generated_pb2.IntOrString | None = ...,
        host: builtins.str | None = ...,
        scheme: builtins.str | None = ...,
        httpHeaders: collections.abc.Iterable[global___HTTPHeader] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["host", b"host", "path", b"path", "port", b"port", "scheme", b"scheme"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["host", b"host", "httpHeaders", b"httpHeaders", "path", b"path", "port", b"port", "scheme", b"scheme"]) -> None: ...

global___HTTPGetAction = HTTPGetAction

@typing.final
class HTTPHeader(google.protobuf.message.Message):
    """HTTPHeader describes a custom header to be used in HTTP probes"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    VALUE_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The header field name"""
    value: builtins.str
    """The header field value"""
    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        value: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["name", b"name", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "value", b"value"]) -> None: ...

global___HTTPHeader = HTTPHeader

@typing.final
class Handler(google.protobuf.message.Message):
    """Handler defines a specific action that should be taken
    TODO: pass structured data to these actions, and document that data here.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EXEC_FIELD_NUMBER: builtins.int
    HTTPGET_FIELD_NUMBER: builtins.int
    TCPSOCKET_FIELD_NUMBER: builtins.int
    @property
    def exec(self) -> global___ExecAction:
        """One and only one of the following should be specified.
        Exec specifies the action to take.
        +optional
        """

    @property
    def httpGet(self) -> global___HTTPGetAction:
        """HTTPGet specifies the http request to perform.
        +optional
        """

    @property
    def tcpSocket(self) -> global___TCPSocketAction:
        """TCPSocket specifies an action involving a TCP port.
        TCP hooks not yet supported
        TODO: implement a realistic TCP lifecycle hook
        +optional
        """

    def __init__(
        self,
        *,
        exec: global___ExecAction | None = ...,
        httpGet: global___HTTPGetAction | None = ...,
        tcpSocket: global___TCPSocketAction | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["exec", b"exec", "httpGet", b"httpGet", "tcpSocket", b"tcpSocket"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["exec", b"exec", "httpGet", b"httpGet", "tcpSocket", b"tcpSocket"]) -> None: ...

global___Handler = Handler

@typing.final
class HostAlias(google.protobuf.message.Message):
    """HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the
    pod's hosts file.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    IP_FIELD_NUMBER: builtins.int
    HOSTNAMES_FIELD_NUMBER: builtins.int
    ip: builtins.str
    """IP address of the host file entry."""
    @property
    def hostnames(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Hostnames for the above IP address."""

    def __init__(
        self,
        *,
        ip: builtins.str | None = ...,
        hostnames: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["ip", b"ip"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["hostnames", b"hostnames", "ip", b"ip"]) -> None: ...

global___HostAlias = HostAlias

@typing.final
class HostPathVolumeSource(google.protobuf.message.Message):
    """Represents a host path mapped into a pod.
    Host path volumes do not support ownership management or SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PATH_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    path: builtins.str
    """Path of the directory on the host.
    If the path is a symlink, it will follow the link to the real path.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath
    """
    type: builtins.str
    """Type for HostPath Volume
    Defaults to ""
    More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath
    +optional
    """
    def __init__(
        self,
        *,
        path: builtins.str | None = ...,
        type: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["path", b"path", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["path", b"path", "type", b"type"]) -> None: ...

global___HostPathVolumeSource = HostPathVolumeSource

@typing.final
class ISCSIPersistentVolumeSource(google.protobuf.message.Message):
    """ISCSIPersistentVolumeSource represents an ISCSI disk.
    ISCSI volumes can only be mounted as read/write once.
    ISCSI volumes support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TARGETPORTAL_FIELD_NUMBER: builtins.int
    IQN_FIELD_NUMBER: builtins.int
    LUN_FIELD_NUMBER: builtins.int
    ISCSIINTERFACE_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    PORTALS_FIELD_NUMBER: builtins.int
    CHAPAUTHDISCOVERY_FIELD_NUMBER: builtins.int
    CHAPAUTHSESSION_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    INITIATORNAME_FIELD_NUMBER: builtins.int
    targetPortal: builtins.str
    """iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port
    is other than default (typically TCP ports 860 and 3260).
    """
    iqn: builtins.str
    """Target iSCSI Qualified Name."""
    lun: builtins.int
    """iSCSI Target Lun number."""
    iscsiInterface: builtins.str
    """iSCSI Interface Name that uses an iSCSI transport.
    Defaults to 'default' (tcp).
    +optional
    """
    fsType: builtins.str
    """Filesystem type of the volume that you want to mount.
    Tip: Ensure that the filesystem type is supported by the host operating system.
    Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi
    TODO: how do we prevent errors in the filesystem from compromising the machine
    +optional
    """
    readOnly: builtins.bool
    """ReadOnly here will force the ReadOnly setting in VolumeMounts.
    Defaults to false.
    +optional
    """
    chapAuthDiscovery: builtins.bool
    """whether support iSCSI Discovery CHAP authentication
    +optional
    """
    chapAuthSession: builtins.bool
    """whether support iSCSI Session CHAP authentication
    +optional
    """
    initiatorName: builtins.str
    """Custom iSCSI Initiator Name.
    If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface
    <target portal>:<volume name> will be created for the connection.
    +optional
    """
    @property
    def portals(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """iSCSI Target Portal List. The Portal is either an IP or ip_addr:port if the port
        is other than default (typically TCP ports 860 and 3260).
        +optional
        """

    @property
    def secretRef(self) -> global___SecretReference:
        """CHAP Secret for iSCSI target and initiator authentication
        +optional
        """

    def __init__(
        self,
        *,
        targetPortal: builtins.str | None = ...,
        iqn: builtins.str | None = ...,
        lun: builtins.int | None = ...,
        iscsiInterface: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        portals: collections.abc.Iterable[builtins.str] | None = ...,
        chapAuthDiscovery: builtins.bool | None = ...,
        chapAuthSession: builtins.bool | None = ...,
        secretRef: global___SecretReference | None = ...,
        initiatorName: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["chapAuthDiscovery", b"chapAuthDiscovery", "chapAuthSession", b"chapAuthSession", "fsType", b"fsType", "initiatorName", b"initiatorName", "iqn", b"iqn", "iscsiInterface", b"iscsiInterface", "lun", b"lun", "readOnly", b"readOnly", "secretRef", b"secretRef", "targetPortal", b"targetPortal"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["chapAuthDiscovery", b"chapAuthDiscovery", "chapAuthSession", b"chapAuthSession", "fsType", b"fsType", "initiatorName", b"initiatorName", "iqn", b"iqn", "iscsiInterface", b"iscsiInterface", "lun", b"lun", "portals", b"portals", "readOnly", b"readOnly", "secretRef", b"secretRef", "targetPortal", b"targetPortal"]) -> None: ...

global___ISCSIPersistentVolumeSource = ISCSIPersistentVolumeSource

@typing.final
class ISCSIVolumeSource(google.protobuf.message.Message):
    """Represents an ISCSI disk.
    ISCSI volumes can only be mounted as read/write once.
    ISCSI volumes support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TARGETPORTAL_FIELD_NUMBER: builtins.int
    IQN_FIELD_NUMBER: builtins.int
    LUN_FIELD_NUMBER: builtins.int
    ISCSIINTERFACE_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    PORTALS_FIELD_NUMBER: builtins.int
    CHAPAUTHDISCOVERY_FIELD_NUMBER: builtins.int
    CHAPAUTHSESSION_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    INITIATORNAME_FIELD_NUMBER: builtins.int
    targetPortal: builtins.str
    """iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port
    is other than default (typically TCP ports 860 and 3260).
    """
    iqn: builtins.str
    """Target iSCSI Qualified Name."""
    lun: builtins.int
    """iSCSI Target Lun number."""
    iscsiInterface: builtins.str
    """iSCSI Interface Name that uses an iSCSI transport.
    Defaults to 'default' (tcp).
    +optional
    """
    fsType: builtins.str
    """Filesystem type of the volume that you want to mount.
    Tip: Ensure that the filesystem type is supported by the host operating system.
    Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi
    TODO: how do we prevent errors in the filesystem from compromising the machine
    +optional
    """
    readOnly: builtins.bool
    """ReadOnly here will force the ReadOnly setting in VolumeMounts.
    Defaults to false.
    +optional
    """
    chapAuthDiscovery: builtins.bool
    """whether support iSCSI Discovery CHAP authentication
    +optional
    """
    chapAuthSession: builtins.bool
    """whether support iSCSI Session CHAP authentication
    +optional
    """
    initiatorName: builtins.str
    """Custom iSCSI Initiator Name.
    If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface
    <target portal>:<volume name> will be created for the connection.
    +optional
    """
    @property
    def portals(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """iSCSI Target Portal List. The portal is either an IP or ip_addr:port if the port
        is other than default (typically TCP ports 860 and 3260).
        +optional
        """

    @property
    def secretRef(self) -> global___LocalObjectReference:
        """CHAP Secret for iSCSI target and initiator authentication
        +optional
        """

    def __init__(
        self,
        *,
        targetPortal: builtins.str | None = ...,
        iqn: builtins.str | None = ...,
        lun: builtins.int | None = ...,
        iscsiInterface: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        portals: collections.abc.Iterable[builtins.str] | None = ...,
        chapAuthDiscovery: builtins.bool | None = ...,
        chapAuthSession: builtins.bool | None = ...,
        secretRef: global___LocalObjectReference | None = ...,
        initiatorName: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["chapAuthDiscovery", b"chapAuthDiscovery", "chapAuthSession", b"chapAuthSession", "fsType", b"fsType", "initiatorName", b"initiatorName", "iqn", b"iqn", "iscsiInterface", b"iscsiInterface", "lun", b"lun", "readOnly", b"readOnly", "secretRef", b"secretRef", "targetPortal", b"targetPortal"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["chapAuthDiscovery", b"chapAuthDiscovery", "chapAuthSession", b"chapAuthSession", "fsType", b"fsType", "initiatorName", b"initiatorName", "iqn", b"iqn", "iscsiInterface", b"iscsiInterface", "lun", b"lun", "portals", b"portals", "readOnly", b"readOnly", "secretRef", b"secretRef", "targetPortal", b"targetPortal"]) -> None: ...

global___ISCSIVolumeSource = ISCSIVolumeSource

@typing.final
class KeyToPath(google.protobuf.message.Message):
    """Maps a string key to a path within a volume."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    PATH_FIELD_NUMBER: builtins.int
    MODE_FIELD_NUMBER: builtins.int
    key: builtins.str
    """The key to project."""
    path: builtins.str
    """The relative path of the file to map the key to.
    May not be an absolute path.
    May not contain the path element '..'.
    May not start with the string '..'.
    """
    mode: builtins.int
    """Optional: mode bits used to set permissions on this file.
    Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511.
    YAML accepts both octal and decimal values, JSON requires decimal values for mode bits.
    If not specified, the volume defaultMode will be used.
    This might be in conflict with other options that affect the file
    mode, like fsGroup, and the result can be other mode bits set.
    +optional
    """
    def __init__(
        self,
        *,
        key: builtins.str | None = ...,
        path: builtins.str | None = ...,
        mode: builtins.int | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "mode", b"mode", "path", b"path"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "mode", b"mode", "path", b"path"]) -> None: ...

global___KeyToPath = KeyToPath

@typing.final
class Lifecycle(google.protobuf.message.Message):
    """Lifecycle describes actions that the management system should take in response to container lifecycle
    events. For the PostStart and PreStop lifecycle handlers, management of the container blocks
    until the action is complete, unless the container process fails, in which case the handler is aborted.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    POSTSTART_FIELD_NUMBER: builtins.int
    PRESTOP_FIELD_NUMBER: builtins.int
    @property
    def postStart(self) -> global___Handler:
        """PostStart is called immediately after a container is created. If the handler fails,
        the container is terminated and restarted according to its restart policy.
        Other management of the container blocks until the hook completes.
        More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
        +optional
        """

    @property
    def preStop(self) -> global___Handler:
        """PreStop is called immediately before a container is terminated due to an
        API request or management event such as liveness/startup probe failure,
        preemption, resource contention, etc. The handler is not called if the
        container crashes or exits. The reason for termination is passed to the
        handler. The Pod's termination grace period countdown begins before the
        PreStop hooked is executed. Regardless of the outcome of the handler, the
        container will eventually terminate within the Pod's termination grace
        period. Other management of the container blocks until the hook completes
        or until the termination grace period is reached.
        More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks
        +optional
        """

    def __init__(
        self,
        *,
        postStart: global___Handler | None = ...,
        preStop: global___Handler | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["postStart", b"postStart", "preStop", b"preStop"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["postStart", b"postStart", "preStop", b"preStop"]) -> None: ...

global___Lifecycle = Lifecycle

@typing.final
class LimitRange(google.protobuf.message.Message):
    """LimitRange sets resource usage limits for each kind of resource in a Namespace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SPEC_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def spec(self) -> global___LimitRangeSpec:
        """Spec defines the limits enforced.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        spec: global___LimitRangeSpec | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec"]) -> None: ...

global___LimitRange = LimitRange

@typing.final
class LimitRangeItem(google.protobuf.message.Message):
    """LimitRangeItem defines a min/max usage limit for any resource that matches on kind."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class MaxEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    @typing.final
    class MinEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    @typing.final
    class DefaultEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    @typing.final
    class DefaultRequestEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    @typing.final
    class MaxLimitRequestRatioEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    TYPE_FIELD_NUMBER: builtins.int
    MAX_FIELD_NUMBER: builtins.int
    MIN_FIELD_NUMBER: builtins.int
    DEFAULT_FIELD_NUMBER: builtins.int
    DEFAULTREQUEST_FIELD_NUMBER: builtins.int
    MAXLIMITREQUESTRATIO_FIELD_NUMBER: builtins.int
    type: builtins.str
    """Type of resource that this limit applies to."""
    @property
    def max(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Max usage constraints on this kind by resource name.
        +optional
        """

    @property
    def min(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Min usage constraints on this kind by resource name.
        +optional
        """

    @property
    def default(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Default resource requirement limit value by resource name if resource limit is omitted.
        +optional
        """

    @property
    def defaultRequest(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """DefaultRequest is the default resource requirement request value by resource name if resource request is omitted.
        +optional
        """

    @property
    def maxLimitRequestRatio(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """MaxLimitRequestRatio if specified, the named resource must have a request and limit that are both non-zero where limit divided by request is less than or equal to the enumerated value; this represents the max burst for the named resource.
        +optional
        """

    def __init__(
        self,
        *,
        type: builtins.str | None = ...,
        max: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        min: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        default: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        defaultRequest: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        maxLimitRequestRatio: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["default", b"default", "defaultRequest", b"defaultRequest", "max", b"max", "maxLimitRequestRatio", b"maxLimitRequestRatio", "min", b"min", "type", b"type"]) -> None: ...

global___LimitRangeItem = LimitRangeItem

@typing.final
class LimitRangeList(google.protobuf.message.Message):
    """LimitRangeList is a list of LimitRange items."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___LimitRange]:
        """Items is a list of LimitRange objects.
        More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___LimitRange] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___LimitRangeList = LimitRangeList

@typing.final
class LimitRangeSpec(google.protobuf.message.Message):
    """LimitRangeSpec defines a min/max usage limit for resources that match on kind."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LIMITS_FIELD_NUMBER: builtins.int
    @property
    def limits(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___LimitRangeItem]:
        """Limits is the list of LimitRangeItem objects that are enforced."""

    def __init__(
        self,
        *,
        limits: collections.abc.Iterable[global___LimitRangeItem] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["limits", b"limits"]) -> None: ...

global___LimitRangeSpec = LimitRangeSpec

@typing.final
class List(google.protobuf.message.Message):
    """List holds a list of objects, which may not be known by the server."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[armada_client.k8s.io.apimachinery.pkg.runtime.generated_pb2.RawExtension]:
        """List of objects"""

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[armada_client.k8s.io.apimachinery.pkg.runtime.generated_pb2.RawExtension] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___List = List

@typing.final
class LoadBalancerIngress(google.protobuf.message.Message):
    """LoadBalancerIngress represents the status of a load-balancer ingress point:
    traffic intended for the service should be sent to an ingress point.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    IP_FIELD_NUMBER: builtins.int
    HOSTNAME_FIELD_NUMBER: builtins.int
    PORTS_FIELD_NUMBER: builtins.int
    ip: builtins.str
    """IP is set for load-balancer ingress points that are IP based
    (typically GCE or OpenStack load-balancers)
    +optional
    """
    hostname: builtins.str
    """Hostname is set for load-balancer ingress points that are DNS based
    (typically AWS load-balancers)
    +optional
    """
    @property
    def ports(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PortStatus]:
        """Ports is a list of records of service ports
        If used, every port defined in the service should have an entry in it
        +listType=atomic
        +optional
        """

    def __init__(
        self,
        *,
        ip: builtins.str | None = ...,
        hostname: builtins.str | None = ...,
        ports: collections.abc.Iterable[global___PortStatus] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["hostname", b"hostname", "ip", b"ip"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["hostname", b"hostname", "ip", b"ip", "ports", b"ports"]) -> None: ...

global___LoadBalancerIngress = LoadBalancerIngress

@typing.final
class LoadBalancerStatus(google.protobuf.message.Message):
    """LoadBalancerStatus represents the status of a load-balancer."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    INGRESS_FIELD_NUMBER: builtins.int
    @property
    def ingress(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___LoadBalancerIngress]:
        """Ingress is a list containing ingress points for the load-balancer.
        Traffic intended for the service should be sent to these ingress points.
        +optional
        """

    def __init__(
        self,
        *,
        ingress: collections.abc.Iterable[global___LoadBalancerIngress] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["ingress", b"ingress"]) -> None: ...

global___LoadBalancerStatus = LoadBalancerStatus

@typing.final
class LocalObjectReference(google.protobuf.message.Message):
    """LocalObjectReference contains enough information to let you locate the
    referenced object inside the same namespace.
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Name of the referent.
    More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names
    TODO: Add other useful fields. apiVersion, kind, uid?
    +optional
    """
    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["name", b"name"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["name", b"name"]) -> None: ...

global___LocalObjectReference = LocalObjectReference

@typing.final
class LocalVolumeSource(google.protobuf.message.Message):
    """Local represents directly-attached storage with node affinity (Beta feature)"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PATH_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    path: builtins.str
    """The full path to the volume on the node.
    It can be either a directory or block device (disk, partition, ...).
    """
    fsType: builtins.str
    """Filesystem type to mount.
    It applies only when the Path is a block device.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs". The default value is to auto-select a fileystem if unspecified.
    +optional
    """
    def __init__(
        self,
        *,
        path: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "path", b"path"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "path", b"path"]) -> None: ...

global___LocalVolumeSource = LocalVolumeSource

@typing.final
class NFSVolumeSource(google.protobuf.message.Message):
    """Represents an NFS mount that lasts the lifetime of a pod.
    NFS volumes do not support ownership management or SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SERVER_FIELD_NUMBER: builtins.int
    PATH_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    server: builtins.str
    """Server is the hostname or IP address of the NFS server.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
    """
    path: builtins.str
    """Path that is exported by the NFS server.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
    """
    readOnly: builtins.bool
    """ReadOnly here will force
    the NFS export to be mounted with read-only permissions.
    Defaults to false.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
    +optional
    """
    def __init__(
        self,
        *,
        server: builtins.str | None = ...,
        path: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["path", b"path", "readOnly", b"readOnly", "server", b"server"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["path", b"path", "readOnly", b"readOnly", "server", b"server"]) -> None: ...

global___NFSVolumeSource = NFSVolumeSource

@typing.final
class Namespace(google.protobuf.message.Message):
    """Namespace provides a scope for Names.
    Use of multiple namespaces is optional.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SPEC_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def spec(self) -> global___NamespaceSpec:
        """Spec defines the behavior of the Namespace.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    @property
    def status(self) -> global___NamespaceStatus:
        """Status describes the current status of a Namespace.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        spec: global___NamespaceSpec | None = ...,
        status: global___NamespaceStatus | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> None: ...

global___Namespace = Namespace

@typing.final
class NamespaceCondition(google.protobuf.message.Message):
    """NamespaceCondition contains details about state of namespace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    LASTTRANSITIONTIME_FIELD_NUMBER: builtins.int
    REASON_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    type: builtins.str
    """Type of namespace controller condition."""
    status: builtins.str
    """Status of the condition, one of True, False, Unknown."""
    reason: builtins.str
    """+optional"""
    message: builtins.str
    """+optional"""
    @property
    def lastTransitionTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """+optional"""

    def __init__(
        self,
        *,
        type: builtins.str | None = ...,
        status: builtins.str | None = ...,
        lastTransitionTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        reason: builtins.str | None = ...,
        message: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["lastTransitionTime", b"lastTransitionTime", "message", b"message", "reason", b"reason", "status", b"status", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["lastTransitionTime", b"lastTransitionTime", "message", b"message", "reason", b"reason", "status", b"status", "type", b"type"]) -> None: ...

global___NamespaceCondition = NamespaceCondition

@typing.final
class NamespaceList(google.protobuf.message.Message):
    """NamespaceList is a list of Namespaces."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Namespace]:
        """Items is the list of Namespace objects in the list.
        More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___Namespace] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___NamespaceList = NamespaceList

@typing.final
class NamespaceSpec(google.protobuf.message.Message):
    """NamespaceSpec describes the attributes on a Namespace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FINALIZERS_FIELD_NUMBER: builtins.int
    @property
    def finalizers(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Finalizers is an opaque list of values that must be empty to permanently remove object from storage.
        More info: https://kubernetes.io/docs/tasks/administer-cluster/namespaces/
        +optional
        """

    def __init__(
        self,
        *,
        finalizers: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["finalizers", b"finalizers"]) -> None: ...

global___NamespaceSpec = NamespaceSpec

@typing.final
class NamespaceStatus(google.protobuf.message.Message):
    """NamespaceStatus is information about the current status of a Namespace."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PHASE_FIELD_NUMBER: builtins.int
    CONDITIONS_FIELD_NUMBER: builtins.int
    phase: builtins.str
    """Phase is the current lifecycle phase of the namespace.
    More info: https://kubernetes.io/docs/tasks/administer-cluster/namespaces/
    +optional
    """
    @property
    def conditions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___NamespaceCondition]:
        """Represents the latest available observations of a namespace's current state.
        +optional
        +patchMergeKey=type
        +patchStrategy=merge
        """

    def __init__(
        self,
        *,
        phase: builtins.str | None = ...,
        conditions: collections.abc.Iterable[global___NamespaceCondition] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["phase", b"phase"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["conditions", b"conditions", "phase", b"phase"]) -> None: ...

global___NamespaceStatus = NamespaceStatus

@typing.final
class Node(google.protobuf.message.Message):
    """Node is a worker node in Kubernetes.
    Each node will have a unique identifier in the cache (i.e. in etcd).
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SPEC_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def spec(self) -> global___NodeSpec:
        """Spec defines the behavior of a node.
        https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    @property
    def status(self) -> global___NodeStatus:
        """Most recently observed status of the node.
        Populated by the system.
        Read-only.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        spec: global___NodeSpec | None = ...,
        status: global___NodeStatus | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> None: ...

global___Node = Node

@typing.final
class NodeAddress(google.protobuf.message.Message):
    """NodeAddress contains information for the node's address."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    ADDRESS_FIELD_NUMBER: builtins.int
    type: builtins.str
    """Node address type, one of Hostname, ExternalIP or InternalIP."""
    address: builtins.str
    """The node address."""
    def __init__(
        self,
        *,
        type: builtins.str | None = ...,
        address: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["address", b"address", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["address", b"address", "type", b"type"]) -> None: ...

global___NodeAddress = NodeAddress

@typing.final
class NodeAffinity(google.protobuf.message.Message):
    """Node affinity is a group of node affinity scheduling rules."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REQUIREDDURINGSCHEDULINGIGNOREDDURINGEXECUTION_FIELD_NUMBER: builtins.int
    PREFERREDDURINGSCHEDULINGIGNOREDDURINGEXECUTION_FIELD_NUMBER: builtins.int
    @property
    def requiredDuringSchedulingIgnoredDuringExecution(self) -> global___NodeSelector:
        """If the affinity requirements specified by this field are not met at
        scheduling time, the pod will not be scheduled onto the node.
        If the affinity requirements specified by this field cease to be met
        at some point during pod execution (e.g. due to an update), the system
        may or may not try to eventually evict the pod from its node.
        +optional
        """

    @property
    def preferredDuringSchedulingIgnoredDuringExecution(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PreferredSchedulingTerm]:
        """The scheduler will prefer to schedule pods to nodes that satisfy
        the affinity expressions specified by this field, but it may choose
        a node that violates one or more of the expressions. The node that is
        most preferred is the one with the greatest sum of weights, i.e.
        for each node that meets all of the scheduling requirements (resource
        request, requiredDuringScheduling affinity expressions, etc.),
        compute a sum by iterating through the elements of this field and adding
        "weight" to the sum if the node matches the corresponding matchExpressions; the
        node(s) with the highest sum are the most preferred.
        +optional
        """

    def __init__(
        self,
        *,
        requiredDuringSchedulingIgnoredDuringExecution: global___NodeSelector | None = ...,
        preferredDuringSchedulingIgnoredDuringExecution: collections.abc.Iterable[global___PreferredSchedulingTerm] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["requiredDuringSchedulingIgnoredDuringExecution", b"requiredDuringSchedulingIgnoredDuringExecution"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["preferredDuringSchedulingIgnoredDuringExecution", b"preferredDuringSchedulingIgnoredDuringExecution", "requiredDuringSchedulingIgnoredDuringExecution", b"requiredDuringSchedulingIgnoredDuringExecution"]) -> None: ...

global___NodeAffinity = NodeAffinity

@typing.final
class NodeCondition(google.protobuf.message.Message):
    """NodeCondition contains condition information for a node."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    LASTHEARTBEATTIME_FIELD_NUMBER: builtins.int
    LASTTRANSITIONTIME_FIELD_NUMBER: builtins.int
    REASON_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    type: builtins.str
    """Type of node condition."""
    status: builtins.str
    """Status of the condition, one of True, False, Unknown."""
    reason: builtins.str
    """(brief) reason for the condition's last transition.
    +optional
    """
    message: builtins.str
    """Human readable message indicating details about last transition.
    +optional
    """
    @property
    def lastHeartbeatTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """Last time we got an update on a given condition.
        +optional
        """

    @property
    def lastTransitionTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """Last time the condition transit from one status to another.
        +optional
        """

    def __init__(
        self,
        *,
        type: builtins.str | None = ...,
        status: builtins.str | None = ...,
        lastHeartbeatTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        lastTransitionTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        reason: builtins.str | None = ...,
        message: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["lastHeartbeatTime", b"lastHeartbeatTime", "lastTransitionTime", b"lastTransitionTime", "message", b"message", "reason", b"reason", "status", b"status", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["lastHeartbeatTime", b"lastHeartbeatTime", "lastTransitionTime", b"lastTransitionTime", "message", b"message", "reason", b"reason", "status", b"status", "type", b"type"]) -> None: ...

global___NodeCondition = NodeCondition

@typing.final
class NodeConfigSource(google.protobuf.message.Message):
    """NodeConfigSource specifies a source of node configuration. Exactly one subfield (excluding metadata) must be non-nil.
    This API is deprecated since 1.22
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CONFIGMAP_FIELD_NUMBER: builtins.int
    @property
    def configMap(self) -> global___ConfigMapNodeConfigSource:
        """ConfigMap is a reference to a Node's ConfigMap"""

    def __init__(
        self,
        *,
        configMap: global___ConfigMapNodeConfigSource | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["configMap", b"configMap"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["configMap", b"configMap"]) -> None: ...

global___NodeConfigSource = NodeConfigSource

@typing.final
class NodeConfigStatus(google.protobuf.message.Message):
    """NodeConfigStatus describes the status of the config assigned by Node.Spec.ConfigSource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ASSIGNED_FIELD_NUMBER: builtins.int
    ACTIVE_FIELD_NUMBER: builtins.int
    LASTKNOWNGOOD_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    error: builtins.str
    """Error describes any problems reconciling the Spec.ConfigSource to the Active config.
    Errors may occur, for example, attempting to checkpoint Spec.ConfigSource to the local Assigned
    record, attempting to checkpoint the payload associated with Spec.ConfigSource, attempting
    to load or validate the Assigned config, etc.
    Errors may occur at different points while syncing config. Earlier errors (e.g. download or
    checkpointing errors) will not result in a rollback to LastKnownGood, and may resolve across
    Kubelet retries. Later errors (e.g. loading or validating a checkpointed config) will result in
    a rollback to LastKnownGood. In the latter case, it is usually possible to resolve the error
    by fixing the config assigned in Spec.ConfigSource.
    You can find additional information for debugging by searching the error message in the Kubelet log.
    Error is a human-readable description of the error state; machines can check whether or not Error
    is empty, but should not rely on the stability of the Error text across Kubelet versions.
    +optional
    """
    @property
    def assigned(self) -> global___NodeConfigSource:
        """Assigned reports the checkpointed config the node will try to use.
        When Node.Spec.ConfigSource is updated, the node checkpoints the associated
        config payload to local disk, along with a record indicating intended
        config. The node refers to this record to choose its config checkpoint, and
        reports this record in Assigned. Assigned only updates in the status after
        the record has been checkpointed to disk. When the Kubelet is restarted,
        it tries to make the Assigned config the Active config by loading and
        validating the checkpointed payload identified by Assigned.
        +optional
        """

    @property
    def active(self) -> global___NodeConfigSource:
        """Active reports the checkpointed config the node is actively using.
        Active will represent either the current version of the Assigned config,
        or the current LastKnownGood config, depending on whether attempting to use the
        Assigned config results in an error.
        +optional
        """

    @property
    def lastKnownGood(self) -> global___NodeConfigSource:
        """LastKnownGood reports the checkpointed config the node will fall back to
        when it encounters an error attempting to use the Assigned config.
        The Assigned config becomes the LastKnownGood config when the node determines
        that the Assigned config is stable and correct.
        This is currently implemented as a 10-minute soak period starting when the local
        record of Assigned config is updated. If the Assigned config is Active at the end
        of this period, it becomes the LastKnownGood. Note that if Spec.ConfigSource is
        reset to nil (use local defaults), the LastKnownGood is also immediately reset to nil,
        because the local default config is always assumed good.
        You should not make assumptions about the node's method of determining config stability
        and correctness, as this may change or become configurable in the future.
        +optional
        """

    def __init__(
        self,
        *,
        assigned: global___NodeConfigSource | None = ...,
        active: global___NodeConfigSource | None = ...,
        lastKnownGood: global___NodeConfigSource | None = ...,
        error: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["active", b"active", "assigned", b"assigned", "error", b"error", "lastKnownGood", b"lastKnownGood"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["active", b"active", "assigned", b"assigned", "error", b"error", "lastKnownGood", b"lastKnownGood"]) -> None: ...

global___NodeConfigStatus = NodeConfigStatus

@typing.final
class NodeDaemonEndpoints(google.protobuf.message.Message):
    """NodeDaemonEndpoints lists ports opened by daemons running on the Node."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KUBELETENDPOINT_FIELD_NUMBER: builtins.int
    @property
    def kubeletEndpoint(self) -> global___DaemonEndpoint:
        """Endpoint on which Kubelet is listening.
        +optional
        """

    def __init__(
        self,
        *,
        kubeletEndpoint: global___DaemonEndpoint | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["kubeletEndpoint", b"kubeletEndpoint"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["kubeletEndpoint", b"kubeletEndpoint"]) -> None: ...

global___NodeDaemonEndpoints = NodeDaemonEndpoints

@typing.final
class NodeList(google.protobuf.message.Message):
    """NodeList is the whole list of all Nodes which have been registered with master."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Node]:
        """List of nodes"""

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___Node] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___NodeList = NodeList

@typing.final
class NodeProxyOptions(google.protobuf.message.Message):
    """NodeProxyOptions is the query options to a Node's proxy call."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PATH_FIELD_NUMBER: builtins.int
    path: builtins.str
    """Path is the URL path to use for the current proxy request to node.
    +optional
    """
    def __init__(
        self,
        *,
        path: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["path", b"path"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["path", b"path"]) -> None: ...

global___NodeProxyOptions = NodeProxyOptions

@typing.final
class NodeResources(google.protobuf.message.Message):
    """NodeResources is an object for conveying resource information about a node.
    see https://kubernetes.io/docs/concepts/architecture/nodes/#capacity for more details.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class CapacityEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    CAPACITY_FIELD_NUMBER: builtins.int
    @property
    def capacity(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Capacity represents the available resources of a node"""

    def __init__(
        self,
        *,
        capacity: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["capacity", b"capacity"]) -> None: ...

global___NodeResources = NodeResources

@typing.final
class NodeSelector(google.protobuf.message.Message):
    """A node selector represents the union of the results of one or more label queries
    over a set of nodes; that is, it represents the OR of the selectors represented
    by the node selector terms.
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NODESELECTORTERMS_FIELD_NUMBER: builtins.int
    @property
    def nodeSelectorTerms(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___NodeSelectorTerm]:
        """Required. A list of node selector terms. The terms are ORed."""

    def __init__(
        self,
        *,
        nodeSelectorTerms: collections.abc.Iterable[global___NodeSelectorTerm] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["nodeSelectorTerms", b"nodeSelectorTerms"]) -> None: ...

global___NodeSelector = NodeSelector

@typing.final
class NodeSelectorRequirement(google.protobuf.message.Message):
    """A node selector requirement is a selector that contains values, a key, and an operator
    that relates the key and values.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    OPERATOR_FIELD_NUMBER: builtins.int
    VALUES_FIELD_NUMBER: builtins.int
    key: builtins.str
    """The label key that the selector applies to."""
    operator: builtins.str
    """Represents a key's relationship to a set of values.
    Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.
    """
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """An array of string values. If the operator is In or NotIn,
        the values array must be non-empty. If the operator is Exists or DoesNotExist,
        the values array must be empty. If the operator is Gt or Lt, the values
        array must have a single element, which will be interpreted as an integer.
        This array is replaced during a strategic merge patch.
        +optional
        """

    def __init__(
        self,
        *,
        key: builtins.str | None = ...,
        operator: builtins.str | None = ...,
        values: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "operator", b"operator"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "operator", b"operator", "values", b"values"]) -> None: ...

global___NodeSelectorRequirement = NodeSelectorRequirement

@typing.final
class NodeSelectorTerm(google.protobuf.message.Message):
    """A null or empty node selector term matches no objects. The requirements of
    them are ANDed.
    The TopologySelectorTerm type implements a subset of the NodeSelectorTerm.
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MATCHEXPRESSIONS_FIELD_NUMBER: builtins.int
    MATCHFIELDS_FIELD_NUMBER: builtins.int
    @property
    def matchExpressions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___NodeSelectorRequirement]:
        """A list of node selector requirements by node's labels.
        +optional
        """

    @property
    def matchFields(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___NodeSelectorRequirement]:
        """A list of node selector requirements by node's fields.
        +optional
        """

    def __init__(
        self,
        *,
        matchExpressions: collections.abc.Iterable[global___NodeSelectorRequirement] | None = ...,
        matchFields: collections.abc.Iterable[global___NodeSelectorRequirement] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["matchExpressions", b"matchExpressions", "matchFields", b"matchFields"]) -> None: ...

global___NodeSelectorTerm = NodeSelectorTerm

@typing.final
class NodeSpec(google.protobuf.message.Message):
    """NodeSpec describes the attributes that a node is created with."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PODCIDR_FIELD_NUMBER: builtins.int
    PODCIDRS_FIELD_NUMBER: builtins.int
    PROVIDERID_FIELD_NUMBER: builtins.int
    UNSCHEDULABLE_FIELD_NUMBER: builtins.int
    TAINTS_FIELD_NUMBER: builtins.int
    CONFIGSOURCE_FIELD_NUMBER: builtins.int
    EXTERNALID_FIELD_NUMBER: builtins.int
    podCIDR: builtins.str
    """PodCIDR represents the pod IP range assigned to the node.
    +optional
    """
    providerID: builtins.str
    """ID of the node assigned by the cloud provider in the format: <ProviderName>://<ProviderSpecificNodeID>
    +optional
    """
    unschedulable: builtins.bool
    """Unschedulable controls node schedulability of new pods. By default, node is schedulable.
    More info: https://kubernetes.io/docs/concepts/nodes/node/#manual-node-administration
    +optional
    """
    externalID: builtins.str
    """Deprecated. Not all kubelets will set this field. Remove field after 1.13.
    see: https://issues.k8s.io/61966
    +optional
    """
    @property
    def podCIDRs(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """podCIDRs represents the IP ranges assigned to the node for usage by Pods on that node. If this
        field is specified, the 0th entry must match the podCIDR field. It may contain at most 1 value for
        each of IPv4 and IPv6.
        +optional
        +patchStrategy=merge
        """

    @property
    def taints(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Taint]:
        """If specified, the node's taints.
        +optional
        """

    @property
    def configSource(self) -> global___NodeConfigSource:
        """Deprecated. If specified, the source of the node's configuration.
        The DynamicKubeletConfig feature gate must be enabled for the Kubelet to use this field.
        This field is deprecated as of 1.22: https://git.k8s.io/enhancements/keps/sig-node/281-dynamic-kubelet-configuration
        +optional
        """

    def __init__(
        self,
        *,
        podCIDR: builtins.str | None = ...,
        podCIDRs: collections.abc.Iterable[builtins.str] | None = ...,
        providerID: builtins.str | None = ...,
        unschedulable: builtins.bool | None = ...,
        taints: collections.abc.Iterable[global___Taint] | None = ...,
        configSource: global___NodeConfigSource | None = ...,
        externalID: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["configSource", b"configSource", "externalID", b"externalID", "podCIDR", b"podCIDR", "providerID", b"providerID", "unschedulable", b"unschedulable"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["configSource", b"configSource", "externalID", b"externalID", "podCIDR", b"podCIDR", "podCIDRs", b"podCIDRs", "providerID", b"providerID", "taints", b"taints", "unschedulable", b"unschedulable"]) -> None: ...

global___NodeSpec = NodeSpec

@typing.final
class NodeStatus(google.protobuf.message.Message):
    """NodeStatus is information about the current status of a node."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class CapacityEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    @typing.final
    class AllocatableEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    CAPACITY_FIELD_NUMBER: builtins.int
    ALLOCATABLE_FIELD_NUMBER: builtins.int
    PHASE_FIELD_NUMBER: builtins.int
    CONDITIONS_FIELD_NUMBER: builtins.int
    ADDRESSES_FIELD_NUMBER: builtins.int
    DAEMONENDPOINTS_FIELD_NUMBER: builtins.int
    NODEINFO_FIELD_NUMBER: builtins.int
    IMAGES_FIELD_NUMBER: builtins.int
    VOLUMESINUSE_FIELD_NUMBER: builtins.int
    VOLUMESATTACHED_FIELD_NUMBER: builtins.int
    CONFIG_FIELD_NUMBER: builtins.int
    phase: builtins.str
    """NodePhase is the recently observed lifecycle phase of the node.
    More info: https://kubernetes.io/docs/concepts/nodes/node/#phase
    The field is never populated, and now is deprecated.
    +optional
    """
    @property
    def capacity(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Capacity represents the total resources of a node.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity
        +optional
        """

    @property
    def allocatable(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Allocatable represents the resources of a node that are available for scheduling.
        Defaults to Capacity.
        +optional
        """

    @property
    def conditions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___NodeCondition]:
        """Conditions is an array of current observed node conditions.
        More info: https://kubernetes.io/docs/concepts/nodes/node/#condition
        +optional
        +patchMergeKey=type
        +patchStrategy=merge
        """

    @property
    def addresses(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___NodeAddress]:
        """List of addresses reachable to the node.
        Queried from cloud provider, if available.
        More info: https://kubernetes.io/docs/concepts/nodes/node/#addresses
        Note: This field is declared as mergeable, but the merge key is not sufficiently
        unique, which can cause data corruption when it is merged. Callers should instead
        use a full-replacement patch. See http://pr.k8s.io/79391 for an example.
        +optional
        +patchMergeKey=type
        +patchStrategy=merge
        """

    @property
    def daemonEndpoints(self) -> global___NodeDaemonEndpoints:
        """Endpoints of daemons running on the Node.
        +optional
        """

    @property
    def nodeInfo(self) -> global___NodeSystemInfo:
        """Set of ids/uuids to uniquely identify the node.
        More info: https://kubernetes.io/docs/concepts/nodes/node/#info
        +optional
        """

    @property
    def images(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ContainerImage]:
        """List of container images on this node
        +optional
        """

    @property
    def volumesInUse(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """List of attachable volumes in use (mounted) by the node.
        +optional
        """

    @property
    def volumesAttached(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___AttachedVolume]:
        """List of volumes that are attached to the node.
        +optional
        """

    @property
    def config(self) -> global___NodeConfigStatus:
        """Status of the config assigned to the node via the dynamic Kubelet config feature.
        +optional
        """

    def __init__(
        self,
        *,
        capacity: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        allocatable: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        phase: builtins.str | None = ...,
        conditions: collections.abc.Iterable[global___NodeCondition] | None = ...,
        addresses: collections.abc.Iterable[global___NodeAddress] | None = ...,
        daemonEndpoints: global___NodeDaemonEndpoints | None = ...,
        nodeInfo: global___NodeSystemInfo | None = ...,
        images: collections.abc.Iterable[global___ContainerImage] | None = ...,
        volumesInUse: collections.abc.Iterable[builtins.str] | None = ...,
        volumesAttached: collections.abc.Iterable[global___AttachedVolume] | None = ...,
        config: global___NodeConfigStatus | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["config", b"config", "daemonEndpoints", b"daemonEndpoints", "nodeInfo", b"nodeInfo", "phase", b"phase"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["addresses", b"addresses", "allocatable", b"allocatable", "capacity", b"capacity", "conditions", b"conditions", "config", b"config", "daemonEndpoints", b"daemonEndpoints", "images", b"images", "nodeInfo", b"nodeInfo", "phase", b"phase", "volumesAttached", b"volumesAttached", "volumesInUse", b"volumesInUse"]) -> None: ...

global___NodeStatus = NodeStatus

@typing.final
class NodeSystemInfo(google.protobuf.message.Message):
    """NodeSystemInfo is a set of ids/uuids to uniquely identify the node."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MACHINEID_FIELD_NUMBER: builtins.int
    SYSTEMUUID_FIELD_NUMBER: builtins.int
    BOOTID_FIELD_NUMBER: builtins.int
    KERNELVERSION_FIELD_NUMBER: builtins.int
    OSIMAGE_FIELD_NUMBER: builtins.int
    CONTAINERRUNTIMEVERSION_FIELD_NUMBER: builtins.int
    KUBELETVERSION_FIELD_NUMBER: builtins.int
    KUBEPROXYVERSION_FIELD_NUMBER: builtins.int
    OPERATINGSYSTEM_FIELD_NUMBER: builtins.int
    ARCHITECTURE_FIELD_NUMBER: builtins.int
    machineID: builtins.str
    """MachineID reported by the node. For unique machine identification
    in the cluster this field is preferred. Learn more from man(5)
    machine-id: http://man7.org/linux/man-pages/man5/machine-id.5.html
    """
    systemUUID: builtins.str
    """SystemUUID reported by the node. For unique machine identification
    MachineID is preferred. This field is specific to Red Hat hosts
    https://access.redhat.com/documentation/en-us/red_hat_subscription_management/1/html/rhsm/uuid
    """
    bootID: builtins.str
    """Boot ID reported by the node."""
    kernelVersion: builtins.str
    """Kernel Version reported by the node from 'uname -r' (e.g. 3.16.0-0.bpo.4-amd64)."""
    osImage: builtins.str
    """OS Image reported by the node from /etc/os-release (e.g. Debian GNU/Linux 7 (wheezy))."""
    containerRuntimeVersion: builtins.str
    """ContainerRuntime Version reported by the node through runtime remote API (e.g. docker://1.5.0)."""
    kubeletVersion: builtins.str
    """Kubelet Version reported by the node."""
    kubeProxyVersion: builtins.str
    """KubeProxy Version reported by the node."""
    operatingSystem: builtins.str
    """The Operating System reported by the node"""
    architecture: builtins.str
    """The Architecture reported by the node"""
    def __init__(
        self,
        *,
        machineID: builtins.str | None = ...,
        systemUUID: builtins.str | None = ...,
        bootID: builtins.str | None = ...,
        kernelVersion: builtins.str | None = ...,
        osImage: builtins.str | None = ...,
        containerRuntimeVersion: builtins.str | None = ...,
        kubeletVersion: builtins.str | None = ...,
        kubeProxyVersion: builtins.str | None = ...,
        operatingSystem: builtins.str | None = ...,
        architecture: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["architecture", b"architecture", "bootID", b"bootID", "containerRuntimeVersion", b"containerRuntimeVersion", "kernelVersion", b"kernelVersion", "kubeProxyVersion", b"kubeProxyVersion", "kubeletVersion", b"kubeletVersion", "machineID", b"machineID", "operatingSystem", b"operatingSystem", "osImage", b"osImage", "systemUUID", b"systemUUID"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["architecture", b"architecture", "bootID", b"bootID", "containerRuntimeVersion", b"containerRuntimeVersion", "kernelVersion", b"kernelVersion", "kubeProxyVersion", b"kubeProxyVersion", "kubeletVersion", b"kubeletVersion", "machineID", b"machineID", "operatingSystem", b"operatingSystem", "osImage", b"osImage", "systemUUID", b"systemUUID"]) -> None: ...

global___NodeSystemInfo = NodeSystemInfo

@typing.final
class ObjectFieldSelector(google.protobuf.message.Message):
    """ObjectFieldSelector selects an APIVersioned field of an object.
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    APIVERSION_FIELD_NUMBER: builtins.int
    FIELDPATH_FIELD_NUMBER: builtins.int
    apiVersion: builtins.str
    """Version of the schema the FieldPath is written in terms of, defaults to "v1".
    +optional
    """
    fieldPath: builtins.str
    """Path of the field to select in the specified API version."""
    def __init__(
        self,
        *,
        apiVersion: builtins.str | None = ...,
        fieldPath: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["apiVersion", b"apiVersion", "fieldPath", b"fieldPath"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["apiVersion", b"apiVersion", "fieldPath", b"fieldPath"]) -> None: ...

global___ObjectFieldSelector = ObjectFieldSelector

@typing.final
class ObjectReference(google.protobuf.message.Message):
    """ObjectReference contains enough information to let you inspect or modify the referred object.
    ---
    New uses of this type are discouraged because of difficulty describing its usage when embedded in APIs.
     1. Ignored fields.  It includes many fields which are not generally honored.  For instance, ResourceVersion and FieldPath are both very rarely valid in actual usage.
     2. Invalid usage help.  It is impossible to add specific help for individual usage.  In most embedded usages, there are particular
        restrictions like, "must refer only to types A and B" or "UID not honored" or "name must be restricted".
        Those cannot be well described when embedded.
     3. Inconsistent validation.  Because the usages are different, the validation rules are different by usage, which makes it hard for users to predict what will happen.
     4. The fields are both imprecise and overly precise.  Kind is not a precise mapping to a URL. This can produce ambiguity
        during interpretation and require a REST mapping.  In most cases, the dependency is on the group,resource tuple
        and the version of the actual struct is irrelevant.
     5. We cannot easily change it.  Because this type is embedded in many locations, updates to this type
        will affect numerous schemas.  Don't make new APIs embed an underspecified API type they do not control.
    Instead of using this type, create a locally provided and used type that is well-focused on your reference.
    For example, ServiceReferences for admission registration: https://github.com/kubernetes/api/blob/release-1.17/admissionregistration/v1/types.go#L533 .
    +k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KIND_FIELD_NUMBER: builtins.int
    NAMESPACE_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    UID_FIELD_NUMBER: builtins.int
    APIVERSION_FIELD_NUMBER: builtins.int
    RESOURCEVERSION_FIELD_NUMBER: builtins.int
    FIELDPATH_FIELD_NUMBER: builtins.int
    kind: builtins.str
    """Kind of the referent.
    More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    +optional
    """
    namespace: builtins.str
    """Namespace of the referent.
    More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/
    +optional
    """
    name: builtins.str
    """Name of the referent.
    More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names
    +optional
    """
    uid: builtins.str
    """UID of the referent.
    More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids
    +optional
    """
    apiVersion: builtins.str
    """API version of the referent.
    +optional
    """
    resourceVersion: builtins.str
    """Specific resourceVersion to which this reference is made, if any.
    More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency
    +optional
    """
    fieldPath: builtins.str
    """If referring to a piece of an object instead of an entire object, this string
    should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2].
    For example, if the object reference is to a container within a pod, this would take on a value like:
    "spec.containers{name}" (where "name" refers to the name of the container that triggered
    the event) or if no container name is specified "spec.containers[2]" (container with
    index 2 in this pod). This syntax is chosen only to have some well-defined way of
    referencing a part of an object.
    TODO: this design is not final and this field is subject to change in the future.
    +optional
    """
    def __init__(
        self,
        *,
        kind: builtins.str | None = ...,
        namespace: builtins.str | None = ...,
        name: builtins.str | None = ...,
        uid: builtins.str | None = ...,
        apiVersion: builtins.str | None = ...,
        resourceVersion: builtins.str | None = ...,
        fieldPath: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["apiVersion", b"apiVersion", "fieldPath", b"fieldPath", "kind", b"kind", "name", b"name", "namespace", b"namespace", "resourceVersion", b"resourceVersion", "uid", b"uid"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["apiVersion", b"apiVersion", "fieldPath", b"fieldPath", "kind", b"kind", "name", b"name", "namespace", b"namespace", "resourceVersion", b"resourceVersion", "uid", b"uid"]) -> None: ...

global___ObjectReference = ObjectReference

@typing.final
class PersistentVolume(google.protobuf.message.Message):
    """PersistentVolume (PV) is a storage resource provisioned by an administrator.
    It is analogous to a node.
    More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SPEC_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def spec(self) -> global___PersistentVolumeSpec:
        """Spec defines a specification of a persistent volume owned by the cluster.
        Provisioned by an administrator.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistent-volumes
        +optional
        """

    @property
    def status(self) -> global___PersistentVolumeStatus:
        """Status represents the current information/status for the persistent volume.
        Populated by the system.
        Read-only.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistent-volumes
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        spec: global___PersistentVolumeSpec | None = ...,
        status: global___PersistentVolumeStatus | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> None: ...

global___PersistentVolume = PersistentVolume

@typing.final
class PersistentVolumeClaim(google.protobuf.message.Message):
    """PersistentVolumeClaim is a user's request for and claim to a persistent volume"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SPEC_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def spec(self) -> global___PersistentVolumeClaimSpec:
        """Spec defines the desired characteristics of a volume requested by a pod author.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
        +optional
        """

    @property
    def status(self) -> global___PersistentVolumeClaimStatus:
        """Status represents the current information/status of a persistent volume claim.
        Read-only.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        spec: global___PersistentVolumeClaimSpec | None = ...,
        status: global___PersistentVolumeClaimStatus | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> None: ...

global___PersistentVolumeClaim = PersistentVolumeClaim

@typing.final
class PersistentVolumeClaimCondition(google.protobuf.message.Message):
    """PersistentVolumeClaimCondition contails details about state of pvc"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    LASTPROBETIME_FIELD_NUMBER: builtins.int
    LASTTRANSITIONTIME_FIELD_NUMBER: builtins.int
    REASON_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    type: builtins.str
    status: builtins.str
    reason: builtins.str
    """Unique, this should be a short, machine understandable string that gives the reason
    for condition's last transition. If it reports "ResizeStarted" that means the underlying
    persistent volume is being resized.
    +optional
    """
    message: builtins.str
    """Human-readable message indicating details about last transition.
    +optional
    """
    @property
    def lastProbeTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """Last time we probed the condition.
        +optional
        """

    @property
    def lastTransitionTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """Last time the condition transitioned from one status to another.
        +optional
        """

    def __init__(
        self,
        *,
        type: builtins.str | None = ...,
        status: builtins.str | None = ...,
        lastProbeTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        lastTransitionTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        reason: builtins.str | None = ...,
        message: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["lastProbeTime", b"lastProbeTime", "lastTransitionTime", b"lastTransitionTime", "message", b"message", "reason", b"reason", "status", b"status", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["lastProbeTime", b"lastProbeTime", "lastTransitionTime", b"lastTransitionTime", "message", b"message", "reason", b"reason", "status", b"status", "type", b"type"]) -> None: ...

global___PersistentVolumeClaimCondition = PersistentVolumeClaimCondition

@typing.final
class PersistentVolumeClaimList(google.protobuf.message.Message):
    """PersistentVolumeClaimList is a list of PersistentVolumeClaim items."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PersistentVolumeClaim]:
        """A list of persistent volume claims.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___PersistentVolumeClaim] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___PersistentVolumeClaimList = PersistentVolumeClaimList

@typing.final
class PersistentVolumeClaimSpec(google.protobuf.message.Message):
    """PersistentVolumeClaimSpec describes the common attributes of storage devices
    and allows a Source for provider-specific attributes
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ACCESSMODES_FIELD_NUMBER: builtins.int
    SELECTOR_FIELD_NUMBER: builtins.int
    RESOURCES_FIELD_NUMBER: builtins.int
    VOLUMENAME_FIELD_NUMBER: builtins.int
    STORAGECLASSNAME_FIELD_NUMBER: builtins.int
    VOLUMEMODE_FIELD_NUMBER: builtins.int
    DATASOURCE_FIELD_NUMBER: builtins.int
    DATASOURCEREF_FIELD_NUMBER: builtins.int
    volumeName: builtins.str
    """VolumeName is the binding reference to the PersistentVolume backing this claim.
    +optional
    """
    storageClassName: builtins.str
    """Name of the StorageClass required by the claim.
    More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1
    +optional
    """
    volumeMode: builtins.str
    """volumeMode defines what type of volume is required by the claim.
    Value of Filesystem is implied when not included in claim spec.
    +optional
    """
    @property
    def accessModes(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """AccessModes contains the desired access modes the volume should have.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
        +optional
        """

    @property
    def selector(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.LabelSelector:
        """A label query over volumes to consider for binding.
        +optional
        """

    @property
    def resources(self) -> global___ResourceRequirements:
        """Resources represents the minimum resources the volume should have.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources
        +optional
        """

    @property
    def dataSource(self) -> global___TypedLocalObjectReference:
        """This field can be used to specify either:
        * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot)
        * An existing PVC (PersistentVolumeClaim)
        If the provisioner or an external controller can support the specified data source,
        it will create a new volume based on the contents of the specified data source.
        If the AnyVolumeDataSource feature gate is enabled, this field will always have
        the same contents as the DataSourceRef field.
        +optional
        """

    @property
    def dataSourceRef(self) -> global___TypedLocalObjectReference:
        """Specifies the object from which to populate the volume with data, if a non-empty
        volume is desired. This may be any local object from a non-empty API group (non
        core object) or a PersistentVolumeClaim object.
        When this field is specified, volume binding will only succeed if the type of
        the specified object matches some installed volume populator or dynamic
        provisioner.
        This field will replace the functionality of the DataSource field and as such
        if both fields are non-empty, they must have the same value. For backwards
        compatibility, both fields (DataSource and DataSourceRef) will be set to the same
        value automatically if one of them is empty and the other is non-empty.
        There are two important differences between DataSource and DataSourceRef:
        * While DataSource only allows two specific types of objects, DataSourceRef
          allows any non-core object, as well as PersistentVolumeClaim objects.
        * While DataSource ignores disallowed values (dropping them), DataSourceRef
          preserves all values, and generates an error if a disallowed value is
          specified.
        (Alpha) Using this field requires the AnyVolumeDataSource feature gate to be enabled.
        +optional
        """

    def __init__(
        self,
        *,
        accessModes: collections.abc.Iterable[builtins.str] | None = ...,
        selector: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.LabelSelector | None = ...,
        resources: global___ResourceRequirements | None = ...,
        volumeName: builtins.str | None = ...,
        storageClassName: builtins.str | None = ...,
        volumeMode: builtins.str | None = ...,
        dataSource: global___TypedLocalObjectReference | None = ...,
        dataSourceRef: global___TypedLocalObjectReference | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["dataSource", b"dataSource", "dataSourceRef", b"dataSourceRef", "resources", b"resources", "selector", b"selector", "storageClassName", b"storageClassName", "volumeMode", b"volumeMode", "volumeName", b"volumeName"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["accessModes", b"accessModes", "dataSource", b"dataSource", "dataSourceRef", b"dataSourceRef", "resources", b"resources", "selector", b"selector", "storageClassName", b"storageClassName", "volumeMode", b"volumeMode", "volumeName", b"volumeName"]) -> None: ...

global___PersistentVolumeClaimSpec = PersistentVolumeClaimSpec

@typing.final
class PersistentVolumeClaimStatus(google.protobuf.message.Message):
    """PersistentVolumeClaimStatus is the current status of a persistent volume claim."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class CapacityEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    PHASE_FIELD_NUMBER: builtins.int
    ACCESSMODES_FIELD_NUMBER: builtins.int
    CAPACITY_FIELD_NUMBER: builtins.int
    CONDITIONS_FIELD_NUMBER: builtins.int
    phase: builtins.str
    """Phase represents the current phase of PersistentVolumeClaim.
    +optional
    """
    @property
    def accessModes(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """AccessModes contains the actual access modes the volume backing the PVC has.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1
        +optional
        """

    @property
    def capacity(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Represents the actual resources of the underlying volume.
        +optional
        """

    @property
    def conditions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PersistentVolumeClaimCondition]:
        """Current Condition of persistent volume claim. If underlying persistent volume is being
        resized then the Condition will be set to 'ResizeStarted'.
        +optional
        +patchMergeKey=type
        +patchStrategy=merge
        """

    def __init__(
        self,
        *,
        phase: builtins.str | None = ...,
        accessModes: collections.abc.Iterable[builtins.str] | None = ...,
        capacity: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        conditions: collections.abc.Iterable[global___PersistentVolumeClaimCondition] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["phase", b"phase"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["accessModes", b"accessModes", "capacity", b"capacity", "conditions", b"conditions", "phase", b"phase"]) -> None: ...

global___PersistentVolumeClaimStatus = PersistentVolumeClaimStatus

@typing.final
class PersistentVolumeClaimTemplate(google.protobuf.message.Message):
    """PersistentVolumeClaimTemplate is used to produce
    PersistentVolumeClaim objects as part of an EphemeralVolumeSource.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SPEC_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """May contain labels and annotations that will be copied into the PVC
        when creating it. No other fields are allowed and will be rejected during
        validation.

        +optional
        """

    @property
    def spec(self) -> global___PersistentVolumeClaimSpec:
        """The specification for the PersistentVolumeClaim. The entire content is
        copied unchanged into the PVC that gets created from this
        template. The same fields as in a PersistentVolumeClaim
        are also valid here.
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        spec: global___PersistentVolumeClaimSpec | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec"]) -> None: ...

global___PersistentVolumeClaimTemplate = PersistentVolumeClaimTemplate

@typing.final
class PersistentVolumeClaimVolumeSource(google.protobuf.message.Message):
    """PersistentVolumeClaimVolumeSource references the user's PVC in the same namespace.
    This volume finds the bound PV and mounts that volume for the pod. A
    PersistentVolumeClaimVolumeSource is, essentially, a wrapper around another
    type of volume that is owned by someone else (the system).
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CLAIMNAME_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    claimName: builtins.str
    """ClaimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume.
    More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
    """
    readOnly: builtins.bool
    """Will force the ReadOnly setting in VolumeMounts.
    Default false.
    +optional
    """
    def __init__(
        self,
        *,
        claimName: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["claimName", b"claimName", "readOnly", b"readOnly"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["claimName", b"claimName", "readOnly", b"readOnly"]) -> None: ...

global___PersistentVolumeClaimVolumeSource = PersistentVolumeClaimVolumeSource

@typing.final
class PersistentVolumeList(google.protobuf.message.Message):
    """PersistentVolumeList is a list of PersistentVolume items."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PersistentVolume]:
        """List of persistent volumes.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___PersistentVolume] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___PersistentVolumeList = PersistentVolumeList

@typing.final
class PersistentVolumeSource(google.protobuf.message.Message):
    """PersistentVolumeSource is similar to VolumeSource but meant for the
    administrator who creates PVs. Exactly one of its members must be set.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    GCEPERSISTENTDISK_FIELD_NUMBER: builtins.int
    AWSELASTICBLOCKSTORE_FIELD_NUMBER: builtins.int
    HOSTPATH_FIELD_NUMBER: builtins.int
    GLUSTERFS_FIELD_NUMBER: builtins.int
    NFS_FIELD_NUMBER: builtins.int
    RBD_FIELD_NUMBER: builtins.int
    ISCSI_FIELD_NUMBER: builtins.int
    CINDER_FIELD_NUMBER: builtins.int
    CEPHFS_FIELD_NUMBER: builtins.int
    FC_FIELD_NUMBER: builtins.int
    FLOCKER_FIELD_NUMBER: builtins.int
    FLEXVOLUME_FIELD_NUMBER: builtins.int
    AZUREFILE_FIELD_NUMBER: builtins.int
    VSPHEREVOLUME_FIELD_NUMBER: builtins.int
    QUOBYTE_FIELD_NUMBER: builtins.int
    AZUREDISK_FIELD_NUMBER: builtins.int
    PHOTONPERSISTENTDISK_FIELD_NUMBER: builtins.int
    PORTWORXVOLUME_FIELD_NUMBER: builtins.int
    SCALEIO_FIELD_NUMBER: builtins.int
    LOCAL_FIELD_NUMBER: builtins.int
    STORAGEOS_FIELD_NUMBER: builtins.int
    CSI_FIELD_NUMBER: builtins.int
    @property
    def gcePersistentDisk(self) -> global___GCEPersistentDiskVolumeSource:
        """GCEPersistentDisk represents a GCE Disk resource that is attached to a
        kubelet's host machine and then exposed to the pod. Provisioned by an admin.
        More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
        +optional
        """

    @property
    def awsElasticBlockStore(self) -> global___AWSElasticBlockStoreVolumeSource:
        """AWSElasticBlockStore represents an AWS Disk resource that is attached to a
        kubelet's host machine and then exposed to the pod.
        More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
        +optional
        """

    @property
    def hostPath(self) -> global___HostPathVolumeSource:
        """HostPath represents a directory on the host.
        Provisioned by a developer or tester.
        This is useful for single-node development and testing only!
        On-host storage is not supported in any way and WILL NOT WORK in a multi-node cluster.
        More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath
        +optional
        """

    @property
    def glusterfs(self) -> global___GlusterfsPersistentVolumeSource:
        """Glusterfs represents a Glusterfs volume that is attached to a host and
        exposed to the pod. Provisioned by an admin.
        More info: https://examples.k8s.io/volumes/glusterfs/README.md
        +optional
        """

    @property
    def nfs(self) -> global___NFSVolumeSource:
        """NFS represents an NFS mount on the host. Provisioned by an admin.
        More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
        +optional
        """

    @property
    def rbd(self) -> global___RBDPersistentVolumeSource:
        """RBD represents a Rados Block Device mount on the host that shares a pod's lifetime.
        More info: https://examples.k8s.io/volumes/rbd/README.md
        +optional
        """

    @property
    def iscsi(self) -> global___ISCSIPersistentVolumeSource:
        """ISCSI represents an ISCSI Disk resource that is attached to a
        kubelet's host machine and then exposed to the pod. Provisioned by an admin.
        +optional
        """

    @property
    def cinder(self) -> global___CinderPersistentVolumeSource:
        """Cinder represents a cinder volume attached and mounted on kubelets host machine.
        More info: https://examples.k8s.io/mysql-cinder-pd/README.md
        +optional
        """

    @property
    def cephfs(self) -> global___CephFSPersistentVolumeSource:
        """CephFS represents a Ceph FS mount on the host that shares a pod's lifetime
        +optional
        """

    @property
    def fc(self) -> global___FCVolumeSource:
        """FC represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.
        +optional
        """

    @property
    def flocker(self) -> global___FlockerVolumeSource:
        """Flocker represents a Flocker volume attached to a kubelet's host machine and exposed to the pod for its usage. This depends on the Flocker control service being running
        +optional
        """

    @property
    def flexVolume(self) -> global___FlexPersistentVolumeSource:
        """FlexVolume represents a generic volume resource that is
        provisioned/attached using an exec based plugin.
        +optional
        """

    @property
    def azureFile(self) -> global___AzureFilePersistentVolumeSource:
        """AzureFile represents an Azure File Service mount on the host and bind mount to the pod.
        +optional
        """

    @property
    def vsphereVolume(self) -> global___VsphereVirtualDiskVolumeSource:
        """VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine
        +optional
        """

    @property
    def quobyte(self) -> global___QuobyteVolumeSource:
        """Quobyte represents a Quobyte mount on the host that shares a pod's lifetime
        +optional
        """

    @property
    def azureDisk(self) -> global___AzureDiskVolumeSource:
        """AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.
        +optional
        """

    @property
    def photonPersistentDisk(self) -> global___PhotonPersistentDiskVolumeSource:
        """PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine"""

    @property
    def portworxVolume(self) -> global___PortworxVolumeSource:
        """PortworxVolume represents a portworx volume attached and mounted on kubelets host machine
        +optional
        """

    @property
    def scaleIO(self) -> global___ScaleIOPersistentVolumeSource:
        """ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.
        +optional
        """

    @property
    def local(self) -> global___LocalVolumeSource:
        """Local represents directly-attached storage with node affinity
        +optional
        """

    @property
    def storageos(self) -> global___StorageOSPersistentVolumeSource:
        """StorageOS represents a StorageOS volume that is attached to the kubelet's host machine and mounted into the pod
        More info: https://examples.k8s.io/volumes/storageos/README.md
        +optional
        """

    @property
    def csi(self) -> global___CSIPersistentVolumeSource:
        """CSI represents storage that is handled by an external CSI driver (Beta feature).
        +optional
        """

    def __init__(
        self,
        *,
        gcePersistentDisk: global___GCEPersistentDiskVolumeSource | None = ...,
        awsElasticBlockStore: global___AWSElasticBlockStoreVolumeSource | None = ...,
        hostPath: global___HostPathVolumeSource | None = ...,
        glusterfs: global___GlusterfsPersistentVolumeSource | None = ...,
        nfs: global___NFSVolumeSource | None = ...,
        rbd: global___RBDPersistentVolumeSource | None = ...,
        iscsi: global___ISCSIPersistentVolumeSource | None = ...,
        cinder: global___CinderPersistentVolumeSource | None = ...,
        cephfs: global___CephFSPersistentVolumeSource | None = ...,
        fc: global___FCVolumeSource | None = ...,
        flocker: global___FlockerVolumeSource | None = ...,
        flexVolume: global___FlexPersistentVolumeSource | None = ...,
        azureFile: global___AzureFilePersistentVolumeSource | None = ...,
        vsphereVolume: global___VsphereVirtualDiskVolumeSource | None = ...,
        quobyte: global___QuobyteVolumeSource | None = ...,
        azureDisk: global___AzureDiskVolumeSource | None = ...,
        photonPersistentDisk: global___PhotonPersistentDiskVolumeSource | None = ...,
        portworxVolume: global___PortworxVolumeSource | None = ...,
        scaleIO: global___ScaleIOPersistentVolumeSource | None = ...,
        local: global___LocalVolumeSource | None = ...,
        storageos: global___StorageOSPersistentVolumeSource | None = ...,
        csi: global___CSIPersistentVolumeSource | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["awsElasticBlockStore", b"awsElasticBlockStore", "azureDisk", b"azureDisk", "azureFile", b"azureFile", "cephfs", b"cephfs", "cinder", b"cinder", "csi", b"csi", "fc", b"fc", "flexVolume", b"flexVolume", "flocker", b"flocker", "gcePersistentDisk", b"gcePersistentDisk", "glusterfs", b"glusterfs", "hostPath", b"hostPath", "iscsi", b"iscsi", "local", b"local", "nfs", b"nfs", "photonPersistentDisk", b"photonPersistentDisk", "portworxVolume", b"portworxVolume", "quobyte", b"quobyte", "rbd", b"rbd", "scaleIO", b"scaleIO", "storageos", b"storageos", "vsphereVolume", b"vsphereVolume"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["awsElasticBlockStore", b"awsElasticBlockStore", "azureDisk", b"azureDisk", "azureFile", b"azureFile", "cephfs", b"cephfs", "cinder", b"cinder", "csi", b"csi", "fc", b"fc", "flexVolume", b"flexVolume", "flocker", b"flocker", "gcePersistentDisk", b"gcePersistentDisk", "glusterfs", b"glusterfs", "hostPath", b"hostPath", "iscsi", b"iscsi", "local", b"local", "nfs", b"nfs", "photonPersistentDisk", b"photonPersistentDisk", "portworxVolume", b"portworxVolume", "quobyte", b"quobyte", "rbd", b"rbd", "scaleIO", b"scaleIO", "storageos", b"storageos", "vsphereVolume", b"vsphereVolume"]) -> None: ...

global___PersistentVolumeSource = PersistentVolumeSource

@typing.final
class PersistentVolumeSpec(google.protobuf.message.Message):
    """PersistentVolumeSpec is the specification of a persistent volume."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class CapacityEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    CAPACITY_FIELD_NUMBER: builtins.int
    PERSISTENTVOLUMESOURCE_FIELD_NUMBER: builtins.int
    ACCESSMODES_FIELD_NUMBER: builtins.int
    CLAIMREF_FIELD_NUMBER: builtins.int
    PERSISTENTVOLUMERECLAIMPOLICY_FIELD_NUMBER: builtins.int
    STORAGECLASSNAME_FIELD_NUMBER: builtins.int
    MOUNTOPTIONS_FIELD_NUMBER: builtins.int
    VOLUMEMODE_FIELD_NUMBER: builtins.int
    NODEAFFINITY_FIELD_NUMBER: builtins.int
    persistentVolumeReclaimPolicy: builtins.str
    """What happens to a persistent volume when released from its claim.
    Valid options are Retain (default for manually created PersistentVolumes), Delete (default
    for dynamically provisioned PersistentVolumes), and Recycle (deprecated).
    Recycle must be supported by the volume plugin underlying this PersistentVolume.
    More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming
    +optional
    """
    storageClassName: builtins.str
    """Name of StorageClass to which this persistent volume belongs. Empty value
    means that this volume does not belong to any StorageClass.
    +optional
    """
    volumeMode: builtins.str
    """volumeMode defines if a volume is intended to be used with a formatted filesystem
    or to remain in raw block state. Value of Filesystem is implied when not included in spec.
    +optional
    """
    @property
    def capacity(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """A description of the persistent volume's resources and capacity.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity
        +optional
        """

    @property
    def persistentVolumeSource(self) -> global___PersistentVolumeSource:
        """The actual volume backing the persistent volume."""

    @property
    def accessModes(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """AccessModes contains all ways the volume can be mounted.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes
        +optional
        """

    @property
    def claimRef(self) -> global___ObjectReference:
        """ClaimRef is part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.
        Expected to be non-nil when bound.
        claim.VolumeName is the authoritative bind between PV and PVC.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding
        +optional
        """

    @property
    def mountOptions(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will
        simply fail if one is invalid.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options
        +optional
        """

    @property
    def nodeAffinity(self) -> global___VolumeNodeAffinity:
        """NodeAffinity defines constraints that limit what nodes this volume can be accessed from.
        This field influences the scheduling of pods that use this volume.
        +optional
        """

    def __init__(
        self,
        *,
        capacity: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        persistentVolumeSource: global___PersistentVolumeSource | None = ...,
        accessModes: collections.abc.Iterable[builtins.str] | None = ...,
        claimRef: global___ObjectReference | None = ...,
        persistentVolumeReclaimPolicy: builtins.str | None = ...,
        storageClassName: builtins.str | None = ...,
        mountOptions: collections.abc.Iterable[builtins.str] | None = ...,
        volumeMode: builtins.str | None = ...,
        nodeAffinity: global___VolumeNodeAffinity | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["claimRef", b"claimRef", "nodeAffinity", b"nodeAffinity", "persistentVolumeReclaimPolicy", b"persistentVolumeReclaimPolicy", "persistentVolumeSource", b"persistentVolumeSource", "storageClassName", b"storageClassName", "volumeMode", b"volumeMode"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["accessModes", b"accessModes", "capacity", b"capacity", "claimRef", b"claimRef", "mountOptions", b"mountOptions", "nodeAffinity", b"nodeAffinity", "persistentVolumeReclaimPolicy", b"persistentVolumeReclaimPolicy", "persistentVolumeSource", b"persistentVolumeSource", "storageClassName", b"storageClassName", "volumeMode", b"volumeMode"]) -> None: ...

global___PersistentVolumeSpec = PersistentVolumeSpec

@typing.final
class PersistentVolumeStatus(google.protobuf.message.Message):
    """PersistentVolumeStatus is the current status of a persistent volume."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PHASE_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    REASON_FIELD_NUMBER: builtins.int
    phase: builtins.str
    """Phase indicates if a volume is available, bound to a claim, or released by a claim.
    More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#phase
    +optional
    """
    message: builtins.str
    """A human-readable message indicating details about why the volume is in this state.
    +optional
    """
    reason: builtins.str
    """Reason is a brief CamelCase string that describes any failure and is meant
    for machine parsing and tidy display in the CLI.
    +optional
    """
    def __init__(
        self,
        *,
        phase: builtins.str | None = ...,
        message: builtins.str | None = ...,
        reason: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["message", b"message", "phase", b"phase", "reason", b"reason"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["message", b"message", "phase", b"phase", "reason", b"reason"]) -> None: ...

global___PersistentVolumeStatus = PersistentVolumeStatus

@typing.final
class PhotonPersistentDiskVolumeSource(google.protobuf.message.Message):
    """Represents a Photon Controller persistent disk resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PDID_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    pdID: builtins.str
    """ID that identifies Photon Controller persistent disk"""
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    """
    def __init__(
        self,
        *,
        pdID: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "pdID", b"pdID"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "pdID", b"pdID"]) -> None: ...

global___PhotonPersistentDiskVolumeSource = PhotonPersistentDiskVolumeSource

@typing.final
class Pod(google.protobuf.message.Message):
    """Pod is a collection of containers that can run on a host. This resource is created
    by clients and scheduled onto hosts.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SPEC_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def spec(self) -> global___PodSpec:
        """Specification of the desired behavior of the pod.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    @property
    def status(self) -> global___PodStatus:
        """Most recently observed status of the pod.
        This data may not be up to date.
        Populated by the system.
        Read-only.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        spec: global___PodSpec | None = ...,
        status: global___PodStatus | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> None: ...

global___Pod = Pod

@typing.final
class PodAffinity(google.protobuf.message.Message):
    """Pod affinity is a group of inter pod affinity scheduling rules."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REQUIREDDURINGSCHEDULINGIGNOREDDURINGEXECUTION_FIELD_NUMBER: builtins.int
    PREFERREDDURINGSCHEDULINGIGNOREDDURINGEXECUTION_FIELD_NUMBER: builtins.int
    @property
    def requiredDuringSchedulingIgnoredDuringExecution(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PodAffinityTerm]:
        """If the affinity requirements specified by this field are not met at
        scheduling time, the pod will not be scheduled onto the node.
        If the affinity requirements specified by this field cease to be met
        at some point during pod execution (e.g. due to a pod label update), the
        system may or may not try to eventually evict the pod from its node.
        When there are multiple elements, the lists of nodes corresponding to each
        podAffinityTerm are intersected, i.e. all terms must be satisfied.
        +optional
        """

    @property
    def preferredDuringSchedulingIgnoredDuringExecution(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___WeightedPodAffinityTerm]:
        """The scheduler will prefer to schedule pods to nodes that satisfy
        the affinity expressions specified by this field, but it may choose
        a node that violates one or more of the expressions. The node that is
        most preferred is the one with the greatest sum of weights, i.e.
        for each node that meets all of the scheduling requirements (resource
        request, requiredDuringScheduling affinity expressions, etc.),
        compute a sum by iterating through the elements of this field and adding
        "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the
        node(s) with the highest sum are the most preferred.
        +optional
        """

    def __init__(
        self,
        *,
        requiredDuringSchedulingIgnoredDuringExecution: collections.abc.Iterable[global___PodAffinityTerm] | None = ...,
        preferredDuringSchedulingIgnoredDuringExecution: collections.abc.Iterable[global___WeightedPodAffinityTerm] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["preferredDuringSchedulingIgnoredDuringExecution", b"preferredDuringSchedulingIgnoredDuringExecution", "requiredDuringSchedulingIgnoredDuringExecution", b"requiredDuringSchedulingIgnoredDuringExecution"]) -> None: ...

global___PodAffinity = PodAffinity

@typing.final
class PodAffinityTerm(google.protobuf.message.Message):
    """Defines a set of pods (namely those matching the labelSelector
    relative to the given namespace(s)) that this pod should be
    co-located (affinity) or not co-located (anti-affinity) with,
    where co-located is defined as running on a node whose value of
    the label with key <topologyKey> matches that of any node on which
    a pod of the set of pods is running
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LABELSELECTOR_FIELD_NUMBER: builtins.int
    NAMESPACES_FIELD_NUMBER: builtins.int
    TOPOLOGYKEY_FIELD_NUMBER: builtins.int
    NAMESPACESELECTOR_FIELD_NUMBER: builtins.int
    topologyKey: builtins.str
    """This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching
    the labelSelector in the specified namespaces, where co-located is defined as running on a node
    whose value of the label with key topologyKey matches that of any node on which any of the
    selected pods is running.
    Empty topologyKey is not allowed.
    """
    @property
    def labelSelector(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.LabelSelector:
        """A label query over a set of resources, in this case pods.
        +optional
        """

    @property
    def namespaces(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """namespaces specifies a static list of namespace names that the term applies to.
        The term is applied to the union of the namespaces listed in this field
        and the ones selected by namespaceSelector.
        null or empty namespaces list and null namespaceSelector means "this pod's namespace"
        +optional
        """

    @property
    def namespaceSelector(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.LabelSelector:
        """A label query over the set of namespaces that the term applies to.
        The term is applied to the union of the namespaces selected by this field
        and the ones listed in the namespaces field.
        null selector and null or empty namespaces list means "this pod's namespace".
        An empty selector ({}) matches all namespaces.
        This field is beta-level and is only honored when PodAffinityNamespaceSelector feature is enabled.
        +optional
        """

    def __init__(
        self,
        *,
        labelSelector: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.LabelSelector | None = ...,
        namespaces: collections.abc.Iterable[builtins.str] | None = ...,
        topologyKey: builtins.str | None = ...,
        namespaceSelector: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.LabelSelector | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["labelSelector", b"labelSelector", "namespaceSelector", b"namespaceSelector", "topologyKey", b"topologyKey"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["labelSelector", b"labelSelector", "namespaceSelector", b"namespaceSelector", "namespaces", b"namespaces", "topologyKey", b"topologyKey"]) -> None: ...

global___PodAffinityTerm = PodAffinityTerm

@typing.final
class PodAntiAffinity(google.protobuf.message.Message):
    """Pod anti affinity is a group of inter pod anti affinity scheduling rules."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REQUIREDDURINGSCHEDULINGIGNOREDDURINGEXECUTION_FIELD_NUMBER: builtins.int
    PREFERREDDURINGSCHEDULINGIGNOREDDURINGEXECUTION_FIELD_NUMBER: builtins.int
    @property
    def requiredDuringSchedulingIgnoredDuringExecution(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PodAffinityTerm]:
        """If the anti-affinity requirements specified by this field are not met at
        scheduling time, the pod will not be scheduled onto the node.
        If the anti-affinity requirements specified by this field cease to be met
        at some point during pod execution (e.g. due to a pod label update), the
        system may or may not try to eventually evict the pod from its node.
        When there are multiple elements, the lists of nodes corresponding to each
        podAffinityTerm are intersected, i.e. all terms must be satisfied.
        +optional
        """

    @property
    def preferredDuringSchedulingIgnoredDuringExecution(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___WeightedPodAffinityTerm]:
        """The scheduler will prefer to schedule pods to nodes that satisfy
        the anti-affinity expressions specified by this field, but it may choose
        a node that violates one or more of the expressions. The node that is
        most preferred is the one with the greatest sum of weights, i.e.
        for each node that meets all of the scheduling requirements (resource
        request, requiredDuringScheduling anti-affinity expressions, etc.),
        compute a sum by iterating through the elements of this field and adding
        "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the
        node(s) with the highest sum are the most preferred.
        +optional
        """

    def __init__(
        self,
        *,
        requiredDuringSchedulingIgnoredDuringExecution: collections.abc.Iterable[global___PodAffinityTerm] | None = ...,
        preferredDuringSchedulingIgnoredDuringExecution: collections.abc.Iterable[global___WeightedPodAffinityTerm] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["preferredDuringSchedulingIgnoredDuringExecution", b"preferredDuringSchedulingIgnoredDuringExecution", "requiredDuringSchedulingIgnoredDuringExecution", b"requiredDuringSchedulingIgnoredDuringExecution"]) -> None: ...

global___PodAntiAffinity = PodAntiAffinity

@typing.final
class PodAttachOptions(google.protobuf.message.Message):
    """PodAttachOptions is the query options to a Pod's remote attach call.
    ---
    TODO: merge w/ PodExecOptions below for stdin, stdout, etc
    and also when we cut V2, we should export a "StreamOptions" or somesuch that contains Stdin, Stdout, Stder and TTY
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    STDIN_FIELD_NUMBER: builtins.int
    STDOUT_FIELD_NUMBER: builtins.int
    STDERR_FIELD_NUMBER: builtins.int
    TTY_FIELD_NUMBER: builtins.int
    CONTAINER_FIELD_NUMBER: builtins.int
    stdin: builtins.bool
    """Stdin if true, redirects the standard input stream of the pod for this call.
    Defaults to false.
    +optional
    """
    stdout: builtins.bool
    """Stdout if true indicates that stdout is to be redirected for the attach call.
    Defaults to true.
    +optional
    """
    stderr: builtins.bool
    """Stderr if true indicates that stderr is to be redirected for the attach call.
    Defaults to true.
    +optional
    """
    tty: builtins.bool
    """TTY if true indicates that a tty will be allocated for the attach call.
    This is passed through the container runtime so the tty
    is allocated on the worker node by the container runtime.
    Defaults to false.
    +optional
    """
    container: builtins.str
    """The container in which to execute the command.
    Defaults to only container if there is only one container in the pod.
    +optional
    """
    def __init__(
        self,
        *,
        stdin: builtins.bool | None = ...,
        stdout: builtins.bool | None = ...,
        stderr: builtins.bool | None = ...,
        tty: builtins.bool | None = ...,
        container: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["container", b"container", "stderr", b"stderr", "stdin", b"stdin", "stdout", b"stdout", "tty", b"tty"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["container", b"container", "stderr", b"stderr", "stdin", b"stdin", "stdout", b"stdout", "tty", b"tty"]) -> None: ...

global___PodAttachOptions = PodAttachOptions

@typing.final
class PodCondition(google.protobuf.message.Message):
    """PodCondition contains details for the current condition of this pod."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    LASTPROBETIME_FIELD_NUMBER: builtins.int
    LASTTRANSITIONTIME_FIELD_NUMBER: builtins.int
    REASON_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    type: builtins.str
    """Type is the type of the condition.
    More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions
    """
    status: builtins.str
    """Status is the status of the condition.
    Can be True, False, Unknown.
    More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions
    """
    reason: builtins.str
    """Unique, one-word, CamelCase reason for the condition's last transition.
    +optional
    """
    message: builtins.str
    """Human-readable message indicating details about last transition.
    +optional
    """
    @property
    def lastProbeTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """Last time we probed the condition.
        +optional
        """

    @property
    def lastTransitionTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """Last time the condition transitioned from one status to another.
        +optional
        """

    def __init__(
        self,
        *,
        type: builtins.str | None = ...,
        status: builtins.str | None = ...,
        lastProbeTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        lastTransitionTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        reason: builtins.str | None = ...,
        message: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["lastProbeTime", b"lastProbeTime", "lastTransitionTime", b"lastTransitionTime", "message", b"message", "reason", b"reason", "status", b"status", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["lastProbeTime", b"lastProbeTime", "lastTransitionTime", b"lastTransitionTime", "message", b"message", "reason", b"reason", "status", b"status", "type", b"type"]) -> None: ...

global___PodCondition = PodCondition

@typing.final
class PodDNSConfig(google.protobuf.message.Message):
    """PodDNSConfig defines the DNS parameters of a pod in addition to
    those generated from DNSPolicy.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAMESERVERS_FIELD_NUMBER: builtins.int
    SEARCHES_FIELD_NUMBER: builtins.int
    OPTIONS_FIELD_NUMBER: builtins.int
    @property
    def nameservers(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """A list of DNS name server IP addresses.
        This will be appended to the base nameservers generated from DNSPolicy.
        Duplicated nameservers will be removed.
        +optional
        """

    @property
    def searches(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """A list of DNS search domains for host-name lookup.
        This will be appended to the base search paths generated from DNSPolicy.
        Duplicated search paths will be removed.
        +optional
        """

    @property
    def options(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PodDNSConfigOption]:
        """A list of DNS resolver options.
        This will be merged with the base options generated from DNSPolicy.
        Duplicated entries will be removed. Resolution options given in Options
        will override those that appear in the base DNSPolicy.
        +optional
        """

    def __init__(
        self,
        *,
        nameservers: collections.abc.Iterable[builtins.str] | None = ...,
        searches: collections.abc.Iterable[builtins.str] | None = ...,
        options: collections.abc.Iterable[global___PodDNSConfigOption] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["nameservers", b"nameservers", "options", b"options", "searches", b"searches"]) -> None: ...

global___PodDNSConfig = PodDNSConfig

@typing.final
class PodDNSConfigOption(google.protobuf.message.Message):
    """PodDNSConfigOption defines DNS resolver options of a pod."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    VALUE_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required."""
    value: builtins.str
    """+optional"""
    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        value: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["name", b"name", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "value", b"value"]) -> None: ...

global___PodDNSConfigOption = PodDNSConfigOption

@typing.final
class PodExecOptions(google.protobuf.message.Message):
    """PodExecOptions is the query options to a Pod's remote exec call.
    ---
    TODO: This is largely identical to PodAttachOptions above, make sure they stay in sync and see about merging
    and also when we cut V2, we should export a "StreamOptions" or somesuch that contains Stdin, Stdout, Stder and TTY
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    STDIN_FIELD_NUMBER: builtins.int
    STDOUT_FIELD_NUMBER: builtins.int
    STDERR_FIELD_NUMBER: builtins.int
    TTY_FIELD_NUMBER: builtins.int
    CONTAINER_FIELD_NUMBER: builtins.int
    COMMAND_FIELD_NUMBER: builtins.int
    stdin: builtins.bool
    """Redirect the standard input stream of the pod for this call.
    Defaults to false.
    +optional
    """
    stdout: builtins.bool
    """Redirect the standard output stream of the pod for this call.
    Defaults to true.
    +optional
    """
    stderr: builtins.bool
    """Redirect the standard error stream of the pod for this call.
    Defaults to true.
    +optional
    """
    tty: builtins.bool
    """TTY if true indicates that a tty will be allocated for the exec call.
    Defaults to false.
    +optional
    """
    container: builtins.str
    """Container in which to execute the command.
    Defaults to only container if there is only one container in the pod.
    +optional
    """
    @property
    def command(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Command is the remote command to execute. argv array. Not executed within a shell."""

    def __init__(
        self,
        *,
        stdin: builtins.bool | None = ...,
        stdout: builtins.bool | None = ...,
        stderr: builtins.bool | None = ...,
        tty: builtins.bool | None = ...,
        container: builtins.str | None = ...,
        command: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["container", b"container", "stderr", b"stderr", "stdin", b"stdin", "stdout", b"stdout", "tty", b"tty"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["command", b"command", "container", b"container", "stderr", b"stderr", "stdin", b"stdin", "stdout", b"stdout", "tty", b"tty"]) -> None: ...

global___PodExecOptions = PodExecOptions

@typing.final
class PodIP(google.protobuf.message.Message):
    """IP address information for entries in the (plural) PodIPs field.
    Each entry includes:
       IP: An IP address allocated to the pod. Routable at least within the cluster.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    IP_FIELD_NUMBER: builtins.int
    ip: builtins.str
    """ip is an IP address (IPv4 or IPv6) assigned to the pod"""
    def __init__(
        self,
        *,
        ip: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["ip", b"ip"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["ip", b"ip"]) -> None: ...

global___PodIP = PodIP

@typing.final
class PodList(google.protobuf.message.Message):
    """PodList is a list of Pods."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Pod]:
        """List of pods.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___Pod] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___PodList = PodList

@typing.final
class PodLogOptions(google.protobuf.message.Message):
    """PodLogOptions is the query options for a Pod's logs REST call."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CONTAINER_FIELD_NUMBER: builtins.int
    FOLLOW_FIELD_NUMBER: builtins.int
    PREVIOUS_FIELD_NUMBER: builtins.int
    SINCESECONDS_FIELD_NUMBER: builtins.int
    SINCETIME_FIELD_NUMBER: builtins.int
    TIMESTAMPS_FIELD_NUMBER: builtins.int
    TAILLINES_FIELD_NUMBER: builtins.int
    LIMITBYTES_FIELD_NUMBER: builtins.int
    INSECURESKIPTLSVERIFYBACKEND_FIELD_NUMBER: builtins.int
    container: builtins.str
    """The container for which to stream logs. Defaults to only container if there is one container in the pod.
    +optional
    """
    follow: builtins.bool
    """Follow the log stream of the pod. Defaults to false.
    +optional
    """
    previous: builtins.bool
    """Return previous terminated container logs. Defaults to false.
    +optional
    """
    sinceSeconds: builtins.int
    """A relative time in seconds before the current time from which to show logs. If this value
    precedes the time a pod was started, only logs since the pod start will be returned.
    If this value is in the future, no logs will be returned.
    Only one of sinceSeconds or sinceTime may be specified.
    +optional
    """
    timestamps: builtins.bool
    """If true, add an RFC3339 or RFC3339Nano timestamp at the beginning of every line
    of log output. Defaults to false.
    +optional
    """
    tailLines: builtins.int
    """If set, the number of lines from the end of the logs to show. If not specified,
    logs are shown from the creation of the container or sinceSeconds or sinceTime
    +optional
    """
    limitBytes: builtins.int
    """If set, the number of bytes to read from the server before terminating the
    log output. This may not display a complete final line of logging, and may return
    slightly more or slightly less than the specified limit.
    +optional
    """
    insecureSkipTLSVerifyBackend: builtins.bool
    """insecureSkipTLSVerifyBackend indicates that the apiserver should not confirm the validity of the
    serving certificate of the backend it is connecting to.  This will make the HTTPS connection between the apiserver
    and the backend insecure. This means the apiserver cannot verify the log data it is receiving came from the real
    kubelet.  If the kubelet is configured to verify the apiserver's TLS credentials, it does not mean the
    connection to the real kubelet is vulnerable to a man in the middle attack (e.g. an attacker could not intercept
    the actual log data coming from the real kubelet).
    +optional
    """
    @property
    def sinceTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """An RFC3339 timestamp from which to show logs. If this value
        precedes the time a pod was started, only logs since the pod start will be returned.
        If this value is in the future, no logs will be returned.
        Only one of sinceSeconds or sinceTime may be specified.
        +optional
        """

    def __init__(
        self,
        *,
        container: builtins.str | None = ...,
        follow: builtins.bool | None = ...,
        previous: builtins.bool | None = ...,
        sinceSeconds: builtins.int | None = ...,
        sinceTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        timestamps: builtins.bool | None = ...,
        tailLines: builtins.int | None = ...,
        limitBytes: builtins.int | None = ...,
        insecureSkipTLSVerifyBackend: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["container", b"container", "follow", b"follow", "insecureSkipTLSVerifyBackend", b"insecureSkipTLSVerifyBackend", "limitBytes", b"limitBytes", "previous", b"previous", "sinceSeconds", b"sinceSeconds", "sinceTime", b"sinceTime", "tailLines", b"tailLines", "timestamps", b"timestamps"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["container", b"container", "follow", b"follow", "insecureSkipTLSVerifyBackend", b"insecureSkipTLSVerifyBackend", "limitBytes", b"limitBytes", "previous", b"previous", "sinceSeconds", b"sinceSeconds", "sinceTime", b"sinceTime", "tailLines", b"tailLines", "timestamps", b"timestamps"]) -> None: ...

global___PodLogOptions = PodLogOptions

@typing.final
class PodPortForwardOptions(google.protobuf.message.Message):
    """PodPortForwardOptions is the query options to a Pod's port forward call
    when using WebSockets.
    The `port` query parameter must specify the port or
    ports (comma separated) to forward over.
    Port forwarding over SPDY does not use these options. It requires the port
    to be passed in the `port` header as part of request.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PORTS_FIELD_NUMBER: builtins.int
    @property
    def ports(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.int]:
        """List of ports to forward
        Required when using WebSockets
        +optional
        """

    def __init__(
        self,
        *,
        ports: collections.abc.Iterable[builtins.int] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["ports", b"ports"]) -> None: ...

global___PodPortForwardOptions = PodPortForwardOptions

@typing.final
class PodProxyOptions(google.protobuf.message.Message):
    """PodProxyOptions is the query options to a Pod's proxy call."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PATH_FIELD_NUMBER: builtins.int
    path: builtins.str
    """Path is the URL path to use for the current proxy request to pod.
    +optional
    """
    def __init__(
        self,
        *,
        path: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["path", b"path"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["path", b"path"]) -> None: ...

global___PodProxyOptions = PodProxyOptions

@typing.final
class PodReadinessGate(google.protobuf.message.Message):
    """PodReadinessGate contains the reference to a pod condition"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CONDITIONTYPE_FIELD_NUMBER: builtins.int
    conditionType: builtins.str
    """ConditionType refers to a condition in the pod's condition list with matching type."""
    def __init__(
        self,
        *,
        conditionType: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["conditionType", b"conditionType"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["conditionType", b"conditionType"]) -> None: ...

global___PodReadinessGate = PodReadinessGate

@typing.final
class PodSecurityContext(google.protobuf.message.Message):
    """PodSecurityContext holds pod-level security attributes and common container settings.
    Some fields are also present in container.securityContext.  Field values of
    container.securityContext take precedence over field values of PodSecurityContext.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SELINUXOPTIONS_FIELD_NUMBER: builtins.int
    WINDOWSOPTIONS_FIELD_NUMBER: builtins.int
    RUNASUSER_FIELD_NUMBER: builtins.int
    RUNASGROUP_FIELD_NUMBER: builtins.int
    RUNASNONROOT_FIELD_NUMBER: builtins.int
    SUPPLEMENTALGROUPS_FIELD_NUMBER: builtins.int
    FSGROUP_FIELD_NUMBER: builtins.int
    SYSCTLS_FIELD_NUMBER: builtins.int
    FSGROUPCHANGEPOLICY_FIELD_NUMBER: builtins.int
    SECCOMPPROFILE_FIELD_NUMBER: builtins.int
    runAsUser: builtins.int
    """The UID to run the entrypoint of the container process.
    Defaults to user specified in image metadata if unspecified.
    May also be set in SecurityContext.  If set in both SecurityContext and
    PodSecurityContext, the value specified in SecurityContext takes precedence
    for that container.
    +optional
    """
    runAsGroup: builtins.int
    """The GID to run the entrypoint of the container process.
    Uses runtime default if unset.
    May also be set in SecurityContext.  If set in both SecurityContext and
    PodSecurityContext, the value specified in SecurityContext takes precedence
    for that container.
    +optional
    """
    runAsNonRoot: builtins.bool
    """Indicates that the container must run as a non-root user.
    If true, the Kubelet will validate the image at runtime to ensure that it
    does not run as UID 0 (root) and fail to start the container if it does.
    If unset or false, no such validation will be performed.
    May also be set in SecurityContext.  If set in both SecurityContext and
    PodSecurityContext, the value specified in SecurityContext takes precedence.
    +optional
    """
    fsGroup: builtins.int
    """A special supplemental group that applies to all containers in a pod.
    Some volume types allow the Kubelet to change the ownership of that volume
    to be owned by the pod:

    1. The owning GID will be the FSGroup
    2. The setgid bit is set (new files created in the volume will be owned by FSGroup)
    3. The permission bits are OR'd with rw-rw----

    If unset, the Kubelet will not modify the ownership and permissions of any volume.
    +optional
    """
    fsGroupChangePolicy: builtins.str
    """fsGroupChangePolicy defines behavior of changing ownership and permission of the volume
    before being exposed inside Pod. This field will only apply to
    volume types which support fsGroup based ownership(and permissions).
    It will have no effect on ephemeral volume types such as: secret, configmaps
    and emptydir.
    Valid values are "OnRootMismatch" and "Always". If not specified, "Always" is used.
    +optional
    """
    @property
    def seLinuxOptions(self) -> global___SELinuxOptions:
        """The SELinux context to be applied to all containers.
        If unspecified, the container runtime will allocate a random SELinux context for each
        container.  May also be set in SecurityContext.  If set in
        both SecurityContext and PodSecurityContext, the value specified in SecurityContext
        takes precedence for that container.
        +optional
        """

    @property
    def windowsOptions(self) -> global___WindowsSecurityContextOptions:
        """The Windows specific settings applied to all containers.
        If unspecified, the options within a container's SecurityContext will be used.
        If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
        +optional
        """

    @property
    def supplementalGroups(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.int]:
        """A list of groups applied to the first process run in each container, in addition
        to the container's primary GID.  If unspecified, no groups will be added to
        any container.
        +optional
        """

    @property
    def sysctls(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Sysctl]:
        """Sysctls hold a list of namespaced sysctls used for the pod. Pods with unsupported
        sysctls (by the container runtime) might fail to launch.
        +optional
        """

    @property
    def seccompProfile(self) -> global___SeccompProfile:
        """The seccomp options to use by the containers in this pod.
        +optional
        """

    def __init__(
        self,
        *,
        seLinuxOptions: global___SELinuxOptions | None = ...,
        windowsOptions: global___WindowsSecurityContextOptions | None = ...,
        runAsUser: builtins.int | None = ...,
        runAsGroup: builtins.int | None = ...,
        runAsNonRoot: builtins.bool | None = ...,
        supplementalGroups: collections.abc.Iterable[builtins.int] | None = ...,
        fsGroup: builtins.int | None = ...,
        sysctls: collections.abc.Iterable[global___Sysctl] | None = ...,
        fsGroupChangePolicy: builtins.str | None = ...,
        seccompProfile: global___SeccompProfile | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsGroup", b"fsGroup", "fsGroupChangePolicy", b"fsGroupChangePolicy", "runAsGroup", b"runAsGroup", "runAsNonRoot", b"runAsNonRoot", "runAsUser", b"runAsUser", "seLinuxOptions", b"seLinuxOptions", "seccompProfile", b"seccompProfile", "windowsOptions", b"windowsOptions"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsGroup", b"fsGroup", "fsGroupChangePolicy", b"fsGroupChangePolicy", "runAsGroup", b"runAsGroup", "runAsNonRoot", b"runAsNonRoot", "runAsUser", b"runAsUser", "seLinuxOptions", b"seLinuxOptions", "seccompProfile", b"seccompProfile", "supplementalGroups", b"supplementalGroups", "sysctls", b"sysctls", "windowsOptions", b"windowsOptions"]) -> None: ...

global___PodSecurityContext = PodSecurityContext

@typing.final
class PodSignature(google.protobuf.message.Message):
    """Describes the class of pods that should avoid this node.
    Exactly one field should be set.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PODCONTROLLER_FIELD_NUMBER: builtins.int
    @property
    def podController(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.OwnerReference:
        """Reference to controller whose pods should avoid this node.
        +optional
        """

    def __init__(
        self,
        *,
        podController: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.OwnerReference | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["podController", b"podController"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["podController", b"podController"]) -> None: ...

global___PodSignature = PodSignature

@typing.final
class PodSpec(google.protobuf.message.Message):
    """PodSpec is a description of a pod."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class NodeSelectorEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: builtins.str | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    @typing.final
    class OverheadEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    VOLUMES_FIELD_NUMBER: builtins.int
    INITCONTAINERS_FIELD_NUMBER: builtins.int
    CONTAINERS_FIELD_NUMBER: builtins.int
    EPHEMERALCONTAINERS_FIELD_NUMBER: builtins.int
    RESTARTPOLICY_FIELD_NUMBER: builtins.int
    TERMINATIONGRACEPERIODSECONDS_FIELD_NUMBER: builtins.int
    ACTIVEDEADLINESECONDS_FIELD_NUMBER: builtins.int
    DNSPOLICY_FIELD_NUMBER: builtins.int
    NODESELECTOR_FIELD_NUMBER: builtins.int
    SERVICEACCOUNTNAME_FIELD_NUMBER: builtins.int
    SERVICEACCOUNT_FIELD_NUMBER: builtins.int
    AUTOMOUNTSERVICEACCOUNTTOKEN_FIELD_NUMBER: builtins.int
    NODENAME_FIELD_NUMBER: builtins.int
    HOSTNETWORK_FIELD_NUMBER: builtins.int
    HOSTPID_FIELD_NUMBER: builtins.int
    HOSTIPC_FIELD_NUMBER: builtins.int
    SHAREPROCESSNAMESPACE_FIELD_NUMBER: builtins.int
    SECURITYCONTEXT_FIELD_NUMBER: builtins.int
    IMAGEPULLSECRETS_FIELD_NUMBER: builtins.int
    HOSTNAME_FIELD_NUMBER: builtins.int
    SUBDOMAIN_FIELD_NUMBER: builtins.int
    AFFINITY_FIELD_NUMBER: builtins.int
    SCHEDULERNAME_FIELD_NUMBER: builtins.int
    TOLERATIONS_FIELD_NUMBER: builtins.int
    HOSTALIASES_FIELD_NUMBER: builtins.int
    PRIORITYCLASSNAME_FIELD_NUMBER: builtins.int
    PRIORITY_FIELD_NUMBER: builtins.int
    DNSCONFIG_FIELD_NUMBER: builtins.int
    READINESSGATES_FIELD_NUMBER: builtins.int
    RUNTIMECLASSNAME_FIELD_NUMBER: builtins.int
    ENABLESERVICELINKS_FIELD_NUMBER: builtins.int
    PREEMPTIONPOLICY_FIELD_NUMBER: builtins.int
    OVERHEAD_FIELD_NUMBER: builtins.int
    TOPOLOGYSPREADCONSTRAINTS_FIELD_NUMBER: builtins.int
    SETHOSTNAMEASFQDN_FIELD_NUMBER: builtins.int
    restartPolicy: builtins.str
    """Restart policy for all containers within the pod.
    One of Always, OnFailure, Never.
    Default to Always.
    More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy
    +optional
    """
    terminationGracePeriodSeconds: builtins.int
    """Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request.
    Value must be non-negative integer. The value zero indicates stop immediately via
    the kill signal (no opportunity to shut down).
    If this value is nil, the default grace period will be used instead.
    The grace period is the duration in seconds after the processes running in the pod are sent
    a termination signal and the time when the processes are forcibly halted with a kill signal.
    Set this value longer than the expected cleanup time for your process.
    Defaults to 30 seconds.
    +optional
    """
    activeDeadlineSeconds: builtins.int
    """Optional duration in seconds the pod may be active on the node relative to
    StartTime before the system will actively try to mark it failed and kill associated containers.
    Value must be a positive integer.
    +optional
    """
    dnsPolicy: builtins.str
    """Set DNS policy for the pod.
    Defaults to "ClusterFirst".
    Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'.
    DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy.
    To have DNS options set along with hostNetwork, you have to specify DNS policy
    explicitly to 'ClusterFirstWithHostNet'.
    +optional
    """
    serviceAccountName: builtins.str
    """ServiceAccountName is the name of the ServiceAccount to use to run this pod.
    More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/
    +optional
    """
    serviceAccount: builtins.str
    """DeprecatedServiceAccount is a depreciated alias for ServiceAccountName.
    Deprecated: Use serviceAccountName instead.
    +k8s:conversion-gen=false
    +optional
    """
    automountServiceAccountToken: builtins.bool
    """AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.
    +optional
    """
    nodeName: builtins.str
    """NodeName is a request to schedule this pod onto a specific node. If it is non-empty,
    the scheduler simply schedules this pod onto that node, assuming that it fits resource
    requirements.
    +optional
    """
    hostNetwork: builtins.bool
    """Host networking requested for this pod. Use the host's network namespace.
    If this option is set, the ports that will be used must be specified.
    Default to false.
    +k8s:conversion-gen=false
    +optional
    """
    hostPID: builtins.bool
    """Use the host's pid namespace.
    Optional: Default to false.
    +k8s:conversion-gen=false
    +optional
    """
    hostIPC: builtins.bool
    """Use the host's ipc namespace.
    Optional: Default to false.
    +k8s:conversion-gen=false
    +optional
    """
    shareProcessNamespace: builtins.bool
    """Share a single process namespace between all of the containers in a pod.
    When this is set containers will be able to view and signal processes from other containers
    in the same pod, and the first process in each container will not be assigned PID 1.
    HostPID and ShareProcessNamespace cannot both be set.
    Optional: Default to false.
    +k8s:conversion-gen=false
    +optional
    """
    hostname: builtins.str
    """Specifies the hostname of the Pod
    If not specified, the pod's hostname will be set to a system-defined value.
    +optional
    """
    subdomain: builtins.str
    """If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>".
    If not specified, the pod will not have a domainname at all.
    +optional
    """
    schedulerName: builtins.str
    """If specified, the pod will be dispatched by specified scheduler.
    If not specified, the pod will be dispatched by default scheduler.
    +optional
    """
    priorityClassName: builtins.str
    """If specified, indicates the pod's priority. "system-node-critical" and
    "system-cluster-critical" are two special keywords which indicate the
    highest priorities with the former being the highest priority. Any other
    name must be defined by creating a PriorityClass object with that name.
    If not specified, the pod priority will be default or zero if there is no
    default.
    +optional
    """
    priority: builtins.int
    """The priority value. Various system components use this field to find the
    priority of the pod. When Priority Admission Controller is enabled, it
    prevents users from setting this field. The admission controller populates
    this field from PriorityClassName.
    The higher the value, the higher the priority.
    +optional
    """
    runtimeClassName: builtins.str
    """RuntimeClassName refers to a RuntimeClass object in the node.k8s.io group, which should be used
    to run this pod.  If no RuntimeClass resource matches the named class, the pod will not be run.
    If unset or empty, the "legacy" RuntimeClass will be used, which is an implicit class with an
    empty definition that uses the default runtime handler.
    More info: https://git.k8s.io/enhancements/keps/sig-node/585-runtime-class
    This is a beta feature as of Kubernetes v1.14.
    +optional
    """
    enableServiceLinks: builtins.bool
    """EnableServiceLinks indicates whether information about services should be injected into pod's
    environment variables, matching the syntax of Docker links.
    Optional: Defaults to true.
    +optional
    """
    preemptionPolicy: builtins.str
    """PreemptionPolicy is the Policy for preempting pods with lower priority.
    One of Never, PreemptLowerPriority.
    Defaults to PreemptLowerPriority if unset.
    This field is beta-level, gated by the NonPreemptingPriority feature-gate.
    +optional
    """
    setHostnameAsFQDN: builtins.bool
    """If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default).
    In Linux containers, this means setting the FQDN in the hostname field of the kernel (the nodename field of struct utsname).
    In Windows containers, this means setting the registry value of hostname for the registry key HKEY_LOCAL_MACHINE\\\\SYSTEM\\\\CurrentControlSet\\\\Services\\\\Tcpip\\\\Parameters to FQDN.
    If a pod does not have FQDN, this has no effect.
    Default to false.
    +optional
    """
    @property
    def volumes(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Volume]:
        """List of volumes that can be mounted by containers belonging to the pod.
        More info: https://kubernetes.io/docs/concepts/storage/volumes
        +optional
        +patchMergeKey=name
        +patchStrategy=merge,retainKeys
        """

    @property
    def initContainers(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Container]:
        """List of initialization containers belonging to the pod.
        Init containers are executed in order prior to containers being started. If any
        init container fails, the pod is considered to have failed and is handled according
        to its restartPolicy. The name for an init container or normal container must be
        unique among all containers.
        Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
        The resourceRequirements of an init container are taken into account during scheduling
        by finding the highest request/limit for each resource type, and then using the max of
        of that value or the sum of the normal containers. Limits are applied to init containers
        in a similar fashion.
        Init containers cannot currently be added or removed.
        Cannot be updated.
        More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/
        +patchMergeKey=name
        +patchStrategy=merge
        """

    @property
    def containers(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Container]:
        """List of containers belonging to the pod.
        Containers cannot currently be added or removed.
        There must be at least one container in a Pod.
        Cannot be updated.
        +patchMergeKey=name
        +patchStrategy=merge
        """

    @property
    def ephemeralContainers(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___EphemeralContainer]:
        """List of ephemeral containers run in this pod. Ephemeral containers may be run in an existing
        pod to perform user-initiated actions such as debugging. This list cannot be specified when
        creating a pod, and it cannot be modified by updating the pod spec. In order to add an
        ephemeral container to an existing pod, use the pod's ephemeralcontainers subresource.
        This field is alpha-level and is only honored by servers that enable the EphemeralContainers feature.
        +optional
        +patchMergeKey=name
        +patchStrategy=merge
        """

    @property
    def nodeSelector(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """NodeSelector is a selector which must be true for the pod to fit on a node.
        Selector which must match a node's labels for the pod to be scheduled on that node.
        More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/
        +optional
        +mapType=atomic
        """

    @property
    def securityContext(self) -> global___PodSecurityContext:
        """SecurityContext holds pod-level security attributes and common container settings.
        Optional: Defaults to empty.  See type description for default values of each field.
        +optional
        """

    @property
    def imagePullSecrets(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___LocalObjectReference]:
        """ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec.
        If specified, these secrets will be passed to individual puller implementations for them to use. For example,
        in the case of docker, only DockerConfig type secrets are honored.
        More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod
        +optional
        +patchMergeKey=name
        +patchStrategy=merge
        """

    @property
    def affinity(self) -> global___Affinity:
        """If specified, the pod's scheduling constraints
        +optional
        """

    @property
    def tolerations(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Toleration]:
        """If specified, the pod's tolerations.
        +optional
        """

    @property
    def hostAliases(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___HostAlias]:
        """HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts
        file if specified. This is only valid for non-hostNetwork pods.
        +optional
        +patchMergeKey=ip
        +patchStrategy=merge
        """

    @property
    def dnsConfig(self) -> global___PodDNSConfig:
        """Specifies the DNS parameters of a pod.
        Parameters specified here will be merged to the generated DNS
        configuration based on DNSPolicy.
        +optional
        """

    @property
    def readinessGates(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PodReadinessGate]:
        """If specified, all readiness gates will be evaluated for pod readiness.
        A pod is ready when all its containers are ready AND
        all conditions specified in the readiness gates have status equal to "True"
        More info: https://git.k8s.io/enhancements/keps/sig-network/580-pod-readiness-gates
        +optional
        """

    @property
    def overhead(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Overhead represents the resource overhead associated with running a pod for a given RuntimeClass.
        This field will be autopopulated at admission time by the RuntimeClass admission controller. If
        the RuntimeClass admission controller is enabled, overhead must not be set in Pod create requests.
        The RuntimeClass admission controller will reject Pod create requests which have the overhead already
        set. If RuntimeClass is configured and selected in the PodSpec, Overhead will be set to the value
        defined in the corresponding RuntimeClass, otherwise it will remain unset and treated as zero.
        More info: https://git.k8s.io/enhancements/keps/sig-node/688-pod-overhead/README.md
        This field is beta-level as of Kubernetes v1.18, and is only honored by servers that enable the PodOverhead feature.
        +optional
        """

    @property
    def topologySpreadConstraints(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___TopologySpreadConstraint]:
        """TopologySpreadConstraints describes how a group of pods ought to spread across topology
        domains. Scheduler will schedule pods in a way which abides by the constraints.
        All topologySpreadConstraints are ANDed.
        +optional
        +patchMergeKey=topologyKey
        +patchStrategy=merge
        +listType=map
        +listMapKey=topologyKey
        +listMapKey=whenUnsatisfiable
        """

    def __init__(
        self,
        *,
        volumes: collections.abc.Iterable[global___Volume] | None = ...,
        initContainers: collections.abc.Iterable[global___Container] | None = ...,
        containers: collections.abc.Iterable[global___Container] | None = ...,
        ephemeralContainers: collections.abc.Iterable[global___EphemeralContainer] | None = ...,
        restartPolicy: builtins.str | None = ...,
        terminationGracePeriodSeconds: builtins.int | None = ...,
        activeDeadlineSeconds: builtins.int | None = ...,
        dnsPolicy: builtins.str | None = ...,
        nodeSelector: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        serviceAccountName: builtins.str | None = ...,
        serviceAccount: builtins.str | None = ...,
        automountServiceAccountToken: builtins.bool | None = ...,
        nodeName: builtins.str | None = ...,
        hostNetwork: builtins.bool | None = ...,
        hostPID: builtins.bool | None = ...,
        hostIPC: builtins.bool | None = ...,
        shareProcessNamespace: builtins.bool | None = ...,
        securityContext: global___PodSecurityContext | None = ...,
        imagePullSecrets: collections.abc.Iterable[global___LocalObjectReference] | None = ...,
        hostname: builtins.str | None = ...,
        subdomain: builtins.str | None = ...,
        affinity: global___Affinity | None = ...,
        schedulerName: builtins.str | None = ...,
        tolerations: collections.abc.Iterable[global___Toleration] | None = ...,
        hostAliases: collections.abc.Iterable[global___HostAlias] | None = ...,
        priorityClassName: builtins.str | None = ...,
        priority: builtins.int | None = ...,
        dnsConfig: global___PodDNSConfig | None = ...,
        readinessGates: collections.abc.Iterable[global___PodReadinessGate] | None = ...,
        runtimeClassName: builtins.str | None = ...,
        enableServiceLinks: builtins.bool | None = ...,
        preemptionPolicy: builtins.str | None = ...,
        overhead: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        topologySpreadConstraints: collections.abc.Iterable[global___TopologySpreadConstraint] | None = ...,
        setHostnameAsFQDN: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["activeDeadlineSeconds", b"activeDeadlineSeconds", "affinity", b"affinity", "automountServiceAccountToken", b"automountServiceAccountToken", "dnsConfig", b"dnsConfig", "dnsPolicy", b"dnsPolicy", "enableServiceLinks", b"enableServiceLinks", "hostIPC", b"hostIPC", "hostNetwork", b"hostNetwork", "hostPID", b"hostPID", "hostname", b"hostname", "nodeName", b"nodeName", "preemptionPolicy", b"preemptionPolicy", "priority", b"priority", "priorityClassName", b"priorityClassName", "restartPolicy", b"restartPolicy", "runtimeClassName", b"runtimeClassName", "schedulerName", b"schedulerName", "securityContext", b"securityContext", "serviceAccount", b"serviceAccount", "serviceAccountName", b"serviceAccountName", "setHostnameAsFQDN", b"setHostnameAsFQDN", "shareProcessNamespace", b"shareProcessNamespace", "subdomain", b"subdomain", "terminationGracePeriodSeconds", b"terminationGracePeriodSeconds"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["activeDeadlineSeconds", b"activeDeadlineSeconds", "affinity", b"affinity", "automountServiceAccountToken", b"automountServiceAccountToken", "containers", b"containers", "dnsConfig", b"dnsConfig", "dnsPolicy", b"dnsPolicy", "enableServiceLinks", b"enableServiceLinks", "ephemeralContainers", b"ephemeralContainers", "hostAliases", b"hostAliases", "hostIPC", b"hostIPC", "hostNetwork", b"hostNetwork", "hostPID", b"hostPID", "hostname", b"hostname", "imagePullSecrets", b"imagePullSecrets", "initContainers", b"initContainers", "nodeName", b"nodeName", "nodeSelector", b"nodeSelector", "overhead", b"overhead", "preemptionPolicy", b"preemptionPolicy", "priority", b"priority", "priorityClassName", b"priorityClassName", "readinessGates", b"readinessGates", "restartPolicy", b"restartPolicy", "runtimeClassName", b"runtimeClassName", "schedulerName", b"schedulerName", "securityContext", b"securityContext", "serviceAccount", b"serviceAccount", "serviceAccountName", b"serviceAccountName", "setHostnameAsFQDN", b"setHostnameAsFQDN", "shareProcessNamespace", b"shareProcessNamespace", "subdomain", b"subdomain", "terminationGracePeriodSeconds", b"terminationGracePeriodSeconds", "tolerations", b"tolerations", "topologySpreadConstraints", b"topologySpreadConstraints", "volumes", b"volumes"]) -> None: ...

global___PodSpec = PodSpec

@typing.final
class PodStatus(google.protobuf.message.Message):
    """PodStatus represents information about the status of a pod. Status may trail the actual
    state of a system, especially if the node that hosts the pod cannot contact the control
    plane.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PHASE_FIELD_NUMBER: builtins.int
    CONDITIONS_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    REASON_FIELD_NUMBER: builtins.int
    NOMINATEDNODENAME_FIELD_NUMBER: builtins.int
    HOSTIP_FIELD_NUMBER: builtins.int
    PODIP_FIELD_NUMBER: builtins.int
    PODIPS_FIELD_NUMBER: builtins.int
    STARTTIME_FIELD_NUMBER: builtins.int
    INITCONTAINERSTATUSES_FIELD_NUMBER: builtins.int
    CONTAINERSTATUSES_FIELD_NUMBER: builtins.int
    QOSCLASS_FIELD_NUMBER: builtins.int
    EPHEMERALCONTAINERSTATUSES_FIELD_NUMBER: builtins.int
    phase: builtins.str
    """The phase of a Pod is a simple, high-level summary of where the Pod is in its lifecycle.
    The conditions array, the reason and message fields, and the individual container status
    arrays contain more detail about the pod's status.
    There are five possible phase values:

    Pending: The pod has been accepted by the Kubernetes system, but one or more of the
    container images has not been created. This includes time before being scheduled as
    well as time spent downloading images over the network, which could take a while.
    Running: The pod has been bound to a node, and all of the containers have been created.
    At least one container is still running, or is in the process of starting or restarting.
    Succeeded: All containers in the pod have terminated in success, and will not be restarted.
    Failed: All containers in the pod have terminated, and at least one container has
    terminated in failure. The container either exited with non-zero status or was terminated
    by the system.
    Unknown: For some reason the state of the pod could not be obtained, typically due to an
    error in communicating with the host of the pod.

    More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-phase
    +optional
    """
    message: builtins.str
    """A human readable message indicating details about why the pod is in this condition.
    +optional
    """
    reason: builtins.str
    """A brief CamelCase message indicating details about why the pod is in this state.
    e.g. 'Evicted'
    +optional
    """
    nominatedNodeName: builtins.str
    """nominatedNodeName is set only when this pod preempts other pods on the node, but it cannot be
    scheduled right away as preemption victims receive their graceful termination periods.
    This field does not guarantee that the pod will be scheduled on this node. Scheduler may decide
    to place the pod elsewhere if other nodes become available sooner. Scheduler may also decide to
    give the resources on this node to a higher priority pod that is created after preemption.
    As a result, this field may be different than PodSpec.nodeName when the pod is
    scheduled.
    +optional
    """
    hostIP: builtins.str
    """IP address of the host to which the pod is assigned. Empty if not yet scheduled.
    +optional
    """
    podIP: builtins.str
    """IP address allocated to the pod. Routable at least within the cluster.
    Empty if not yet allocated.
    +optional
    """
    qosClass: builtins.str
    """The Quality of Service (QOS) classification assigned to the pod based on resource requirements
    See PodQOSClass type for available QOS classes
    More info: https://git.k8s.io/community/contributors/design-proposals/node/resource-qos.md
    +optional
    """
    @property
    def conditions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PodCondition]:
        """Current service state of pod.
        More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions
        +optional
        +patchMergeKey=type
        +patchStrategy=merge
        """

    @property
    def podIPs(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PodIP]:
        """podIPs holds the IP addresses allocated to the pod. If this field is specified, the 0th entry must
        match the podIP field. Pods may be allocated at most 1 value for each of IPv4 and IPv6. This list
        is empty if no IPs have been allocated yet.
        +optional
        +patchStrategy=merge
        +patchMergeKey=ip
        """

    @property
    def startTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """RFC 3339 date and time at which the object was acknowledged by the Kubelet.
        This is before the Kubelet pulled the container image(s) for the pod.
        +optional
        """

    @property
    def initContainerStatuses(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ContainerStatus]:
        """The list has one entry per init container in the manifest. The most recent successful
        init container will have ready = true, the most recently started container will have
        startTime set.
        More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-and-container-status
        """

    @property
    def containerStatuses(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ContainerStatus]:
        """The list has one entry per container in the manifest. Each entry is currently the output
        of `docker inspect`.
        More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-and-container-status
        +optional
        """

    @property
    def ephemeralContainerStatuses(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ContainerStatus]:
        """Status for any ephemeral containers that have run in this pod.
        This field is alpha-level and is only populated by servers that enable the EphemeralContainers feature.
        +optional
        """

    def __init__(
        self,
        *,
        phase: builtins.str | None = ...,
        conditions: collections.abc.Iterable[global___PodCondition] | None = ...,
        message: builtins.str | None = ...,
        reason: builtins.str | None = ...,
        nominatedNodeName: builtins.str | None = ...,
        hostIP: builtins.str | None = ...,
        podIP: builtins.str | None = ...,
        podIPs: collections.abc.Iterable[global___PodIP] | None = ...,
        startTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        initContainerStatuses: collections.abc.Iterable[global___ContainerStatus] | None = ...,
        containerStatuses: collections.abc.Iterable[global___ContainerStatus] | None = ...,
        qosClass: builtins.str | None = ...,
        ephemeralContainerStatuses: collections.abc.Iterable[global___ContainerStatus] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["hostIP", b"hostIP", "message", b"message", "nominatedNodeName", b"nominatedNodeName", "phase", b"phase", "podIP", b"podIP", "qosClass", b"qosClass", "reason", b"reason", "startTime", b"startTime"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["conditions", b"conditions", "containerStatuses", b"containerStatuses", "ephemeralContainerStatuses", b"ephemeralContainerStatuses", "hostIP", b"hostIP", "initContainerStatuses", b"initContainerStatuses", "message", b"message", "nominatedNodeName", b"nominatedNodeName", "phase", b"phase", "podIP", b"podIP", "podIPs", b"podIPs", "qosClass", b"qosClass", "reason", b"reason", "startTime", b"startTime"]) -> None: ...

global___PodStatus = PodStatus

@typing.final
class PodStatusResult(google.protobuf.message.Message):
    """PodStatusResult is a wrapper for PodStatus returned by kubelet that can be encode/decoded"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def status(self) -> global___PodStatus:
        """Most recently observed status of the pod.
        This data may not be up to date.
        Populated by the system.
        Read-only.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        status: global___PodStatus | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "status", b"status"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "status", b"status"]) -> None: ...

global___PodStatusResult = PodStatusResult

@typing.final
class PodTemplate(google.protobuf.message.Message):
    """PodTemplate describes a template for creating copies of a predefined pod."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    TEMPLATE_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def template(self) -> global___PodTemplateSpec:
        """Template defines the pods that will be created from this pod template.
        https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        template: global___PodTemplateSpec | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "template", b"template"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "template", b"template"]) -> None: ...

global___PodTemplate = PodTemplate

@typing.final
class PodTemplateList(google.protobuf.message.Message):
    """PodTemplateList is a list of PodTemplates."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PodTemplate]:
        """List of pod templates"""

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___PodTemplate] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___PodTemplateList = PodTemplateList

@typing.final
class PodTemplateSpec(google.protobuf.message.Message):
    """PodTemplateSpec describes the data a pod should have when created from a template"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SPEC_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def spec(self) -> global___PodSpec:
        """Specification of the desired behavior of the pod.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        spec: global___PodSpec | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec"]) -> None: ...

global___PodTemplateSpec = PodTemplateSpec

@typing.final
class PortStatus(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PORT_FIELD_NUMBER: builtins.int
    PROTOCOL_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    port: builtins.int
    """Port is the port number of the service port of which status is recorded here"""
    protocol: builtins.str
    """Protocol is the protocol of the service port of which status is recorded here
    The supported values are: "TCP", "UDP", "SCTP"
    """
    error: builtins.str
    """Error is to record the problem with the service port
    The format of the error shall comply with the following rules:
    - built-in error values shall be specified in this file and those shall use
      CamelCase names
    - cloud provider specific error values must have names that comply with the
      format foo.example.com/CamelCase.
    ---
    The regex it matches is (dns1123SubdomainFmt/)?(qualifiedNameFmt)
    +optional
    +kubebuilder:validation:Required
    +kubebuilder:validation:Pattern=`^([a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*/)?(([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9])$`
    +kubebuilder:validation:MaxLength=316
    """
    def __init__(
        self,
        *,
        port: builtins.int | None = ...,
        protocol: builtins.str | None = ...,
        error: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "port", b"port", "protocol", b"protocol"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "port", b"port", "protocol", b"protocol"]) -> None: ...

global___PortStatus = PortStatus

@typing.final
class PortworxVolumeSource(google.protobuf.message.Message):
    """PortworxVolumeSource represents a Portworx volume resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VOLUMEID_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    volumeID: builtins.str
    """VolumeID uniquely identifies a Portworx volume"""
    fsType: builtins.str
    """FSType represents the filesystem type to mount
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs". Implicitly inferred to be "ext4" if unspecified.
    """
    readOnly: builtins.bool
    """Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    +optional
    """
    def __init__(
        self,
        *,
        volumeID: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "readOnly", b"readOnly", "volumeID", b"volumeID"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "readOnly", b"readOnly", "volumeID", b"volumeID"]) -> None: ...

global___PortworxVolumeSource = PortworxVolumeSource

@typing.final
class Preconditions(google.protobuf.message.Message):
    """Preconditions must be fulfilled before an operation (update, delete, etc.) is carried out.
    +k8s:openapi-gen=false
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    UID_FIELD_NUMBER: builtins.int
    uid: builtins.str
    """Specifies the target UID.
    +optional
    """
    def __init__(
        self,
        *,
        uid: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["uid", b"uid"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["uid", b"uid"]) -> None: ...

global___Preconditions = Preconditions

@typing.final
class PreferAvoidPodsEntry(google.protobuf.message.Message):
    """Describes a class of pods that should avoid this node."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PODSIGNATURE_FIELD_NUMBER: builtins.int
    EVICTIONTIME_FIELD_NUMBER: builtins.int
    REASON_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    reason: builtins.str
    """(brief) reason why this entry was added to the list.
    +optional
    """
    message: builtins.str
    """Human readable message indicating why this entry was added to the list.
    +optional
    """
    @property
    def podSignature(self) -> global___PodSignature:
        """The class of pods."""

    @property
    def evictionTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """Time at which this entry was added to the list.
        +optional
        """

    def __init__(
        self,
        *,
        podSignature: global___PodSignature | None = ...,
        evictionTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        reason: builtins.str | None = ...,
        message: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["evictionTime", b"evictionTime", "message", b"message", "podSignature", b"podSignature", "reason", b"reason"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["evictionTime", b"evictionTime", "message", b"message", "podSignature", b"podSignature", "reason", b"reason"]) -> None: ...

global___PreferAvoidPodsEntry = PreferAvoidPodsEntry

@typing.final
class PreferredSchedulingTerm(google.protobuf.message.Message):
    """An empty preferred scheduling term matches all objects with implicit weight 0
    (i.e. it's a no-op). A null preferred scheduling term matches no objects (i.e. is also a no-op).
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WEIGHT_FIELD_NUMBER: builtins.int
    PREFERENCE_FIELD_NUMBER: builtins.int
    weight: builtins.int
    """Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100."""
    @property
    def preference(self) -> global___NodeSelectorTerm:
        """A node selector term, associated with the corresponding weight."""

    def __init__(
        self,
        *,
        weight: builtins.int | None = ...,
        preference: global___NodeSelectorTerm | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["preference", b"preference", "weight", b"weight"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["preference", b"preference", "weight", b"weight"]) -> None: ...

global___PreferredSchedulingTerm = PreferredSchedulingTerm

@typing.final
class Probe(google.protobuf.message.Message):
    """Probe describes a health check to be performed against a container to determine whether it is
    alive or ready to receive traffic.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    HANDLER_FIELD_NUMBER: builtins.int
    INITIALDELAYSECONDS_FIELD_NUMBER: builtins.int
    TIMEOUTSECONDS_FIELD_NUMBER: builtins.int
    PERIODSECONDS_FIELD_NUMBER: builtins.int
    SUCCESSTHRESHOLD_FIELD_NUMBER: builtins.int
    FAILURETHRESHOLD_FIELD_NUMBER: builtins.int
    TERMINATIONGRACEPERIODSECONDS_FIELD_NUMBER: builtins.int
    initialDelaySeconds: builtins.int
    """Number of seconds after the container has started before liveness probes are initiated.
    More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
    +optional
    """
    timeoutSeconds: builtins.int
    """Number of seconds after which the probe times out.
    Defaults to 1 second. Minimum value is 1.
    More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes
    +optional
    """
    periodSeconds: builtins.int
    """How often (in seconds) to perform the probe.
    Default to 10 seconds. Minimum value is 1.
    +optional
    """
    successThreshold: builtins.int
    """Minimum consecutive successes for the probe to be considered successful after having failed.
    Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.
    +optional
    """
    failureThreshold: builtins.int
    """Minimum consecutive failures for the probe to be considered failed after having succeeded.
    Defaults to 3. Minimum value is 1.
    +optional
    """
    terminationGracePeriodSeconds: builtins.int
    """Optional duration in seconds the pod needs to terminate gracefully upon probe failure.
    The grace period is the duration in seconds after the processes running in the pod are sent
    a termination signal and the time when the processes are forcibly halted with a kill signal.
    Set this value longer than the expected cleanup time for your process.
    If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this
    value overrides the value provided by the pod spec.
    Value must be non-negative integer. The value zero indicates stop immediately via
    the kill signal (no opportunity to shut down).
    This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate.
    Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.
    +optional
    """
    @property
    def handler(self) -> global___Handler:
        """The action taken to determine the health of a container"""

    def __init__(
        self,
        *,
        handler: global___Handler | None = ...,
        initialDelaySeconds: builtins.int | None = ...,
        timeoutSeconds: builtins.int | None = ...,
        periodSeconds: builtins.int | None = ...,
        successThreshold: builtins.int | None = ...,
        failureThreshold: builtins.int | None = ...,
        terminationGracePeriodSeconds: builtins.int | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["failureThreshold", b"failureThreshold", "handler", b"handler", "initialDelaySeconds", b"initialDelaySeconds", "periodSeconds", b"periodSeconds", "successThreshold", b"successThreshold", "terminationGracePeriodSeconds", b"terminationGracePeriodSeconds", "timeoutSeconds", b"timeoutSeconds"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["failureThreshold", b"failureThreshold", "handler", b"handler", "initialDelaySeconds", b"initialDelaySeconds", "periodSeconds", b"periodSeconds", "successThreshold", b"successThreshold", "terminationGracePeriodSeconds", b"terminationGracePeriodSeconds", "timeoutSeconds", b"timeoutSeconds"]) -> None: ...

global___Probe = Probe

@typing.final
class ProjectedVolumeSource(google.protobuf.message.Message):
    """Represents a projected volume source"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SOURCES_FIELD_NUMBER: builtins.int
    DEFAULTMODE_FIELD_NUMBER: builtins.int
    defaultMode: builtins.int
    """Mode bits used to set permissions on created files by default.
    Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511.
    YAML accepts both octal and decimal values, JSON requires decimal values for mode bits.
    Directories within the path are not affected by this setting.
    This might be in conflict with other options that affect the file
    mode, like fsGroup, and the result can be other mode bits set.
    +optional
    """
    @property
    def sources(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___VolumeProjection]:
        """list of volume projections
        +optional
        """

    def __init__(
        self,
        *,
        sources: collections.abc.Iterable[global___VolumeProjection] | None = ...,
        defaultMode: builtins.int | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["defaultMode", b"defaultMode"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["defaultMode", b"defaultMode", "sources", b"sources"]) -> None: ...

global___ProjectedVolumeSource = ProjectedVolumeSource

@typing.final
class QuobyteVolumeSource(google.protobuf.message.Message):
    """Represents a Quobyte mount that lasts the lifetime of a pod.
    Quobyte volumes do not support ownership management or SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REGISTRY_FIELD_NUMBER: builtins.int
    VOLUME_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    USER_FIELD_NUMBER: builtins.int
    GROUP_FIELD_NUMBER: builtins.int
    TENANT_FIELD_NUMBER: builtins.int
    registry: builtins.str
    """Registry represents a single or multiple Quobyte Registry services
    specified as a string as host:port pair (multiple entries are separated with commas)
    which acts as the central registry for volumes
    """
    volume: builtins.str
    """Volume is a string that references an already created Quobyte volume by name."""
    readOnly: builtins.bool
    """ReadOnly here will force the Quobyte volume to be mounted with read-only permissions.
    Defaults to false.
    +optional
    """
    user: builtins.str
    """User to map volume access to
    Defaults to serivceaccount user
    +optional
    """
    group: builtins.str
    """Group to map volume access to
    Default is no group
    +optional
    """
    tenant: builtins.str
    """Tenant owning the given Quobyte volume in the Backend
    Used with dynamically provisioned Quobyte volumes, value is set by the plugin
    +optional
    """
    def __init__(
        self,
        *,
        registry: builtins.str | None = ...,
        volume: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        user: builtins.str | None = ...,
        group: builtins.str | None = ...,
        tenant: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["group", b"group", "readOnly", b"readOnly", "registry", b"registry", "tenant", b"tenant", "user", b"user", "volume", b"volume"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["group", b"group", "readOnly", b"readOnly", "registry", b"registry", "tenant", b"tenant", "user", b"user", "volume", b"volume"]) -> None: ...

global___QuobyteVolumeSource = QuobyteVolumeSource

@typing.final
class RBDPersistentVolumeSource(google.protobuf.message.Message):
    """Represents a Rados Block Device mount that lasts the lifetime of a pod.
    RBD volumes support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MONITORS_FIELD_NUMBER: builtins.int
    IMAGE_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    POOL_FIELD_NUMBER: builtins.int
    USER_FIELD_NUMBER: builtins.int
    KEYRING_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    image: builtins.str
    """The rados image name.
    More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
    """
    fsType: builtins.str
    """Filesystem type of the volume that you want to mount.
    Tip: Ensure that the filesystem type is supported by the host operating system.
    Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd
    TODO: how do we prevent errors in the filesystem from compromising the machine
    +optional
    """
    pool: builtins.str
    """The rados pool name.
    Default is rbd.
    More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
    +optional
    """
    user: builtins.str
    """The rados user name.
    Default is admin.
    More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
    +optional
    """
    keyring: builtins.str
    """Keyring is the path to key ring for RBDUser.
    Default is /etc/ceph/keyring.
    More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
    +optional
    """
    readOnly: builtins.bool
    """ReadOnly here will force the ReadOnly setting in VolumeMounts.
    Defaults to false.
    More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
    +optional
    """
    @property
    def monitors(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """A collection of Ceph monitors.
        More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
        """

    @property
    def secretRef(self) -> global___SecretReference:
        """SecretRef is name of the authentication secret for RBDUser. If provided
        overrides keyring.
        Default is nil.
        More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
        +optional
        """

    def __init__(
        self,
        *,
        monitors: collections.abc.Iterable[builtins.str] | None = ...,
        image: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        pool: builtins.str | None = ...,
        user: builtins.str | None = ...,
        keyring: builtins.str | None = ...,
        secretRef: global___SecretReference | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "image", b"image", "keyring", b"keyring", "pool", b"pool", "readOnly", b"readOnly", "secretRef", b"secretRef", "user", b"user"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "image", b"image", "keyring", b"keyring", "monitors", b"monitors", "pool", b"pool", "readOnly", b"readOnly", "secretRef", b"secretRef", "user", b"user"]) -> None: ...

global___RBDPersistentVolumeSource = RBDPersistentVolumeSource

@typing.final
class RBDVolumeSource(google.protobuf.message.Message):
    """Represents a Rados Block Device mount that lasts the lifetime of a pod.
    RBD volumes support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MONITORS_FIELD_NUMBER: builtins.int
    IMAGE_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    POOL_FIELD_NUMBER: builtins.int
    USER_FIELD_NUMBER: builtins.int
    KEYRING_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    image: builtins.str
    """The rados image name.
    More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
    """
    fsType: builtins.str
    """Filesystem type of the volume that you want to mount.
    Tip: Ensure that the filesystem type is supported by the host operating system.
    Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd
    TODO: how do we prevent errors in the filesystem from compromising the machine
    +optional
    """
    pool: builtins.str
    """The rados pool name.
    Default is rbd.
    More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
    +optional
    """
    user: builtins.str
    """The rados user name.
    Default is admin.
    More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
    +optional
    """
    keyring: builtins.str
    """Keyring is the path to key ring for RBDUser.
    Default is /etc/ceph/keyring.
    More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
    +optional
    """
    readOnly: builtins.bool
    """ReadOnly here will force the ReadOnly setting in VolumeMounts.
    Defaults to false.
    More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
    +optional
    """
    @property
    def monitors(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """A collection of Ceph monitors.
        More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
        """

    @property
    def secretRef(self) -> global___LocalObjectReference:
        """SecretRef is name of the authentication secret for RBDUser. If provided
        overrides keyring.
        Default is nil.
        More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it
        +optional
        """

    def __init__(
        self,
        *,
        monitors: collections.abc.Iterable[builtins.str] | None = ...,
        image: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        pool: builtins.str | None = ...,
        user: builtins.str | None = ...,
        keyring: builtins.str | None = ...,
        secretRef: global___LocalObjectReference | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "image", b"image", "keyring", b"keyring", "pool", b"pool", "readOnly", b"readOnly", "secretRef", b"secretRef", "user", b"user"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "image", b"image", "keyring", b"keyring", "monitors", b"monitors", "pool", b"pool", "readOnly", b"readOnly", "secretRef", b"secretRef", "user", b"user"]) -> None: ...

global___RBDVolumeSource = RBDVolumeSource

@typing.final
class RangeAllocation(google.protobuf.message.Message):
    """RangeAllocation is not a public type."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    RANGE_FIELD_NUMBER: builtins.int
    DATA_FIELD_NUMBER: builtins.int
    range: builtins.str
    """Range is string that identifies the range represented by 'data'."""
    data: builtins.bytes
    """Data is a bit array containing all allocated addresses in the previous segment."""
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        range: builtins.str | None = ...,
        data: builtins.bytes | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["data", b"data", "metadata", b"metadata", "range", b"range"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["data", b"data", "metadata", b"metadata", "range", b"range"]) -> None: ...

global___RangeAllocation = RangeAllocation

@typing.final
class ReplicationController(google.protobuf.message.Message):
    """ReplicationController represents the configuration of a replication controller."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SPEC_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """If the Labels of a ReplicationController are empty, they are defaulted to
        be the same as the Pod(s) that the replication controller manages.
        Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def spec(self) -> global___ReplicationControllerSpec:
        """Spec defines the specification of the desired behavior of the replication controller.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    @property
    def status(self) -> global___ReplicationControllerStatus:
        """Status is the most recently observed status of the replication controller.
        This data may be out of date by some window of time.
        Populated by the system.
        Read-only.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        spec: global___ReplicationControllerSpec | None = ...,
        status: global___ReplicationControllerStatus | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> None: ...

global___ReplicationController = ReplicationController

@typing.final
class ReplicationControllerCondition(google.protobuf.message.Message):
    """ReplicationControllerCondition describes the state of a replication controller at a certain point."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    LASTTRANSITIONTIME_FIELD_NUMBER: builtins.int
    REASON_FIELD_NUMBER: builtins.int
    MESSAGE_FIELD_NUMBER: builtins.int
    type: builtins.str
    """Type of replication controller condition."""
    status: builtins.str
    """Status of the condition, one of True, False, Unknown."""
    reason: builtins.str
    """The reason for the condition's last transition.
    +optional
    """
    message: builtins.str
    """A human readable message indicating details about the transition.
    +optional
    """
    @property
    def lastTransitionTime(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """The last time the condition transitioned from one status to another.
        +optional
        """

    def __init__(
        self,
        *,
        type: builtins.str | None = ...,
        status: builtins.str | None = ...,
        lastTransitionTime: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
        reason: builtins.str | None = ...,
        message: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["lastTransitionTime", b"lastTransitionTime", "message", b"message", "reason", b"reason", "status", b"status", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["lastTransitionTime", b"lastTransitionTime", "message", b"message", "reason", b"reason", "status", b"status", "type", b"type"]) -> None: ...

global___ReplicationControllerCondition = ReplicationControllerCondition

@typing.final
class ReplicationControllerList(google.protobuf.message.Message):
    """ReplicationControllerList is a collection of replication controllers."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ReplicationController]:
        """List of replication controllers.
        More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___ReplicationController] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___ReplicationControllerList = ReplicationControllerList

@typing.final
class ReplicationControllerSpec(google.protobuf.message.Message):
    """ReplicationControllerSpec is the specification of a replication controller."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class SelectorEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: builtins.str | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    REPLICAS_FIELD_NUMBER: builtins.int
    MINREADYSECONDS_FIELD_NUMBER: builtins.int
    SELECTOR_FIELD_NUMBER: builtins.int
    TEMPLATE_FIELD_NUMBER: builtins.int
    replicas: builtins.int
    """Replicas is the number of desired replicas.
    This is a pointer to distinguish between explicit zero and unspecified.
    Defaults to 1.
    More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#what-is-a-replicationcontroller
    +optional
    """
    minReadySeconds: builtins.int
    """Minimum number of seconds for which a newly created pod should be ready
    without any of its container crashing, for it to be considered available.
    Defaults to 0 (pod will be considered available as soon as it is ready)
    +optional
    """
    @property
    def selector(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """Selector is a label query over pods that should match the Replicas count.
        If Selector is empty, it is defaulted to the labels present on the Pod template.
        Label keys and values that must match in order to be controlled by this replication
        controller, if empty defaulted to labels on Pod template.
        More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors
        +optional
        +mapType=atomic
        """

    @property
    def template(self) -> global___PodTemplateSpec:
        """Template is the object that describes the pod that will be created if
        insufficient replicas are detected. This takes precedence over a TemplateRef.
        More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template
        +optional
        """

    def __init__(
        self,
        *,
        replicas: builtins.int | None = ...,
        minReadySeconds: builtins.int | None = ...,
        selector: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        template: global___PodTemplateSpec | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["minReadySeconds", b"minReadySeconds", "replicas", b"replicas", "template", b"template"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["minReadySeconds", b"minReadySeconds", "replicas", b"replicas", "selector", b"selector", "template", b"template"]) -> None: ...

global___ReplicationControllerSpec = ReplicationControllerSpec

@typing.final
class ReplicationControllerStatus(google.protobuf.message.Message):
    """ReplicationControllerStatus represents the current status of a replication
    controller.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REPLICAS_FIELD_NUMBER: builtins.int
    FULLYLABELEDREPLICAS_FIELD_NUMBER: builtins.int
    READYREPLICAS_FIELD_NUMBER: builtins.int
    AVAILABLEREPLICAS_FIELD_NUMBER: builtins.int
    OBSERVEDGENERATION_FIELD_NUMBER: builtins.int
    CONDITIONS_FIELD_NUMBER: builtins.int
    replicas: builtins.int
    """Replicas is the most recently oberved number of replicas.
    More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#what-is-a-replicationcontroller
    """
    fullyLabeledReplicas: builtins.int
    """The number of pods that have labels matching the labels of the pod template of the replication controller.
    +optional
    """
    readyReplicas: builtins.int
    """The number of ready replicas for this replication controller.
    +optional
    """
    availableReplicas: builtins.int
    """The number of available replicas (ready for at least minReadySeconds) for this replication controller.
    +optional
    """
    observedGeneration: builtins.int
    """ObservedGeneration reflects the generation of the most recently observed replication controller.
    +optional
    """
    @property
    def conditions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ReplicationControllerCondition]:
        """Represents the latest available observations of a replication controller's current state.
        +optional
        +patchMergeKey=type
        +patchStrategy=merge
        """

    def __init__(
        self,
        *,
        replicas: builtins.int | None = ...,
        fullyLabeledReplicas: builtins.int | None = ...,
        readyReplicas: builtins.int | None = ...,
        availableReplicas: builtins.int | None = ...,
        observedGeneration: builtins.int | None = ...,
        conditions: collections.abc.Iterable[global___ReplicationControllerCondition] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["availableReplicas", b"availableReplicas", "fullyLabeledReplicas", b"fullyLabeledReplicas", "observedGeneration", b"observedGeneration", "readyReplicas", b"readyReplicas", "replicas", b"replicas"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["availableReplicas", b"availableReplicas", "conditions", b"conditions", "fullyLabeledReplicas", b"fullyLabeledReplicas", "observedGeneration", b"observedGeneration", "readyReplicas", b"readyReplicas", "replicas", b"replicas"]) -> None: ...

global___ReplicationControllerStatus = ReplicationControllerStatus

@typing.final
class ResourceFieldSelector(google.protobuf.message.Message):
    """ResourceFieldSelector represents container resources (cpu, memory) and their output format
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CONTAINERNAME_FIELD_NUMBER: builtins.int
    RESOURCE_FIELD_NUMBER: builtins.int
    DIVISOR_FIELD_NUMBER: builtins.int
    containerName: builtins.str
    """Container name: required for volumes, optional for env vars
    +optional
    """
    resource: builtins.str
    """Required: resource to select"""
    @property
    def divisor(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity:
        """Specifies the output format of the exposed resources, defaults to "1"
        +optional
        """

    def __init__(
        self,
        *,
        containerName: builtins.str | None = ...,
        resource: builtins.str | None = ...,
        divisor: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["containerName", b"containerName", "divisor", b"divisor", "resource", b"resource"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["containerName", b"containerName", "divisor", b"divisor", "resource", b"resource"]) -> None: ...

global___ResourceFieldSelector = ResourceFieldSelector

@typing.final
class ResourceQuota(google.protobuf.message.Message):
    """ResourceQuota sets aggregate quota restrictions enforced per namespace"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SPEC_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def spec(self) -> global___ResourceQuotaSpec:
        """Spec defines the desired quota.
        https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    @property
    def status(self) -> global___ResourceQuotaStatus:
        """Status defines the actual enforced quota and its current usage.
        https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        spec: global___ResourceQuotaSpec | None = ...,
        status: global___ResourceQuotaStatus | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> None: ...

global___ResourceQuota = ResourceQuota

@typing.final
class ResourceQuotaList(google.protobuf.message.Message):
    """ResourceQuotaList is a list of ResourceQuota items."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ResourceQuota]:
        """Items is a list of ResourceQuota objects.
        More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___ResourceQuota] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___ResourceQuotaList = ResourceQuotaList

@typing.final
class ResourceQuotaSpec(google.protobuf.message.Message):
    """ResourceQuotaSpec defines the desired hard limits to enforce for Quota."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class HardEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    HARD_FIELD_NUMBER: builtins.int
    SCOPES_FIELD_NUMBER: builtins.int
    SCOPESELECTOR_FIELD_NUMBER: builtins.int
    @property
    def hard(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """hard is the set of desired hard limits for each named resource.
        More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/
        +optional
        """

    @property
    def scopes(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """A collection of filters that must match each object tracked by a quota.
        If not specified, the quota matches all objects.
        +optional
        """

    @property
    def scopeSelector(self) -> global___ScopeSelector:
        """scopeSelector is also a collection of filters like scopes that must match each object tracked by a quota
        but expressed using ScopeSelectorOperator in combination with possible values.
        For a resource to match, both scopes AND scopeSelector (if specified in spec), must be matched.
        +optional
        """

    def __init__(
        self,
        *,
        hard: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        scopes: collections.abc.Iterable[builtins.str] | None = ...,
        scopeSelector: global___ScopeSelector | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["scopeSelector", b"scopeSelector"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["hard", b"hard", "scopeSelector", b"scopeSelector", "scopes", b"scopes"]) -> None: ...

global___ResourceQuotaSpec = ResourceQuotaSpec

@typing.final
class ResourceQuotaStatus(google.protobuf.message.Message):
    """ResourceQuotaStatus defines the enforced hard limits and observed use."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class HardEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    @typing.final
    class UsedEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    HARD_FIELD_NUMBER: builtins.int
    USED_FIELD_NUMBER: builtins.int
    @property
    def hard(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Hard is the set of enforced hard limits for each named resource.
        More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/
        +optional
        """

    @property
    def used(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Used is the current observed total usage of the resource in the namespace.
        +optional
        """

    def __init__(
        self,
        *,
        hard: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        used: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["hard", b"hard", "used", b"used"]) -> None: ...

global___ResourceQuotaStatus = ResourceQuotaStatus

@typing.final
class ResourceRequirements(google.protobuf.message.Message):
    """ResourceRequirements describes the compute resource requirements."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class LimitsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    @typing.final
    class RequestsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity: ...
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    LIMITS_FIELD_NUMBER: builtins.int
    REQUESTS_FIELD_NUMBER: builtins.int
    @property
    def limits(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Limits describes the maximum amount of compute resources allowed.
        More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
        +optional
        """

    @property
    def requests(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity]:
        """Requests describes the minimum amount of compute resources required.
        If Requests is omitted for a container, it defaults to Limits if that is explicitly specified,
        otherwise to an implementation-defined value.
        More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/
        +optional
        """

    def __init__(
        self,
        *,
        limits: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
        requests: collections.abc.Mapping[builtins.str, armada_client.k8s.io.apimachinery.pkg.api.resource.generated_pb2.Quantity] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["limits", b"limits", "requests", b"requests"]) -> None: ...

global___ResourceRequirements = ResourceRequirements

@typing.final
class SELinuxOptions(google.protobuf.message.Message):
    """SELinuxOptions are the labels to be applied to the container"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    USER_FIELD_NUMBER: builtins.int
    ROLE_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    LEVEL_FIELD_NUMBER: builtins.int
    user: builtins.str
    """User is a SELinux user label that applies to the container.
    +optional
    """
    role: builtins.str
    """Role is a SELinux role label that applies to the container.
    +optional
    """
    type: builtins.str
    """Type is a SELinux type label that applies to the container.
    +optional
    """
    level: builtins.str
    """Level is SELinux level label that applies to the container.
    +optional
    """
    def __init__(
        self,
        *,
        user: builtins.str | None = ...,
        role: builtins.str | None = ...,
        type: builtins.str | None = ...,
        level: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["level", b"level", "role", b"role", "type", b"type", "user", b"user"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["level", b"level", "role", b"role", "type", b"type", "user", b"user"]) -> None: ...

global___SELinuxOptions = SELinuxOptions

@typing.final
class ScaleIOPersistentVolumeSource(google.protobuf.message.Message):
    """ScaleIOPersistentVolumeSource represents a persistent ScaleIO volume"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    GATEWAY_FIELD_NUMBER: builtins.int
    SYSTEM_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    SSLENABLED_FIELD_NUMBER: builtins.int
    PROTECTIONDOMAIN_FIELD_NUMBER: builtins.int
    STORAGEPOOL_FIELD_NUMBER: builtins.int
    STORAGEMODE_FIELD_NUMBER: builtins.int
    VOLUMENAME_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    gateway: builtins.str
    """The host address of the ScaleIO API Gateway."""
    system: builtins.str
    """The name of the storage system as configured in ScaleIO."""
    sslEnabled: builtins.bool
    """Flag to enable/disable SSL communication with Gateway, default false
    +optional
    """
    protectionDomain: builtins.str
    """The name of the ScaleIO Protection Domain for the configured storage.
    +optional
    """
    storagePool: builtins.str
    """The ScaleIO Storage Pool associated with the protection domain.
    +optional
    """
    storageMode: builtins.str
    """Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.
    Default is ThinProvisioned.
    +optional
    """
    volumeName: builtins.str
    """The name of a volume already created in the ScaleIO system
    that is associated with this volume source.
    """
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs".
    Default is "xfs"
    +optional
    """
    readOnly: builtins.bool
    """Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    +optional
    """
    @property
    def secretRef(self) -> global___SecretReference:
        """SecretRef references to the secret for ScaleIO user and other
        sensitive information. If this is not provided, Login operation will fail.
        """

    def __init__(
        self,
        *,
        gateway: builtins.str | None = ...,
        system: builtins.str | None = ...,
        secretRef: global___SecretReference | None = ...,
        sslEnabled: builtins.bool | None = ...,
        protectionDomain: builtins.str | None = ...,
        storagePool: builtins.str | None = ...,
        storageMode: builtins.str | None = ...,
        volumeName: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "gateway", b"gateway", "protectionDomain", b"protectionDomain", "readOnly", b"readOnly", "secretRef", b"secretRef", "sslEnabled", b"sslEnabled", "storageMode", b"storageMode", "storagePool", b"storagePool", "system", b"system", "volumeName", b"volumeName"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "gateway", b"gateway", "protectionDomain", b"protectionDomain", "readOnly", b"readOnly", "secretRef", b"secretRef", "sslEnabled", b"sslEnabled", "storageMode", b"storageMode", "storagePool", b"storagePool", "system", b"system", "volumeName", b"volumeName"]) -> None: ...

global___ScaleIOPersistentVolumeSource = ScaleIOPersistentVolumeSource

@typing.final
class ScaleIOVolumeSource(google.protobuf.message.Message):
    """ScaleIOVolumeSource represents a persistent ScaleIO volume"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    GATEWAY_FIELD_NUMBER: builtins.int
    SYSTEM_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    SSLENABLED_FIELD_NUMBER: builtins.int
    PROTECTIONDOMAIN_FIELD_NUMBER: builtins.int
    STORAGEPOOL_FIELD_NUMBER: builtins.int
    STORAGEMODE_FIELD_NUMBER: builtins.int
    VOLUMENAME_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    gateway: builtins.str
    """The host address of the ScaleIO API Gateway."""
    system: builtins.str
    """The name of the storage system as configured in ScaleIO."""
    sslEnabled: builtins.bool
    """Flag to enable/disable SSL communication with Gateway, default false
    +optional
    """
    protectionDomain: builtins.str
    """The name of the ScaleIO Protection Domain for the configured storage.
    +optional
    """
    storagePool: builtins.str
    """The ScaleIO Storage Pool associated with the protection domain.
    +optional
    """
    storageMode: builtins.str
    """Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.
    Default is ThinProvisioned.
    +optional
    """
    volumeName: builtins.str
    """The name of a volume already created in the ScaleIO system
    that is associated with this volume source.
    """
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs".
    Default is "xfs".
    +optional
    """
    readOnly: builtins.bool
    """Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    +optional
    """
    @property
    def secretRef(self) -> global___LocalObjectReference:
        """SecretRef references to the secret for ScaleIO user and other
        sensitive information. If this is not provided, Login operation will fail.
        """

    def __init__(
        self,
        *,
        gateway: builtins.str | None = ...,
        system: builtins.str | None = ...,
        secretRef: global___LocalObjectReference | None = ...,
        sslEnabled: builtins.bool | None = ...,
        protectionDomain: builtins.str | None = ...,
        storagePool: builtins.str | None = ...,
        storageMode: builtins.str | None = ...,
        volumeName: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "gateway", b"gateway", "protectionDomain", b"protectionDomain", "readOnly", b"readOnly", "secretRef", b"secretRef", "sslEnabled", b"sslEnabled", "storageMode", b"storageMode", "storagePool", b"storagePool", "system", b"system", "volumeName", b"volumeName"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "gateway", b"gateway", "protectionDomain", b"protectionDomain", "readOnly", b"readOnly", "secretRef", b"secretRef", "sslEnabled", b"sslEnabled", "storageMode", b"storageMode", "storagePool", b"storagePool", "system", b"system", "volumeName", b"volumeName"]) -> None: ...

global___ScaleIOVolumeSource = ScaleIOVolumeSource

@typing.final
class ScopeSelector(google.protobuf.message.Message):
    """A scope selector represents the AND of the selectors represented
    by the scoped-resource selector requirements.
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MATCHEXPRESSIONS_FIELD_NUMBER: builtins.int
    @property
    def matchExpressions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ScopedResourceSelectorRequirement]:
        """A list of scope selector requirements by scope of the resources.
        +optional
        """

    def __init__(
        self,
        *,
        matchExpressions: collections.abc.Iterable[global___ScopedResourceSelectorRequirement] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["matchExpressions", b"matchExpressions"]) -> None: ...

global___ScopeSelector = ScopeSelector

@typing.final
class ScopedResourceSelectorRequirement(google.protobuf.message.Message):
    """A scoped-resource selector requirement is a selector that contains values, a scope name, and an operator
    that relates the scope name and values.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SCOPENAME_FIELD_NUMBER: builtins.int
    OPERATOR_FIELD_NUMBER: builtins.int
    VALUES_FIELD_NUMBER: builtins.int
    scopeName: builtins.str
    """The name of the scope that the selector applies to."""
    operator: builtins.str
    """Represents a scope's relationship to a set of values.
    Valid operators are In, NotIn, Exists, DoesNotExist.
    """
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """An array of string values. If the operator is In or NotIn,
        the values array must be non-empty. If the operator is Exists or DoesNotExist,
        the values array must be empty.
        This array is replaced during a strategic merge patch.
        +optional
        """

    def __init__(
        self,
        *,
        scopeName: builtins.str | None = ...,
        operator: builtins.str | None = ...,
        values: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["operator", b"operator", "scopeName", b"scopeName"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["operator", b"operator", "scopeName", b"scopeName", "values", b"values"]) -> None: ...

global___ScopedResourceSelectorRequirement = ScopedResourceSelectorRequirement

@typing.final
class SeccompProfile(google.protobuf.message.Message):
    """SeccompProfile defines a pod/container's seccomp profile settings.
    Only one profile source may be set.
    +union
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    LOCALHOSTPROFILE_FIELD_NUMBER: builtins.int
    type: builtins.str
    """type indicates which kind of seccomp profile will be applied.
    Valid options are:

    Localhost - a profile defined in a file on the node should be used.
    RuntimeDefault - the container runtime default profile should be used.
    Unconfined - no profile should be applied.
    +unionDiscriminator
    """
    localhostProfile: builtins.str
    """localhostProfile indicates a profile defined in a file on the node should be used.
    The profile must be preconfigured on the node to work.
    Must be a descending path, relative to the kubelet's configured seccomp profile location.
    Must only be set if type is "Localhost".
    +optional
    """
    def __init__(
        self,
        *,
        type: builtins.str | None = ...,
        localhostProfile: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["localhostProfile", b"localhostProfile", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["localhostProfile", b"localhostProfile", "type", b"type"]) -> None: ...

global___SeccompProfile = SeccompProfile

@typing.final
class Secret(google.protobuf.message.Message):
    """Secret holds secret data of a certain type. The total bytes of the values in
    the Data field must be less than MaxSecretSize bytes.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class DataEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.bytes
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: builtins.bytes | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    @typing.final
    class StringDataEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: builtins.str | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    METADATA_FIELD_NUMBER: builtins.int
    IMMUTABLE_FIELD_NUMBER: builtins.int
    DATA_FIELD_NUMBER: builtins.int
    STRINGDATA_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    immutable: builtins.bool
    """Immutable, if set to true, ensures that data stored in the Secret cannot
    be updated (only object metadata can be modified).
    If not set to true, the field can be modified at any time.
    Defaulted to nil.
    +optional
    """
    type: builtins.str
    """Used to facilitate programmatic handling of secret data.
    +optional
    """
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def data(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.bytes]:
        """Data contains the secret data. Each key must consist of alphanumeric
        characters, '-', '_' or '.'. The serialized form of the secret data is a
        base64 encoded string, representing the arbitrary (possibly non-string)
        data value here. Described in https://tools.ietf.org/html/rfc4648#section-4
        +optional
        """

    @property
    def stringData(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """stringData allows specifying non-binary secret data in string form.
        It is provided as a write-only input field for convenience.
        All keys and values are merged into the data field on write, overwriting any existing values.
        The stringData field is never output when reading from the API.
        +k8s:conversion-gen=false
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        immutable: builtins.bool | None = ...,
        data: collections.abc.Mapping[builtins.str, builtins.bytes] | None = ...,
        stringData: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        type: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["immutable", b"immutable", "metadata", b"metadata", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["data", b"data", "immutable", b"immutable", "metadata", b"metadata", "stringData", b"stringData", "type", b"type"]) -> None: ...

global___Secret = Secret

@typing.final
class SecretEnvSource(google.protobuf.message.Message):
    """SecretEnvSource selects a Secret to populate the environment
    variables with.

    The contents of the target Secret's Data field will represent the
    key-value pairs as environment variables.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LOCALOBJECTREFERENCE_FIELD_NUMBER: builtins.int
    OPTIONAL_FIELD_NUMBER: builtins.int
    optional: builtins.bool
    """Specify whether the Secret must be defined
    +optional
    """
    @property
    def localObjectReference(self) -> global___LocalObjectReference:
        """The Secret to select from."""

    def __init__(
        self,
        *,
        localObjectReference: global___LocalObjectReference | None = ...,
        optional: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["localObjectReference", b"localObjectReference", "optional", b"optional"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["localObjectReference", b"localObjectReference", "optional", b"optional"]) -> None: ...

global___SecretEnvSource = SecretEnvSource

@typing.final
class SecretKeySelector(google.protobuf.message.Message):
    """SecretKeySelector selects a key of a Secret.
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LOCALOBJECTREFERENCE_FIELD_NUMBER: builtins.int
    KEY_FIELD_NUMBER: builtins.int
    OPTIONAL_FIELD_NUMBER: builtins.int
    key: builtins.str
    """The key of the secret to select from.  Must be a valid secret key."""
    optional: builtins.bool
    """Specify whether the Secret or its key must be defined
    +optional
    """
    @property
    def localObjectReference(self) -> global___LocalObjectReference:
        """The name of the secret in the pod's namespace to select from."""

    def __init__(
        self,
        *,
        localObjectReference: global___LocalObjectReference | None = ...,
        key: builtins.str | None = ...,
        optional: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "localObjectReference", b"localObjectReference", "optional", b"optional"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "localObjectReference", b"localObjectReference", "optional", b"optional"]) -> None: ...

global___SecretKeySelector = SecretKeySelector

@typing.final
class SecretList(google.protobuf.message.Message):
    """SecretList is a list of Secret."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Secret]:
        """Items is a list of secret objects.
        More info: https://kubernetes.io/docs/concepts/configuration/secret
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___Secret] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___SecretList = SecretList

@typing.final
class SecretProjection(google.protobuf.message.Message):
    """Adapts a secret into a projected volume.

    The contents of the target Secret's Data field will be presented in a
    projected volume as files using the keys in the Data field as the file names.
    Note that this is identical to a secret volume source without the default
    mode.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LOCALOBJECTREFERENCE_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    OPTIONAL_FIELD_NUMBER: builtins.int
    optional: builtins.bool
    """Specify whether the Secret or its key must be defined
    +optional
    """
    @property
    def localObjectReference(self) -> global___LocalObjectReference: ...
    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___KeyToPath]:
        """If unspecified, each key-value pair in the Data field of the referenced
        Secret will be projected into the volume as a file whose name is the
        key and content is the value. If specified, the listed keys will be
        projected into the specified paths, and unlisted keys will not be
        present. If a key is specified which is not present in the Secret,
        the volume setup will error unless it is marked optional. Paths must be
        relative and may not contain the '..' path or start with '..'.
        +optional
        """

    def __init__(
        self,
        *,
        localObjectReference: global___LocalObjectReference | None = ...,
        items: collections.abc.Iterable[global___KeyToPath] | None = ...,
        optional: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["localObjectReference", b"localObjectReference", "optional", b"optional"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "localObjectReference", b"localObjectReference", "optional", b"optional"]) -> None: ...

global___SecretProjection = SecretProjection

@typing.final
class SecretReference(google.protobuf.message.Message):
    """SecretReference represents a Secret Reference. It has enough information to retrieve secret
    in any namespace
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    NAMESPACE_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Name is unique within a namespace to reference a secret resource.
    +optional
    """
    namespace: builtins.str
    """Namespace defines the space within which the secret name must be unique.
    +optional
    """
    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        namespace: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["name", b"name", "namespace", b"namespace"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "namespace", b"namespace"]) -> None: ...

global___SecretReference = SecretReference

@typing.final
class SecretVolumeSource(google.protobuf.message.Message):
    """Adapts a Secret into a volume.

    The contents of the target Secret's Data field will be presented in a volume
    as files using the keys in the Data field as the file names.
    Secret volumes support ownership management and SELinux relabeling.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SECRETNAME_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    DEFAULTMODE_FIELD_NUMBER: builtins.int
    OPTIONAL_FIELD_NUMBER: builtins.int
    secretName: builtins.str
    """Name of the secret in the pod's namespace to use.
    More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
    +optional
    """
    defaultMode: builtins.int
    """Optional: mode bits used to set permissions on created files by default.
    Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511.
    YAML accepts both octal and decimal values, JSON requires decimal values
    for mode bits. Defaults to 0644.
    Directories within the path are not affected by this setting.
    This might be in conflict with other options that affect the file
    mode, like fsGroup, and the result can be other mode bits set.
    +optional
    """
    optional: builtins.bool
    """Specify whether the Secret or its keys must be defined
    +optional
    """
    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___KeyToPath]:
        """If unspecified, each key-value pair in the Data field of the referenced
        Secret will be projected into the volume as a file whose name is the
        key and content is the value. If specified, the listed keys will be
        projected into the specified paths, and unlisted keys will not be
        present. If a key is specified which is not present in the Secret,
        the volume setup will error unless it is marked optional. Paths must be
        relative and may not contain the '..' path or start with '..'.
        +optional
        """

    def __init__(
        self,
        *,
        secretName: builtins.str | None = ...,
        items: collections.abc.Iterable[global___KeyToPath] | None = ...,
        defaultMode: builtins.int | None = ...,
        optional: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["defaultMode", b"defaultMode", "optional", b"optional", "secretName", b"secretName"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["defaultMode", b"defaultMode", "items", b"items", "optional", b"optional", "secretName", b"secretName"]) -> None: ...

global___SecretVolumeSource = SecretVolumeSource

@typing.final
class SecurityContext(google.protobuf.message.Message):
    """SecurityContext holds security configuration that will be applied to a container.
    Some fields are present in both SecurityContext and PodSecurityContext.  When both
    are set, the values in SecurityContext take precedence.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CAPABILITIES_FIELD_NUMBER: builtins.int
    PRIVILEGED_FIELD_NUMBER: builtins.int
    SELINUXOPTIONS_FIELD_NUMBER: builtins.int
    WINDOWSOPTIONS_FIELD_NUMBER: builtins.int
    RUNASUSER_FIELD_NUMBER: builtins.int
    RUNASGROUP_FIELD_NUMBER: builtins.int
    RUNASNONROOT_FIELD_NUMBER: builtins.int
    READONLYROOTFILESYSTEM_FIELD_NUMBER: builtins.int
    ALLOWPRIVILEGEESCALATION_FIELD_NUMBER: builtins.int
    PROCMOUNT_FIELD_NUMBER: builtins.int
    SECCOMPPROFILE_FIELD_NUMBER: builtins.int
    privileged: builtins.bool
    """Run container in privileged mode.
    Processes in privileged containers are essentially equivalent to root on the host.
    Defaults to false.
    +optional
    """
    runAsUser: builtins.int
    """The UID to run the entrypoint of the container process.
    Defaults to user specified in image metadata if unspecified.
    May also be set in PodSecurityContext.  If set in both SecurityContext and
    PodSecurityContext, the value specified in SecurityContext takes precedence.
    +optional
    """
    runAsGroup: builtins.int
    """The GID to run the entrypoint of the container process.
    Uses runtime default if unset.
    May also be set in PodSecurityContext.  If set in both SecurityContext and
    PodSecurityContext, the value specified in SecurityContext takes precedence.
    +optional
    """
    runAsNonRoot: builtins.bool
    """Indicates that the container must run as a non-root user.
    If true, the Kubelet will validate the image at runtime to ensure that it
    does not run as UID 0 (root) and fail to start the container if it does.
    If unset or false, no such validation will be performed.
    May also be set in PodSecurityContext.  If set in both SecurityContext and
    PodSecurityContext, the value specified in SecurityContext takes precedence.
    +optional
    """
    readOnlyRootFilesystem: builtins.bool
    """Whether this container has a read-only root filesystem.
    Default is false.
    +optional
    """
    allowPrivilegeEscalation: builtins.bool
    """AllowPrivilegeEscalation controls whether a process can gain more
    privileges than its parent process. This bool directly controls if
    the no_new_privs flag will be set on the container process.
    AllowPrivilegeEscalation is true always when the container is:
    1) run as Privileged
    2) has CAP_SYS_ADMIN
    +optional
    """
    procMount: builtins.str
    """procMount denotes the type of proc mount to use for the containers.
    The default is DefaultProcMount which uses the container runtime defaults for
    readonly paths and masked paths.
    This requires the ProcMountType feature flag to be enabled.
    +optional
    """
    @property
    def capabilities(self) -> global___Capabilities:
        """The capabilities to add/drop when running containers.
        Defaults to the default set of capabilities granted by the container runtime.
        +optional
        """

    @property
    def seLinuxOptions(self) -> global___SELinuxOptions:
        """The SELinux context to be applied to the container.
        If unspecified, the container runtime will allocate a random SELinux context for each
        container.  May also be set in PodSecurityContext.  If set in both SecurityContext and
        PodSecurityContext, the value specified in SecurityContext takes precedence.
        +optional
        """

    @property
    def windowsOptions(self) -> global___WindowsSecurityContextOptions:
        """The Windows specific settings applied to all containers.
        If unspecified, the options from the PodSecurityContext will be used.
        If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.
        +optional
        """

    @property
    def seccompProfile(self) -> global___SeccompProfile:
        """The seccomp options to use by this container. If seccomp options are
        provided at both the pod & container level, the container options
        override the pod options.
        +optional
        """

    def __init__(
        self,
        *,
        capabilities: global___Capabilities | None = ...,
        privileged: builtins.bool | None = ...,
        seLinuxOptions: global___SELinuxOptions | None = ...,
        windowsOptions: global___WindowsSecurityContextOptions | None = ...,
        runAsUser: builtins.int | None = ...,
        runAsGroup: builtins.int | None = ...,
        runAsNonRoot: builtins.bool | None = ...,
        readOnlyRootFilesystem: builtins.bool | None = ...,
        allowPrivilegeEscalation: builtins.bool | None = ...,
        procMount: builtins.str | None = ...,
        seccompProfile: global___SeccompProfile | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["allowPrivilegeEscalation", b"allowPrivilegeEscalation", "capabilities", b"capabilities", "privileged", b"privileged", "procMount", b"procMount", "readOnlyRootFilesystem", b"readOnlyRootFilesystem", "runAsGroup", b"runAsGroup", "runAsNonRoot", b"runAsNonRoot", "runAsUser", b"runAsUser", "seLinuxOptions", b"seLinuxOptions", "seccompProfile", b"seccompProfile", "windowsOptions", b"windowsOptions"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["allowPrivilegeEscalation", b"allowPrivilegeEscalation", "capabilities", b"capabilities", "privileged", b"privileged", "procMount", b"procMount", "readOnlyRootFilesystem", b"readOnlyRootFilesystem", "runAsGroup", b"runAsGroup", "runAsNonRoot", b"runAsNonRoot", "runAsUser", b"runAsUser", "seLinuxOptions", b"seLinuxOptions", "seccompProfile", b"seccompProfile", "windowsOptions", b"windowsOptions"]) -> None: ...

global___SecurityContext = SecurityContext

@typing.final
class SerializedReference(google.protobuf.message.Message):
    """SerializedReference is a reference to serialized object."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REFERENCE_FIELD_NUMBER: builtins.int
    @property
    def reference(self) -> global___ObjectReference:
        """The reference to an object in the system.
        +optional
        """

    def __init__(
        self,
        *,
        reference: global___ObjectReference | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["reference", b"reference"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["reference", b"reference"]) -> None: ...

global___SerializedReference = SerializedReference

@typing.final
class Service(google.protobuf.message.Message):
    """Service is a named abstraction of software service (for example, mysql) consisting of local port
    (for example 3306) that the proxy listens on, and the selector that determines which pods
    will answer requests sent through the proxy.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SPEC_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def spec(self) -> global___ServiceSpec:
        """Spec defines the behavior of a service.
        https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    @property
    def status(self) -> global___ServiceStatus:
        """Most recently observed status of the service.
        Populated by the system.
        Read-only.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        spec: global___ServiceSpec | None = ...,
        status: global___ServiceStatus | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["metadata", b"metadata", "spec", b"spec", "status", b"status"]) -> None: ...

global___Service = Service

@typing.final
class ServiceAccount(google.protobuf.message.Message):
    """ServiceAccount binds together:
    * a name, understood by users, and perhaps by peripheral systems, for an identity
    * a principal that can be authenticated and authorized
    * a set of secrets
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    SECRETS_FIELD_NUMBER: builtins.int
    IMAGEPULLSECRETS_FIELD_NUMBER: builtins.int
    AUTOMOUNTSERVICEACCOUNTTOKEN_FIELD_NUMBER: builtins.int
    automountServiceAccountToken: builtins.bool
    """AutomountServiceAccountToken indicates whether pods running as this service account should have an API token automatically mounted.
    Can be overridden at the pod level.
    +optional
    """
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta:
        """Standard object's metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
        +optional
        """

    @property
    def secrets(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ObjectReference]:
        """Secrets is the list of secrets allowed to be used by pods running using this ServiceAccount.
        More info: https://kubernetes.io/docs/concepts/configuration/secret
        +optional
        +patchMergeKey=name
        +patchStrategy=merge
        """

    @property
    def imagePullSecrets(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___LocalObjectReference]:
        """ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images
        in pods that reference this ServiceAccount. ImagePullSecrets are distinct from Secrets because Secrets
        can be mounted in the pod, but ImagePullSecrets are only accessed by the kubelet.
        More info: https://kubernetes.io/docs/concepts/containers/images/#specifying-imagepullsecrets-on-a-pod
        +optional
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ObjectMeta | None = ...,
        secrets: collections.abc.Iterable[global___ObjectReference] | None = ...,
        imagePullSecrets: collections.abc.Iterable[global___LocalObjectReference] | None = ...,
        automountServiceAccountToken: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["automountServiceAccountToken", b"automountServiceAccountToken", "metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["automountServiceAccountToken", b"automountServiceAccountToken", "imagePullSecrets", b"imagePullSecrets", "metadata", b"metadata", "secrets", b"secrets"]) -> None: ...

global___ServiceAccount = ServiceAccount

@typing.final
class ServiceAccountList(google.protobuf.message.Message):
    """ServiceAccountList is a list of ServiceAccount objects"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ServiceAccount]:
        """List of ServiceAccounts.
        More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/
        """

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___ServiceAccount] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___ServiceAccountList = ServiceAccountList

@typing.final
class ServiceAccountTokenProjection(google.protobuf.message.Message):
    """ServiceAccountTokenProjection represents a projected service account token
    volume. This projection can be used to insert a service account token into
    the pods runtime filesystem for use against APIs (Kubernetes API Server or
    otherwise).
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUDIENCE_FIELD_NUMBER: builtins.int
    EXPIRATIONSECONDS_FIELD_NUMBER: builtins.int
    PATH_FIELD_NUMBER: builtins.int
    audience: builtins.str
    """Audience is the intended audience of the token. A recipient of a token
    must identify itself with an identifier specified in the audience of the
    token, and otherwise should reject the token. The audience defaults to the
    identifier of the apiserver.
    +optional
    """
    expirationSeconds: builtins.int
    """ExpirationSeconds is the requested duration of validity of the service
    account token. As the token approaches expiration, the kubelet volume
    plugin will proactively rotate the service account token. The kubelet will
    start trying to rotate the token if the token is older than 80 percent of
    its time to live or if the token is older than 24 hours.Defaults to 1 hour
    and must be at least 10 minutes.
    +optional
    """
    path: builtins.str
    """Path is the path relative to the mount point of the file to project the
    token into.
    """
    def __init__(
        self,
        *,
        audience: builtins.str | None = ...,
        expirationSeconds: builtins.int | None = ...,
        path: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["audience", b"audience", "expirationSeconds", b"expirationSeconds", "path", b"path"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["audience", b"audience", "expirationSeconds", b"expirationSeconds", "path", b"path"]) -> None: ...

global___ServiceAccountTokenProjection = ServiceAccountTokenProjection

@typing.final
class ServiceList(google.protobuf.message.Message):
    """ServiceList holds a list of services."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METADATA_FIELD_NUMBER: builtins.int
    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def metadata(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta:
        """Standard list metadata.
        More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
        +optional
        """

    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Service]:
        """List of services"""

    def __init__(
        self,
        *,
        metadata: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.ListMeta | None = ...,
        items: collections.abc.Iterable[global___Service] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["metadata", b"metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["items", b"items", "metadata", b"metadata"]) -> None: ...

global___ServiceList = ServiceList

@typing.final
class ServicePort(google.protobuf.message.Message):
    """ServicePort contains information on service's port."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    PROTOCOL_FIELD_NUMBER: builtins.int
    APPPROTOCOL_FIELD_NUMBER: builtins.int
    PORT_FIELD_NUMBER: builtins.int
    TARGETPORT_FIELD_NUMBER: builtins.int
    NODEPORT_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The name of this port within the service. This must be a DNS_LABEL.
    All ports within a ServiceSpec must have unique names. When considering
    the endpoints for a Service, this must match the 'name' field in the
    EndpointPort.
    Optional if only one ServicePort is defined on this service.
    +optional
    """
    protocol: builtins.str
    """The IP protocol for this port. Supports "TCP", "UDP", and "SCTP".
    Default is TCP.
    +default="TCP"
    +optional
    """
    appProtocol: builtins.str
    """The application protocol for this port.
    This field follows standard Kubernetes label syntax.
    Un-prefixed names are reserved for IANA standard service names (as per
    RFC-6335 and http://www.iana.org/assignments/service-names).
    Non-standard protocols should use prefixed names such as
    mycompany.com/my-custom-protocol.
    +optional
    """
    port: builtins.int
    """The port that will be exposed by this service."""
    nodePort: builtins.int
    """The port on each node on which this service is exposed when type is
    NodePort or LoadBalancer.  Usually assigned by the system. If a value is
    specified, in-range, and not in use it will be used, otherwise the
    operation will fail.  If not specified, a port will be allocated if this
    Service requires one.  If this field is specified when creating a
    Service which does not need it, creation will fail. This field will be
    wiped when updating a Service to no longer need it (e.g. changing type
    from NodePort to ClusterIP).
    More info: https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport
    +optional
    """
    @property
    def targetPort(self) -> armada_client.k8s.io.apimachinery.pkg.util.intstr.generated_pb2.IntOrString:
        """Number or name of the port to access on the pods targeted by the service.
        Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.
        If this is a string, it will be looked up as a named port in the
        target Pod's container ports. If this is not specified, the value
        of the 'port' field is used (an identity map).
        This field is ignored for services with clusterIP=None, and should be
        omitted or set equal to the 'port' field.
        More info: https://kubernetes.io/docs/concepts/services-networking/service/#defining-a-service
        +optional
        """

    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        protocol: builtins.str | None = ...,
        appProtocol: builtins.str | None = ...,
        port: builtins.int | None = ...,
        targetPort: armada_client.k8s.io.apimachinery.pkg.util.intstr.generated_pb2.IntOrString | None = ...,
        nodePort: builtins.int | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["appProtocol", b"appProtocol", "name", b"name", "nodePort", b"nodePort", "port", b"port", "protocol", b"protocol", "targetPort", b"targetPort"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["appProtocol", b"appProtocol", "name", b"name", "nodePort", b"nodePort", "port", b"port", "protocol", b"protocol", "targetPort", b"targetPort"]) -> None: ...

global___ServicePort = ServicePort

@typing.final
class ServiceProxyOptions(google.protobuf.message.Message):
    """ServiceProxyOptions is the query options to a Service's proxy call."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PATH_FIELD_NUMBER: builtins.int
    path: builtins.str
    """Path is the part of URLs that include service endpoints, suffixes,
    and parameters to use for the current proxy request to service.
    For example, the whole request URL is
    http://localhost/api/v1/namespaces/kube-system/services/elasticsearch-logging/_search?q=user:kimchy.
    Path is _search?q=user:kimchy.
    +optional
    """
    def __init__(
        self,
        *,
        path: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["path", b"path"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["path", b"path"]) -> None: ...

global___ServiceProxyOptions = ServiceProxyOptions

@typing.final
class ServiceSpec(google.protobuf.message.Message):
    """ServiceSpec describes the attributes that a user creates on a service."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class SelectorEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str | None = ...,
            value: builtins.str | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    PORTS_FIELD_NUMBER: builtins.int
    SELECTOR_FIELD_NUMBER: builtins.int
    CLUSTERIP_FIELD_NUMBER: builtins.int
    CLUSTERIPS_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    EXTERNALIPS_FIELD_NUMBER: builtins.int
    SESSIONAFFINITY_FIELD_NUMBER: builtins.int
    LOADBALANCERIP_FIELD_NUMBER: builtins.int
    LOADBALANCERSOURCERANGES_FIELD_NUMBER: builtins.int
    EXTERNALNAME_FIELD_NUMBER: builtins.int
    EXTERNALTRAFFICPOLICY_FIELD_NUMBER: builtins.int
    HEALTHCHECKNODEPORT_FIELD_NUMBER: builtins.int
    PUBLISHNOTREADYADDRESSES_FIELD_NUMBER: builtins.int
    SESSIONAFFINITYCONFIG_FIELD_NUMBER: builtins.int
    IPFAMILIES_FIELD_NUMBER: builtins.int
    IPFAMILYPOLICY_FIELD_NUMBER: builtins.int
    ALLOCATELOADBALANCERNODEPORTS_FIELD_NUMBER: builtins.int
    LOADBALANCERCLASS_FIELD_NUMBER: builtins.int
    INTERNALTRAFFICPOLICY_FIELD_NUMBER: builtins.int
    clusterIP: builtins.str
    """clusterIP is the IP address of the service and is usually assigned
    randomly. If an address is specified manually, is in-range (as per
    system configuration), and is not in use, it will be allocated to the
    service; otherwise creation of the service will fail. This field may not
    be changed through updates unless the type field is also being changed
    to ExternalName (which requires this field to be blank) or the type
    field is being changed from ExternalName (in which case this field may
    optionally be specified, as describe above).  Valid values are "None",
    empty string (""), or a valid IP address. Setting this to "None" makes a
    "headless service" (no virtual IP), which is useful when direct endpoint
    connections are preferred and proxying is not required.  Only applies to
    types ClusterIP, NodePort, and LoadBalancer. If this field is specified
    when creating a Service of type ExternalName, creation will fail. This
    field will be wiped when updating a Service to type ExternalName.
    More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies
    +optional
    """
    type: builtins.str
    """type determines how the Service is exposed. Defaults to ClusterIP. Valid
    options are ExternalName, ClusterIP, NodePort, and LoadBalancer.
    "ClusterIP" allocates a cluster-internal IP address for load-balancing
    to endpoints. Endpoints are determined by the selector or if that is not
    specified, by manual construction of an Endpoints object or
    EndpointSlice objects. If clusterIP is "None", no virtual IP is
    allocated and the endpoints are published as a set of endpoints rather
    than a virtual IP.
    "NodePort" builds on ClusterIP and allocates a port on every node which
    routes to the same endpoints as the clusterIP.
    "LoadBalancer" builds on NodePort and creates an external load-balancer
    (if supported in the current cloud) which routes to the same endpoints
    as the clusterIP.
    "ExternalName" aliases this service to the specified externalName.
    Several other fields do not apply to ExternalName services.
    More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services-service-types
    +optional
    """
    sessionAffinity: builtins.str
    """Supports "ClientIP" and "None". Used to maintain session affinity.
    Enable client IP based session affinity.
    Must be ClientIP or None.
    Defaults to None.
    More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies
    +optional
    """
    loadBalancerIP: builtins.str
    """Only applies to Service Type: LoadBalancer
    LoadBalancer will get created with the IP specified in this field.
    This feature depends on whether the underlying cloud-provider supports specifying
    the loadBalancerIP when a load balancer is created.
    This field will be ignored if the cloud-provider does not support the feature.
    +optional
    """
    externalName: builtins.str
    """externalName is the external reference that discovery mechanisms will
    return as an alias for this service (e.g. a DNS CNAME record). No
    proxying will be involved.  Must be a lowercase RFC-1123 hostname
    (https://tools.ietf.org/html/rfc1123) and requires `type` to be "ExternalName".
    +optional
    """
    externalTrafficPolicy: builtins.str
    """externalTrafficPolicy denotes if this Service desires to route external
    traffic to node-local or cluster-wide endpoints. "Local" preserves the
    client source IP and avoids a second hop for LoadBalancer and Nodeport
    type services, but risks potentially imbalanced traffic spreading.
    "Cluster" obscures the client source IP and may cause a second hop to
    another node, but should have good overall load-spreading.
    +optional
    """
    healthCheckNodePort: builtins.int
    """healthCheckNodePort specifies the healthcheck nodePort for the service.
    This only applies when type is set to LoadBalancer and
    externalTrafficPolicy is set to Local. If a value is specified, is
    in-range, and is not in use, it will be used.  If not specified, a value
    will be automatically allocated.  External systems (e.g. load-balancers)
    can use this port to determine if a given node holds endpoints for this
    service or not.  If this field is specified when creating a Service
    which does not need it, creation will fail. This field will be wiped
    when updating a Service to no longer need it (e.g. changing type).
    +optional
    """
    publishNotReadyAddresses: builtins.bool
    """publishNotReadyAddresses indicates that any agent which deals with endpoints for this
    Service should disregard any indications of ready/not-ready.
    The primary use case for setting this field is for a StatefulSet's Headless Service to
    propagate SRV DNS records for its Pods for the purpose of peer discovery.
    The Kubernetes controllers that generate Endpoints and EndpointSlice resources for
    Services interpret this to mean that all endpoints are considered "ready" even if the
    Pods themselves are not. Agents which consume only Kubernetes generated endpoints
    through the Endpoints or EndpointSlice resources can safely assume this behavior.
    +optional
    """
    ipFamilyPolicy: builtins.str
    """IPFamilyPolicy represents the dual-stack-ness requested or required by
    this Service, and is gated by the "IPv6DualStack" feature gate.  If
    there is no value provided, then this field will be set to SingleStack.
    Services can be "SingleStack" (a single IP family), "PreferDualStack"
    (two IP families on dual-stack configured clusters or a single IP family
    on single-stack clusters), or "RequireDualStack" (two IP families on
    dual-stack configured clusters, otherwise fail). The ipFamilies and
    clusterIPs fields depend on the value of this field.  This field will be
    wiped when updating a service to type ExternalName.
    +optional
    """
    allocateLoadBalancerNodePorts: builtins.bool
    """allocateLoadBalancerNodePorts defines if NodePorts will be automatically
    allocated for services with type LoadBalancer.  Default is "true". It
    may be set to "false" if the cluster load-balancer does not rely on
    NodePorts.  If the caller requests specific NodePorts (by specifying a
    value), those requests will be respected, regardless of this field.
    This field may only be set for services with type LoadBalancer and will
    be cleared if the type is changed to any other type.
    This field is beta-level and is only honored by servers that enable the ServiceLBNodePortControl feature.
    +featureGate=ServiceLBNodePortControl
    +optional
    """
    loadBalancerClass: builtins.str
    """loadBalancerClass is the class of the load balancer implementation this Service belongs to.
    If specified, the value of this field must be a label-style identifier, with an optional prefix,
    e.g. "internal-vip" or "example.com/internal-vip". Unprefixed names are reserved for end-users.
    This field can only be set when the Service type is 'LoadBalancer'. If not set, the default load
    balancer implementation is used, today this is typically done through the cloud provider integration,
    but should apply for any default implementation. If set, it is assumed that a load balancer
    implementation is watching for Services with a matching class. Any default load balancer
    implementation (e.g. cloud providers) should ignore Services that set this field.
    This field can only be set when creating or updating a Service to type 'LoadBalancer'.
    Once set, it can not be changed. This field will be wiped when a service is updated to a non 'LoadBalancer' type.
    +featureGate=LoadBalancerClass
    +optional
    """
    internalTrafficPolicy: builtins.str
    """InternalTrafficPolicy specifies if the cluster internal traffic
    should be routed to all endpoints or node-local endpoints only.
    "Cluster" routes internal traffic to a Service to all endpoints.
    "Local" routes traffic to node-local endpoints only, traffic is
    dropped if no node-local endpoints are ready.
    The default value is "Cluster".
    +featureGate=ServiceInternalTrafficPolicy
    +optional
    """
    @property
    def ports(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ServicePort]:
        """The list of ports that are exposed by this service.
        More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies
        +patchMergeKey=port
        +patchStrategy=merge
        +listType=map
        +listMapKey=port
        +listMapKey=protocol
        """

    @property
    def selector(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """Route service traffic to pods with label keys and values matching this
        selector. If empty or not present, the service is assumed to have an
        external process managing its endpoints, which Kubernetes will not
        modify. Only applies to types ClusterIP, NodePort, and LoadBalancer.
        Ignored if type is ExternalName.
        More info: https://kubernetes.io/docs/concepts/services-networking/service/
        +optional
        +mapType=atomic
        """

    @property
    def clusterIPs(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """ClusterIPs is a list of IP addresses assigned to this service, and are
        usually assigned randomly.  If an address is specified manually, is
        in-range (as per system configuration), and is not in use, it will be
        allocated to the service; otherwise creation of the service will fail.
        This field may not be changed through updates unless the type field is
        also being changed to ExternalName (which requires this field to be
        empty) or the type field is being changed from ExternalName (in which
        case this field may optionally be specified, as describe above).  Valid
        values are "None", empty string (""), or a valid IP address.  Setting
        this to "None" makes a "headless service" (no virtual IP), which is
        useful when direct endpoint connections are preferred and proxying is
        not required.  Only applies to types ClusterIP, NodePort, and
        LoadBalancer. If this field is specified when creating a Service of type
        ExternalName, creation will fail. This field will be wiped when updating
        a Service to type ExternalName.  If this field is not specified, it will
        be initialized from the clusterIP field.  If this field is specified,
        clients must ensure that clusterIPs[0] and clusterIP have the same
        value.

        Unless the "IPv6DualStack" feature gate is enabled, this field is
        limited to one value, which must be the same as the clusterIP field.  If
        the feature gate is enabled, this field may hold a maximum of two
        entries (dual-stack IPs, in either order).  These IPs must correspond to
        the values of the ipFamilies field. Both clusterIPs and ipFamilies are
        governed by the ipFamilyPolicy field.
        More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies
        +listType=atomic
        +optional
        """

    @property
    def externalIPs(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """externalIPs is a list of IP addresses for which nodes in the cluster
        will also accept traffic for this service.  These IPs are not managed by
        Kubernetes.  The user is responsible for ensuring that traffic arrives
        at a node with this IP.  A common example is external load-balancers
        that are not part of the Kubernetes system.
        +optional
        """

    @property
    def loadBalancerSourceRanges(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """If specified and supported by the platform, this will restrict traffic through the cloud-provider
        load-balancer will be restricted to the specified client IPs. This field will be ignored if the
        cloud-provider does not support the feature."
        More info: https://kubernetes.io/docs/tasks/access-application-cluster/create-external-load-balancer/
        +optional
        """

    @property
    def sessionAffinityConfig(self) -> global___SessionAffinityConfig:
        """sessionAffinityConfig contains the configurations of session affinity.
        +optional
        """

    @property
    def ipFamilies(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """IPFamilies is a list of IP families (e.g. IPv4, IPv6) assigned to this
        service, and is gated by the "IPv6DualStack" feature gate.  This field
        is usually assigned automatically based on cluster configuration and the
        ipFamilyPolicy field. If this field is specified manually, the requested
        family is available in the cluster, and ipFamilyPolicy allows it, it
        will be used; otherwise creation of the service will fail.  This field
        is conditionally mutable: it allows for adding or removing a secondary
        IP family, but it does not allow changing the primary IP family of the
        Service.  Valid values are "IPv4" and "IPv6".  This field only applies
        to Services of types ClusterIP, NodePort, and LoadBalancer, and does
        apply to "headless" services.  This field will be wiped when updating a
        Service to type ExternalName.

        This field may hold a maximum of two entries (dual-stack families, in
        either order).  These families must correspond to the values of the
        clusterIPs field, if specified. Both clusterIPs and ipFamilies are
        governed by the ipFamilyPolicy field.
        +listType=atomic
        +optional
        """

    def __init__(
        self,
        *,
        ports: collections.abc.Iterable[global___ServicePort] | None = ...,
        selector: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        clusterIP: builtins.str | None = ...,
        clusterIPs: collections.abc.Iterable[builtins.str] | None = ...,
        type: builtins.str | None = ...,
        externalIPs: collections.abc.Iterable[builtins.str] | None = ...,
        sessionAffinity: builtins.str | None = ...,
        loadBalancerIP: builtins.str | None = ...,
        loadBalancerSourceRanges: collections.abc.Iterable[builtins.str] | None = ...,
        externalName: builtins.str | None = ...,
        externalTrafficPolicy: builtins.str | None = ...,
        healthCheckNodePort: builtins.int | None = ...,
        publishNotReadyAddresses: builtins.bool | None = ...,
        sessionAffinityConfig: global___SessionAffinityConfig | None = ...,
        ipFamilies: collections.abc.Iterable[builtins.str] | None = ...,
        ipFamilyPolicy: builtins.str | None = ...,
        allocateLoadBalancerNodePorts: builtins.bool | None = ...,
        loadBalancerClass: builtins.str | None = ...,
        internalTrafficPolicy: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["allocateLoadBalancerNodePorts", b"allocateLoadBalancerNodePorts", "clusterIP", b"clusterIP", "externalName", b"externalName", "externalTrafficPolicy", b"externalTrafficPolicy", "healthCheckNodePort", b"healthCheckNodePort", "internalTrafficPolicy", b"internalTrafficPolicy", "ipFamilyPolicy", b"ipFamilyPolicy", "loadBalancerClass", b"loadBalancerClass", "loadBalancerIP", b"loadBalancerIP", "publishNotReadyAddresses", b"publishNotReadyAddresses", "sessionAffinity", b"sessionAffinity", "sessionAffinityConfig", b"sessionAffinityConfig", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["allocateLoadBalancerNodePorts", b"allocateLoadBalancerNodePorts", "clusterIP", b"clusterIP", "clusterIPs", b"clusterIPs", "externalIPs", b"externalIPs", "externalName", b"externalName", "externalTrafficPolicy", b"externalTrafficPolicy", "healthCheckNodePort", b"healthCheckNodePort", "internalTrafficPolicy", b"internalTrafficPolicy", "ipFamilies", b"ipFamilies", "ipFamilyPolicy", b"ipFamilyPolicy", "loadBalancerClass", b"loadBalancerClass", "loadBalancerIP", b"loadBalancerIP", "loadBalancerSourceRanges", b"loadBalancerSourceRanges", "ports", b"ports", "publishNotReadyAddresses", b"publishNotReadyAddresses", "selector", b"selector", "sessionAffinity", b"sessionAffinity", "sessionAffinityConfig", b"sessionAffinityConfig", "type", b"type"]) -> None: ...

global___ServiceSpec = ServiceSpec

@typing.final
class ServiceStatus(google.protobuf.message.Message):
    """ServiceStatus represents the current status of a service."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LOADBALANCER_FIELD_NUMBER: builtins.int
    CONDITIONS_FIELD_NUMBER: builtins.int
    @property
    def loadBalancer(self) -> global___LoadBalancerStatus:
        """LoadBalancer contains the current status of the load-balancer,
        if one is present.
        +optional
        """

    @property
    def conditions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Condition]:
        """Current service state
        +optional
        +patchMergeKey=type
        +patchStrategy=merge
        +listType=map
        +listMapKey=type
        """

    def __init__(
        self,
        *,
        loadBalancer: global___LoadBalancerStatus | None = ...,
        conditions: collections.abc.Iterable[armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Condition] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["loadBalancer", b"loadBalancer"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["conditions", b"conditions", "loadBalancer", b"loadBalancer"]) -> None: ...

global___ServiceStatus = ServiceStatus

@typing.final
class SessionAffinityConfig(google.protobuf.message.Message):
    """SessionAffinityConfig represents the configurations of session affinity."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CLIENTIP_FIELD_NUMBER: builtins.int
    @property
    def clientIP(self) -> global___ClientIPConfig:
        """clientIP contains the configurations of Client IP based session affinity.
        +optional
        """

    def __init__(
        self,
        *,
        clientIP: global___ClientIPConfig | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["clientIP", b"clientIP"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["clientIP", b"clientIP"]) -> None: ...

global___SessionAffinityConfig = SessionAffinityConfig

@typing.final
class StorageOSPersistentVolumeSource(google.protobuf.message.Message):
    """Represents a StorageOS persistent volume resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VOLUMENAME_FIELD_NUMBER: builtins.int
    VOLUMENAMESPACE_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    volumeName: builtins.str
    """VolumeName is the human-readable name of the StorageOS volume.  Volume
    names are only unique within a namespace.
    """
    volumeNamespace: builtins.str
    """VolumeNamespace specifies the scope of the volume within StorageOS.  If no
    namespace is specified then the Pod's namespace will be used.  This allows the
    Kubernetes name scoping to be mirrored within StorageOS for tighter integration.
    Set VolumeName to any name to override the default behaviour.
    Set to "default" if you are not using namespaces within StorageOS.
    Namespaces that do not pre-exist within StorageOS will be created.
    +optional
    """
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    +optional
    """
    readOnly: builtins.bool
    """Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    +optional
    """
    @property
    def secretRef(self) -> global___ObjectReference:
        """SecretRef specifies the secret to use for obtaining the StorageOS API
        credentials.  If not specified, default values will be attempted.
        +optional
        """

    def __init__(
        self,
        *,
        volumeName: builtins.str | None = ...,
        volumeNamespace: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        secretRef: global___ObjectReference | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "readOnly", b"readOnly", "secretRef", b"secretRef", "volumeName", b"volumeName", "volumeNamespace", b"volumeNamespace"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "readOnly", b"readOnly", "secretRef", b"secretRef", "volumeName", b"volumeName", "volumeNamespace", b"volumeNamespace"]) -> None: ...

global___StorageOSPersistentVolumeSource = StorageOSPersistentVolumeSource

@typing.final
class StorageOSVolumeSource(google.protobuf.message.Message):
    """Represents a StorageOS persistent volume resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VOLUMENAME_FIELD_NUMBER: builtins.int
    VOLUMENAMESPACE_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    SECRETREF_FIELD_NUMBER: builtins.int
    volumeName: builtins.str
    """VolumeName is the human-readable name of the StorageOS volume.  Volume
    names are only unique within a namespace.
    """
    volumeNamespace: builtins.str
    """VolumeNamespace specifies the scope of the volume within StorageOS.  If no
    namespace is specified then the Pod's namespace will be used.  This allows the
    Kubernetes name scoping to be mirrored within StorageOS for tighter integration.
    Set VolumeName to any name to override the default behaviour.
    Set to "default" if you are not using namespaces within StorageOS.
    Namespaces that do not pre-exist within StorageOS will be created.
    +optional
    """
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    +optional
    """
    readOnly: builtins.bool
    """Defaults to false (read/write). ReadOnly here will force
    the ReadOnly setting in VolumeMounts.
    +optional
    """
    @property
    def secretRef(self) -> global___LocalObjectReference:
        """SecretRef specifies the secret to use for obtaining the StorageOS API
        credentials.  If not specified, default values will be attempted.
        +optional
        """

    def __init__(
        self,
        *,
        volumeName: builtins.str | None = ...,
        volumeNamespace: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        secretRef: global___LocalObjectReference | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "readOnly", b"readOnly", "secretRef", b"secretRef", "volumeName", b"volumeName", "volumeNamespace", b"volumeNamespace"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "readOnly", b"readOnly", "secretRef", b"secretRef", "volumeName", b"volumeName", "volumeNamespace", b"volumeNamespace"]) -> None: ...

global___StorageOSVolumeSource = StorageOSVolumeSource

@typing.final
class Sysctl(google.protobuf.message.Message):
    """Sysctl defines a kernel parameter to be set"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    VALUE_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Name of a property to set"""
    value: builtins.str
    """Value of a property to set"""
    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        value: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["name", b"name", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "value", b"value"]) -> None: ...

global___Sysctl = Sysctl

@typing.final
class TCPSocketAction(google.protobuf.message.Message):
    """TCPSocketAction describes an action based on opening a socket"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PORT_FIELD_NUMBER: builtins.int
    HOST_FIELD_NUMBER: builtins.int
    host: builtins.str
    """Optional: Host name to connect to, defaults to the pod IP.
    +optional
    """
    @property
    def port(self) -> armada_client.k8s.io.apimachinery.pkg.util.intstr.generated_pb2.IntOrString:
        """Number or name of the port to access on the container.
        Number must be in the range 1 to 65535.
        Name must be an IANA_SVC_NAME.
        """

    def __init__(
        self,
        *,
        port: armada_client.k8s.io.apimachinery.pkg.util.intstr.generated_pb2.IntOrString | None = ...,
        host: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["host", b"host", "port", b"port"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["host", b"host", "port", b"port"]) -> None: ...

global___TCPSocketAction = TCPSocketAction

@typing.final
class Taint(google.protobuf.message.Message):
    """The node this Taint is attached to has the "effect" on
    any pod that does not tolerate the Taint.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    VALUE_FIELD_NUMBER: builtins.int
    EFFECT_FIELD_NUMBER: builtins.int
    TIMEADDED_FIELD_NUMBER: builtins.int
    key: builtins.str
    """Required. The taint key to be applied to a node."""
    value: builtins.str
    """The taint value corresponding to the taint key.
    +optional
    """
    effect: builtins.str
    """Required. The effect of the taint on pods
    that do not tolerate the taint.
    Valid effects are NoSchedule, PreferNoSchedule and NoExecute.
    """
    @property
    def timeAdded(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time:
        """TimeAdded represents the time at which the taint was added.
        It is only written for NoExecute taints.
        +optional
        """

    def __init__(
        self,
        *,
        key: builtins.str | None = ...,
        value: builtins.str | None = ...,
        effect: builtins.str | None = ...,
        timeAdded: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.Time | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["effect", b"effect", "key", b"key", "timeAdded", b"timeAdded", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["effect", b"effect", "key", b"key", "timeAdded", b"timeAdded", "value", b"value"]) -> None: ...

global___Taint = Taint

@typing.final
class Toleration(google.protobuf.message.Message):
    """The pod this Toleration is attached to tolerates any taint that matches
    the triple <key,value,effect> using the matching operator <operator>.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    OPERATOR_FIELD_NUMBER: builtins.int
    VALUE_FIELD_NUMBER: builtins.int
    EFFECT_FIELD_NUMBER: builtins.int
    TOLERATIONSECONDS_FIELD_NUMBER: builtins.int
    key: builtins.str
    """Key is the taint key that the toleration applies to. Empty means match all taint keys.
    If the key is empty, operator must be Exists; this combination means to match all values and all keys.
    +optional
    """
    operator: builtins.str
    """Operator represents a key's relationship to the value.
    Valid operators are Exists and Equal. Defaults to Equal.
    Exists is equivalent to wildcard for value, so that a pod can
    tolerate all taints of a particular category.
    +optional
    """
    value: builtins.str
    """Value is the taint value the toleration matches to.
    If the operator is Exists, the value should be empty, otherwise just a regular string.
    +optional
    """
    effect: builtins.str
    """Effect indicates the taint effect to match. Empty means match all taint effects.
    When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute.
    +optional
    """
    tolerationSeconds: builtins.int
    """TolerationSeconds represents the period of time the toleration (which must be
    of effect NoExecute, otherwise this field is ignored) tolerates the taint. By default,
    it is not set, which means tolerate the taint forever (do not evict). Zero and
    negative values will be treated as 0 (evict immediately) by the system.
    +optional
    """
    def __init__(
        self,
        *,
        key: builtins.str | None = ...,
        operator: builtins.str | None = ...,
        value: builtins.str | None = ...,
        effect: builtins.str | None = ...,
        tolerationSeconds: builtins.int | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["effect", b"effect", "key", b"key", "operator", b"operator", "tolerationSeconds", b"tolerationSeconds", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["effect", b"effect", "key", b"key", "operator", b"operator", "tolerationSeconds", b"tolerationSeconds", "value", b"value"]) -> None: ...

global___Toleration = Toleration

@typing.final
class TopologySelectorLabelRequirement(google.protobuf.message.Message):
    """A topology selector requirement is a selector that matches given label.
    This is an alpha feature and may change in the future.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    VALUES_FIELD_NUMBER: builtins.int
    key: builtins.str
    """The label key that the selector applies to."""
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """An array of string values. One value must match the label to be selected.
        Each entry in Values is ORed.
        """

    def __init__(
        self,
        *,
        key: builtins.str | None = ...,
        values: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "values", b"values"]) -> None: ...

global___TopologySelectorLabelRequirement = TopologySelectorLabelRequirement

@typing.final
class TopologySelectorTerm(google.protobuf.message.Message):
    """A topology selector term represents the result of label queries.
    A null or empty topology selector term matches no objects.
    The requirements of them are ANDed.
    It provides a subset of functionality as NodeSelectorTerm.
    This is an alpha feature and may change in the future.
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MATCHLABELEXPRESSIONS_FIELD_NUMBER: builtins.int
    @property
    def matchLabelExpressions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___TopologySelectorLabelRequirement]:
        """A list of topology selector requirements by labels.
        +optional
        """

    def __init__(
        self,
        *,
        matchLabelExpressions: collections.abc.Iterable[global___TopologySelectorLabelRequirement] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["matchLabelExpressions", b"matchLabelExpressions"]) -> None: ...

global___TopologySelectorTerm = TopologySelectorTerm

@typing.final
class TopologySpreadConstraint(google.protobuf.message.Message):
    """TopologySpreadConstraint specifies how to spread matching pods among the given topology."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MAXSKEW_FIELD_NUMBER: builtins.int
    TOPOLOGYKEY_FIELD_NUMBER: builtins.int
    WHENUNSATISFIABLE_FIELD_NUMBER: builtins.int
    LABELSELECTOR_FIELD_NUMBER: builtins.int
    maxSkew: builtins.int
    """MaxSkew describes the degree to which pods may be unevenly distributed.
    When `whenUnsatisfiable=DoNotSchedule`, it is the maximum permitted difference
    between the number of matching pods in the target topology and the global minimum.
    For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same
    labelSelector spread as 1/1/0:
    +-------+-------+-------+
    | zone1 | zone2 | zone3 |
    +-------+-------+-------+
    |   P   |   P   |       |
    +-------+-------+-------+
    - if MaxSkew is 1, incoming pod can only be scheduled to zone3 to become 1/1/1;
    scheduling it onto zone1(zone2) would make the ActualSkew(2-0) on zone1(zone2)
    violate MaxSkew(1).
    - if MaxSkew is 2, incoming pod can be scheduled onto any zone.
    When `whenUnsatisfiable=ScheduleAnyway`, it is used to give higher precedence
    to topologies that satisfy it.
    It's a required field. Default value is 1 and 0 is not allowed.
    """
    topologyKey: builtins.str
    """TopologyKey is the key of node labels. Nodes that have a label with this key
    and identical values are considered to be in the same topology.
    We consider each <key, value> as a "bucket", and try to put balanced number
    of pods into each bucket.
    It's a required field.
    """
    whenUnsatisfiable: builtins.str
    """WhenUnsatisfiable indicates how to deal with a pod if it doesn't satisfy
    the spread constraint.
    - DoNotSchedule (default) tells the scheduler not to schedule it.
    - ScheduleAnyway tells the scheduler to schedule the pod in any location,
      but giving higher precedence to topologies that would help reduce the
      skew.
    A constraint is considered "Unsatisfiable" for an incoming pod
    if and only if every possible node assigment for that pod would violate
    "MaxSkew" on some topology.
    For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same
    labelSelector spread as 3/1/1:
    +-------+-------+-------+
    | zone1 | zone2 | zone3 |
    +-------+-------+-------+
    | P P P |   P   |   P   |
    +-------+-------+-------+
    If WhenUnsatisfiable is set to DoNotSchedule, incoming pod can only be scheduled
    to zone2(zone3) to become 3/2/1(3/1/2) as ActualSkew(2-1) on zone2(zone3) satisfies
    MaxSkew(1). In other words, the cluster can still be imbalanced, but scheduler
    won't make it *more* imbalanced.
    It's a required field.
    """
    @property
    def labelSelector(self) -> armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.LabelSelector:
        """LabelSelector is used to find matching pods.
        Pods that match this label selector are counted to determine the number of pods
        in their corresponding topology domain.
        +optional
        """

    def __init__(
        self,
        *,
        maxSkew: builtins.int | None = ...,
        topologyKey: builtins.str | None = ...,
        whenUnsatisfiable: builtins.str | None = ...,
        labelSelector: armada_client.k8s.io.apimachinery.pkg.apis.meta.v1.generated_pb2.LabelSelector | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["labelSelector", b"labelSelector", "maxSkew", b"maxSkew", "topologyKey", b"topologyKey", "whenUnsatisfiable", b"whenUnsatisfiable"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["labelSelector", b"labelSelector", "maxSkew", b"maxSkew", "topologyKey", b"topologyKey", "whenUnsatisfiable", b"whenUnsatisfiable"]) -> None: ...

global___TopologySpreadConstraint = TopologySpreadConstraint

@typing.final
class TypedLocalObjectReference(google.protobuf.message.Message):
    """TypedLocalObjectReference contains enough information to let you locate the
    typed referenced object inside the same namespace.
    +structType=atomic
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    APIGROUP_FIELD_NUMBER: builtins.int
    KIND_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    apiGroup: builtins.str
    """APIGroup is the group for the resource being referenced.
    If APIGroup is not specified, the specified Kind must be in the core API group.
    For any other third-party types, APIGroup is required.
    +optional
    """
    kind: builtins.str
    """Kind is the type of resource being referenced"""
    name: builtins.str
    """Name is the name of resource being referenced"""
    def __init__(
        self,
        *,
        apiGroup: builtins.str | None = ...,
        kind: builtins.str | None = ...,
        name: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["apiGroup", b"apiGroup", "kind", b"kind", "name", b"name"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["apiGroup", b"apiGroup", "kind", b"kind", "name", b"name"]) -> None: ...

global___TypedLocalObjectReference = TypedLocalObjectReference

@typing.final
class Volume(google.protobuf.message.Message):
    """Volume represents a named volume in a pod that may be accessed by any container in the pod."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    VOLUMESOURCE_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Volume's name.
    Must be a DNS_LABEL and unique within the pod.
    More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names
    """
    @property
    def volumeSource(self) -> global___VolumeSource:
        """VolumeSource represents the location and type of the mounted volume.
        If not specified, the Volume is implied to be an EmptyDir.
        This implied behavior is deprecated and will be removed in a future version.
        """

    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        volumeSource: global___VolumeSource | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["name", b"name", "volumeSource", b"volumeSource"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "volumeSource", b"volumeSource"]) -> None: ...

global___Volume = Volume

@typing.final
class VolumeDevice(google.protobuf.message.Message):
    """volumeDevice describes a mapping of a raw block device within a container."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    DEVICEPATH_FIELD_NUMBER: builtins.int
    name: builtins.str
    """name must match the name of a persistentVolumeClaim in the pod"""
    devicePath: builtins.str
    """devicePath is the path inside of the container that the device will be mapped to."""
    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        devicePath: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["devicePath", b"devicePath", "name", b"name"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["devicePath", b"devicePath", "name", b"name"]) -> None: ...

global___VolumeDevice = VolumeDevice

@typing.final
class VolumeMount(google.protobuf.message.Message):
    """VolumeMount describes a mounting of a Volume within a container."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    READONLY_FIELD_NUMBER: builtins.int
    MOUNTPATH_FIELD_NUMBER: builtins.int
    SUBPATH_FIELD_NUMBER: builtins.int
    MOUNTPROPAGATION_FIELD_NUMBER: builtins.int
    SUBPATHEXPR_FIELD_NUMBER: builtins.int
    name: builtins.str
    """This must match the Name of a Volume."""
    readOnly: builtins.bool
    """Mounted read-only if true, read-write otherwise (false or unspecified).
    Defaults to false.
    +optional
    """
    mountPath: builtins.str
    """Path within the container at which the volume should be mounted.  Must
    not contain ':'.
    """
    subPath: builtins.str
    """Path within the volume from which the container's volume should be mounted.
    Defaults to "" (volume's root).
    +optional
    """
    mountPropagation: builtins.str
    """mountPropagation determines how mounts are propagated from the host
    to container and the other way around.
    When not set, MountPropagationNone is used.
    This field is beta in 1.10.
    +optional
    """
    subPathExpr: builtins.str
    """Expanded path within the volume from which the container's volume should be mounted.
    Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment.
    Defaults to "" (volume's root).
    SubPathExpr and SubPath are mutually exclusive.
    +optional
    """
    def __init__(
        self,
        *,
        name: builtins.str | None = ...,
        readOnly: builtins.bool | None = ...,
        mountPath: builtins.str | None = ...,
        subPath: builtins.str | None = ...,
        mountPropagation: builtins.str | None = ...,
        subPathExpr: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["mountPath", b"mountPath", "mountPropagation", b"mountPropagation", "name", b"name", "readOnly", b"readOnly", "subPath", b"subPath", "subPathExpr", b"subPathExpr"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["mountPath", b"mountPath", "mountPropagation", b"mountPropagation", "name", b"name", "readOnly", b"readOnly", "subPath", b"subPath", "subPathExpr", b"subPathExpr"]) -> None: ...

global___VolumeMount = VolumeMount

@typing.final
class VolumeNodeAffinity(google.protobuf.message.Message):
    """VolumeNodeAffinity defines constraints that limit what nodes this volume can be accessed from."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REQUIRED_FIELD_NUMBER: builtins.int
    @property
    def required(self) -> global___NodeSelector:
        """Required specifies hard node constraints that must be met."""

    def __init__(
        self,
        *,
        required: global___NodeSelector | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["required", b"required"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["required", b"required"]) -> None: ...

global___VolumeNodeAffinity = VolumeNodeAffinity

@typing.final
class VolumeProjection(google.protobuf.message.Message):
    """Projection that may be projected along with other supported volume types"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SECRET_FIELD_NUMBER: builtins.int
    DOWNWARDAPI_FIELD_NUMBER: builtins.int
    CONFIGMAP_FIELD_NUMBER: builtins.int
    SERVICEACCOUNTTOKEN_FIELD_NUMBER: builtins.int
    @property
    def secret(self) -> global___SecretProjection:
        """information about the secret data to project
        +optional
        """

    @property
    def downwardAPI(self) -> global___DownwardAPIProjection:
        """information about the downwardAPI data to project
        +optional
        """

    @property
    def configMap(self) -> global___ConfigMapProjection:
        """information about the configMap data to project
        +optional
        """

    @property
    def serviceAccountToken(self) -> global___ServiceAccountTokenProjection:
        """information about the serviceAccountToken data to project
        +optional
        """

    def __init__(
        self,
        *,
        secret: global___SecretProjection | None = ...,
        downwardAPI: global___DownwardAPIProjection | None = ...,
        configMap: global___ConfigMapProjection | None = ...,
        serviceAccountToken: global___ServiceAccountTokenProjection | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["configMap", b"configMap", "downwardAPI", b"downwardAPI", "secret", b"secret", "serviceAccountToken", b"serviceAccountToken"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["configMap", b"configMap", "downwardAPI", b"downwardAPI", "secret", b"secret", "serviceAccountToken", b"serviceAccountToken"]) -> None: ...

global___VolumeProjection = VolumeProjection

@typing.final
class VolumeSource(google.protobuf.message.Message):
    """Represents the source of a volume to mount.
    Only one of its members may be specified.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    HOSTPATH_FIELD_NUMBER: builtins.int
    EMPTYDIR_FIELD_NUMBER: builtins.int
    GCEPERSISTENTDISK_FIELD_NUMBER: builtins.int
    AWSELASTICBLOCKSTORE_FIELD_NUMBER: builtins.int
    GITREPO_FIELD_NUMBER: builtins.int
    SECRET_FIELD_NUMBER: builtins.int
    NFS_FIELD_NUMBER: builtins.int
    ISCSI_FIELD_NUMBER: builtins.int
    GLUSTERFS_FIELD_NUMBER: builtins.int
    PERSISTENTVOLUMECLAIM_FIELD_NUMBER: builtins.int
    RBD_FIELD_NUMBER: builtins.int
    FLEXVOLUME_FIELD_NUMBER: builtins.int
    CINDER_FIELD_NUMBER: builtins.int
    CEPHFS_FIELD_NUMBER: builtins.int
    FLOCKER_FIELD_NUMBER: builtins.int
    DOWNWARDAPI_FIELD_NUMBER: builtins.int
    FC_FIELD_NUMBER: builtins.int
    AZUREFILE_FIELD_NUMBER: builtins.int
    CONFIGMAP_FIELD_NUMBER: builtins.int
    VSPHEREVOLUME_FIELD_NUMBER: builtins.int
    QUOBYTE_FIELD_NUMBER: builtins.int
    AZUREDISK_FIELD_NUMBER: builtins.int
    PHOTONPERSISTENTDISK_FIELD_NUMBER: builtins.int
    PROJECTED_FIELD_NUMBER: builtins.int
    PORTWORXVOLUME_FIELD_NUMBER: builtins.int
    SCALEIO_FIELD_NUMBER: builtins.int
    STORAGEOS_FIELD_NUMBER: builtins.int
    CSI_FIELD_NUMBER: builtins.int
    EPHEMERAL_FIELD_NUMBER: builtins.int
    @property
    def hostPath(self) -> global___HostPathVolumeSource:
        """HostPath represents a pre-existing file or directory on the host
        machine that is directly exposed to the container. This is generally
        used for system agents or other privileged things that are allowed
        to see the host machine. Most containers will NOT need this.
        More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath
        ---
        TODO(jonesdl) We need to restrict who can use host directory mounts and who can/can not
        mount host directories as read/write.
        +optional
        """

    @property
    def emptyDir(self) -> global___EmptyDirVolumeSource:
        """EmptyDir represents a temporary directory that shares a pod's lifetime.
        More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir
        +optional
        """

    @property
    def gcePersistentDisk(self) -> global___GCEPersistentDiskVolumeSource:
        """GCEPersistentDisk represents a GCE Disk resource that is attached to a
        kubelet's host machine and then exposed to the pod.
        More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk
        +optional
        """

    @property
    def awsElasticBlockStore(self) -> global___AWSElasticBlockStoreVolumeSource:
        """AWSElasticBlockStore represents an AWS Disk resource that is attached to a
        kubelet's host machine and then exposed to the pod.
        More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore
        +optional
        """

    @property
    def gitRepo(self) -> global___GitRepoVolumeSource:
        """GitRepo represents a git repository at a particular revision.
        DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an
        EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir
        into the Pod's container.
        +optional
        """

    @property
    def secret(self) -> global___SecretVolumeSource:
        """Secret represents a secret that should populate this volume.
        More info: https://kubernetes.io/docs/concepts/storage/volumes#secret
        +optional
        """

    @property
    def nfs(self) -> global___NFSVolumeSource:
        """NFS represents an NFS mount on the host that shares a pod's lifetime
        More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs
        +optional
        """

    @property
    def iscsi(self) -> global___ISCSIVolumeSource:
        """ISCSI represents an ISCSI Disk resource that is attached to a
        kubelet's host machine and then exposed to the pod.
        More info: https://examples.k8s.io/volumes/iscsi/README.md
        +optional
        """

    @property
    def glusterfs(self) -> global___GlusterfsVolumeSource:
        """Glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime.
        More info: https://examples.k8s.io/volumes/glusterfs/README.md
        +optional
        """

    @property
    def persistentVolumeClaim(self) -> global___PersistentVolumeClaimVolumeSource:
        """PersistentVolumeClaimVolumeSource represents a reference to a
        PersistentVolumeClaim in the same namespace.
        More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims
        +optional
        """

    @property
    def rbd(self) -> global___RBDVolumeSource:
        """RBD represents a Rados Block Device mount on the host that shares a pod's lifetime.
        More info: https://examples.k8s.io/volumes/rbd/README.md
        +optional
        """

    @property
    def flexVolume(self) -> global___FlexVolumeSource:
        """FlexVolume represents a generic volume resource that is
        provisioned/attached using an exec based plugin.
        +optional
        """

    @property
    def cinder(self) -> global___CinderVolumeSource:
        """Cinder represents a cinder volume attached and mounted on kubelets host machine.
        More info: https://examples.k8s.io/mysql-cinder-pd/README.md
        +optional
        """

    @property
    def cephfs(self) -> global___CephFSVolumeSource:
        """CephFS represents a Ceph FS mount on the host that shares a pod's lifetime
        +optional
        """

    @property
    def flocker(self) -> global___FlockerVolumeSource:
        """Flocker represents a Flocker volume attached to a kubelet's host machine. This depends on the Flocker control service being running
        +optional
        """

    @property
    def downwardAPI(self) -> global___DownwardAPIVolumeSource:
        """DownwardAPI represents downward API about the pod that should populate this volume
        +optional
        """

    @property
    def fc(self) -> global___FCVolumeSource:
        """FC represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.
        +optional
        """

    @property
    def azureFile(self) -> global___AzureFileVolumeSource:
        """AzureFile represents an Azure File Service mount on the host and bind mount to the pod.
        +optional
        """

    @property
    def configMap(self) -> global___ConfigMapVolumeSource:
        """ConfigMap represents a configMap that should populate this volume
        +optional
        """

    @property
    def vsphereVolume(self) -> global___VsphereVirtualDiskVolumeSource:
        """VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine
        +optional
        """

    @property
    def quobyte(self) -> global___QuobyteVolumeSource:
        """Quobyte represents a Quobyte mount on the host that shares a pod's lifetime
        +optional
        """

    @property
    def azureDisk(self) -> global___AzureDiskVolumeSource:
        """AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.
        +optional
        """

    @property
    def photonPersistentDisk(self) -> global___PhotonPersistentDiskVolumeSource:
        """PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine"""

    @property
    def projected(self) -> global___ProjectedVolumeSource:
        """Items for all in one resources secrets, configmaps, and downward API"""

    @property
    def portworxVolume(self) -> global___PortworxVolumeSource:
        """PortworxVolume represents a portworx volume attached and mounted on kubelets host machine
        +optional
        """

    @property
    def scaleIO(self) -> global___ScaleIOVolumeSource:
        """ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.
        +optional
        """

    @property
    def storageos(self) -> global___StorageOSVolumeSource:
        """StorageOS represents a StorageOS volume attached and mounted on Kubernetes nodes.
        +optional
        """

    @property
    def csi(self) -> global___CSIVolumeSource:
        """CSI (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature).
        +optional
        """

    @property
    def ephemeral(self) -> global___EphemeralVolumeSource:
        """Ephemeral represents a volume that is handled by a cluster storage driver.
        The volume's lifecycle is tied to the pod that defines it - it will be created before the pod starts,
        and deleted when the pod is removed.

        Use this if:
        a) the volume is only needed while the pod runs,
        b) features of normal volumes like restoring from snapshot or capacity
           tracking are needed,
        c) the storage driver is specified through a storage class, and
        d) the storage driver supports dynamic volume provisioning through
           a PersistentVolumeClaim (see EphemeralVolumeSource for more
           information on the connection between this volume type
           and PersistentVolumeClaim).

        Use PersistentVolumeClaim or one of the vendor-specific
        APIs for volumes that persist for longer than the lifecycle
        of an individual pod.

        Use CSI for light-weight local ephemeral volumes if the CSI driver is meant to
        be used that way - see the documentation of the driver for
        more information.

        A pod can use both types of ephemeral volumes and
        persistent volumes at the same time.

        This is a beta feature and only available when the GenericEphemeralVolume
        feature gate is enabled.

        +optional
        """

    def __init__(
        self,
        *,
        hostPath: global___HostPathVolumeSource | None = ...,
        emptyDir: global___EmptyDirVolumeSource | None = ...,
        gcePersistentDisk: global___GCEPersistentDiskVolumeSource | None = ...,
        awsElasticBlockStore: global___AWSElasticBlockStoreVolumeSource | None = ...,
        gitRepo: global___GitRepoVolumeSource | None = ...,
        secret: global___SecretVolumeSource | None = ...,
        nfs: global___NFSVolumeSource | None = ...,
        iscsi: global___ISCSIVolumeSource | None = ...,
        glusterfs: global___GlusterfsVolumeSource | None = ...,
        persistentVolumeClaim: global___PersistentVolumeClaimVolumeSource | None = ...,
        rbd: global___RBDVolumeSource | None = ...,
        flexVolume: global___FlexVolumeSource | None = ...,
        cinder: global___CinderVolumeSource | None = ...,
        cephfs: global___CephFSVolumeSource | None = ...,
        flocker: global___FlockerVolumeSource | None = ...,
        downwardAPI: global___DownwardAPIVolumeSource | None = ...,
        fc: global___FCVolumeSource | None = ...,
        azureFile: global___AzureFileVolumeSource | None = ...,
        configMap: global___ConfigMapVolumeSource | None = ...,
        vsphereVolume: global___VsphereVirtualDiskVolumeSource | None = ...,
        quobyte: global___QuobyteVolumeSource | None = ...,
        azureDisk: global___AzureDiskVolumeSource | None = ...,
        photonPersistentDisk: global___PhotonPersistentDiskVolumeSource | None = ...,
        projected: global___ProjectedVolumeSource | None = ...,
        portworxVolume: global___PortworxVolumeSource | None = ...,
        scaleIO: global___ScaleIOVolumeSource | None = ...,
        storageos: global___StorageOSVolumeSource | None = ...,
        csi: global___CSIVolumeSource | None = ...,
        ephemeral: global___EphemeralVolumeSource | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["awsElasticBlockStore", b"awsElasticBlockStore", "azureDisk", b"azureDisk", "azureFile", b"azureFile", "cephfs", b"cephfs", "cinder", b"cinder", "configMap", b"configMap", "csi", b"csi", "downwardAPI", b"downwardAPI", "emptyDir", b"emptyDir", "ephemeral", b"ephemeral", "fc", b"fc", "flexVolume", b"flexVolume", "flocker", b"flocker", "gcePersistentDisk", b"gcePersistentDisk", "gitRepo", b"gitRepo", "glusterfs", b"glusterfs", "hostPath", b"hostPath", "iscsi", b"iscsi", "nfs", b"nfs", "persistentVolumeClaim", b"persistentVolumeClaim", "photonPersistentDisk", b"photonPersistentDisk", "portworxVolume", b"portworxVolume", "projected", b"projected", "quobyte", b"quobyte", "rbd", b"rbd", "scaleIO", b"scaleIO", "secret", b"secret", "storageos", b"storageos", "vsphereVolume", b"vsphereVolume"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["awsElasticBlockStore", b"awsElasticBlockStore", "azureDisk", b"azureDisk", "azureFile", b"azureFile", "cephfs", b"cephfs", "cinder", b"cinder", "configMap", b"configMap", "csi", b"csi", "downwardAPI", b"downwardAPI", "emptyDir", b"emptyDir", "ephemeral", b"ephemeral", "fc", b"fc", "flexVolume", b"flexVolume", "flocker", b"flocker", "gcePersistentDisk", b"gcePersistentDisk", "gitRepo", b"gitRepo", "glusterfs", b"glusterfs", "hostPath", b"hostPath", "iscsi", b"iscsi", "nfs", b"nfs", "persistentVolumeClaim", b"persistentVolumeClaim", "photonPersistentDisk", b"photonPersistentDisk", "portworxVolume", b"portworxVolume", "projected", b"projected", "quobyte", b"quobyte", "rbd", b"rbd", "scaleIO", b"scaleIO", "secret", b"secret", "storageos", b"storageos", "vsphereVolume", b"vsphereVolume"]) -> None: ...

global___VolumeSource = VolumeSource

@typing.final
class VsphereVirtualDiskVolumeSource(google.protobuf.message.Message):
    """Represents a vSphere volume resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VOLUMEPATH_FIELD_NUMBER: builtins.int
    FSTYPE_FIELD_NUMBER: builtins.int
    STORAGEPOLICYNAME_FIELD_NUMBER: builtins.int
    STORAGEPOLICYID_FIELD_NUMBER: builtins.int
    volumePath: builtins.str
    """Path that identifies vSphere volume vmdk"""
    fsType: builtins.str
    """Filesystem type to mount.
    Must be a filesystem type supported by the host operating system.
    Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.
    +optional
    """
    storagePolicyName: builtins.str
    """Storage Policy Based Management (SPBM) profile name.
    +optional
    """
    storagePolicyID: builtins.str
    """Storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.
    +optional
    """
    def __init__(
        self,
        *,
        volumePath: builtins.str | None = ...,
        fsType: builtins.str | None = ...,
        storagePolicyName: builtins.str | None = ...,
        storagePolicyID: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["fsType", b"fsType", "storagePolicyID", b"storagePolicyID", "storagePolicyName", b"storagePolicyName", "volumePath", b"volumePath"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["fsType", b"fsType", "storagePolicyID", b"storagePolicyID", "storagePolicyName", b"storagePolicyName", "volumePath", b"volumePath"]) -> None: ...

global___VsphereVirtualDiskVolumeSource = VsphereVirtualDiskVolumeSource

@typing.final
class WeightedPodAffinityTerm(google.protobuf.message.Message):
    """The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WEIGHT_FIELD_NUMBER: builtins.int
    PODAFFINITYTERM_FIELD_NUMBER: builtins.int
    weight: builtins.int
    """weight associated with matching the corresponding podAffinityTerm,
    in the range 1-100.
    """
    @property
    def podAffinityTerm(self) -> global___PodAffinityTerm:
        """Required. A pod affinity term, associated with the corresponding weight."""

    def __init__(
        self,
        *,
        weight: builtins.int | None = ...,
        podAffinityTerm: global___PodAffinityTerm | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["podAffinityTerm", b"podAffinityTerm", "weight", b"weight"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["podAffinityTerm", b"podAffinityTerm", "weight", b"weight"]) -> None: ...

global___WeightedPodAffinityTerm = WeightedPodAffinityTerm

@typing.final
class WindowsSecurityContextOptions(google.protobuf.message.Message):
    """WindowsSecurityContextOptions contain Windows-specific options and credentials."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    GMSACREDENTIALSPECNAME_FIELD_NUMBER: builtins.int
    GMSACREDENTIALSPEC_FIELD_NUMBER: builtins.int
    RUNASUSERNAME_FIELD_NUMBER: builtins.int
    HOSTPROCESS_FIELD_NUMBER: builtins.int
    gmsaCredentialSpecName: builtins.str
    """GMSACredentialSpecName is the name of the GMSA credential spec to use.
    +optional
    """
    gmsaCredentialSpec: builtins.str
    """GMSACredentialSpec is where the GMSA admission webhook
    (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the
    GMSA credential spec named by the GMSACredentialSpecName field.
    +optional
    """
    runAsUserName: builtins.str
    """The UserName in Windows to run the entrypoint of the container process.
    Defaults to the user specified in image metadata if unspecified.
    May also be set in PodSecurityContext. If set in both SecurityContext and
    PodSecurityContext, the value specified in SecurityContext takes precedence.
    +optional
    """
    hostProcess: builtins.bool
    """HostProcess determines if a container should be run as a 'Host Process' container.
    This field is alpha-level and will only be honored by components that enable the
    WindowsHostProcessContainers feature flag. Setting this field without the feature
    flag will result in errors when validating the Pod. All of a Pod's containers must
    have the same effective HostProcess value (it is not allowed to have a mix of HostProcess
    containers and non-HostProcess containers).  In addition, if HostProcess is true
    then HostNetwork must also be set to true.
    +optional
    """
    def __init__(
        self,
        *,
        gmsaCredentialSpecName: builtins.str | None = ...,
        gmsaCredentialSpec: builtins.str | None = ...,
        runAsUserName: builtins.str | None = ...,
        hostProcess: builtins.bool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["gmsaCredentialSpec", b"gmsaCredentialSpec", "gmsaCredentialSpecName", b"gmsaCredentialSpecName", "hostProcess", b"hostProcess", "runAsUserName", b"runAsUserName"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["gmsaCredentialSpec", b"gmsaCredentialSpec", "gmsaCredentialSpecName", b"gmsaCredentialSpecName", "hostProcess", b"hostProcess", "runAsUserName", b"runAsUserName"]) -> None: ...

global___WindowsSecurityContextOptions = WindowsSecurityContextOptions
